// FILE: ./assets/js/utilities/Messages_fiscal.js
var Messages_fiscal = function Messages_fiscal () {

    /* + ----------------------------------- +
     * | Error messages                      |
     * + ----------------------------------- + */
    this.CATCH_EXCEPTION_ERROR = function(error) {
        return 'Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>';
    };

    this.SAVE_ROW_ERROR = 'Erro ao salvar o registro';
    this.REMOVE_ROW_ERROR = 'Erro ao excluir o registro';

    this.IMPORTACAO_ERROR = 'Erro ao realizar importação';
    this.DELETE_IMPORTA_TIPO_ITEM_ERROR = 'Não foi possível realizar a importação. Existem registros relacionados na tela "Livro Magnético -> Gênero/Item por Produto"';

    this.TIMEOUT_ERROR = 'Timeout';

    this.DADOS_NAO_ENCONTRADOS_ERROR = 'Dados não encontrados';

    this.DTINI_POST_DTFIM_ERROR = 'A data final deve ser igual ou posterior à data inicial';
    this.DATA_POST_DTATUAL_ERROR = 'Data deve ser igual ou posterior à data atual';

    this.INTERVALO_INV_PRODUTO_ERROR = 'O produto final deve ser maior ou igual ao produto inicial';

    this.EXCL_LIVRO_PADRAO_ERROR = 'Não é possível excluir o livro padrão';
    this.EXISTE_LIVRO_PADRAO_ERROR = 'Deve existir um livro padrão';
    this.LIVRO_ORIG_SEM_DADOS = 'Não existem dados para replicação no livro de origem';

    this.PARAMETROS_GERAIS_NAO_INFORMADOS_ERROR = 'Parâmetros gerais devem ser informados.';
    this.EMPRESA_NAO_INFORMADA_ERROR = 'Empresa deve ser informada';
    this.INSCRICAO_NAO_INFORMADA_ERROR = 'Inscrição estadual deve ser informada';
    this.FILTRO_INVALIDO_ERROR = 'Existem campos não preenchidos ou inválidos no filtro';

    this.PARAM_IMPOSTO_RELAC_ERROR = 'Os impostos relacionados devem possuir as mesmas parametrizações para Orgão Arrecadador, Imposto Recuperável e Forma de Apuração';
    this.MAPA_REGIME_EMPRESA_ERROR = 'Regime da empresa não permite inserir/alterar as informações para esse tipo de apuração';
    this.PERIODO_APURADCAO = 'Período de apuração deve estar compreendido no mesmo mês.';
    this.MAPA_ANTERIOR_APURADO= 'Mapa anterior deve estar apurado.';
    this.MAPA_POSTERIOR_BLOQUEADO ='Mapa posterior deve estar desbloqueado.';
    this.MAPA_ANTERIOR_BLOQUEADO ='Mapa anterior deve estar bloqueado.';
    this.SEQUENCIAL_JA_CADASTRADO = 'Sequencial já cadastrado.';
    this.AJUSTE_CREDITO_CUMULATIVO_ERROR = 'Tipo de Ajuste de Crédito só pode ser gerado para o Regime não Cumulativo.';
    this.COMPOR_ITENS = 'Para Compor Valor dos Itens, Nota Fiscal deve ser Informada.';
    this.REPLICAR_INFORMACOES_ADICIONAIS = 'Todos os itens serão sobrepostos pelos itens do mês anterior. Confirma importação?';
    /* + ----------------------------------- +
     * | Successful messages                 |
     * + ----------------------------------- + */
    this.CADASTRO_AUTOMATICO_SUCCESS = 'Cadastro automático realizado com sucesso';

    this.SAVE_ROW_SUCCESS = 'Registro salvo com sucesso';
    this.REMOVE_ROW_SUCCESS = 'Registro excluído com sucesso';

    this.IMPORTACAO_SUCCESS = 'Importação realizada com sucesso';
    this.EXPORTACAO_SUCCESS = 'Exportação realizada com sucesso';
    this.REPLICACAO_SUCESS = 'Replicação realizada com sucesso';
    this.APURACAO_SUCCESS =  'Apuração realizada com sucesso';
    this.MAPA_BLOQUEADO_SUCESSO ='Mapa bloqueado com sucesso.';
    this.MAPA_DESBLOQUEADO_SUCESSO ='Mapa desbloqueado com sucesso.';
    /* + ----------------------------------- +
     * | Alert messages                      |
     * + ----------------------------------- + */
    this.DELETE_ROW = 'Deseja realmente excluir o registro?';
    this.CONFIRMA_IMPORTACAO = 'Todos os dados serão sobrescritos. Deseja realmente realizar a importação?';
    this.CONFIRMA_REPLICACAO_LIVRO = 'Todos os dados do livro de destino serão sobrescritos pelo livro de origem. Deseja realmente realizar a replicação?';

    /* + ----------------------------------- +
     * | General messages                    |
     * + ----------------------------------- + */
    this.INFORMAR_DADOS_REGISTRO1400 = 'Devem ser informados os dados para geração do registro 1400 - Informação sobre valores agregados.';
    this.INVENTARIO_SEM_INFORMACOES = 'Bloco H - Inventário Fiscal gerado sem informações.';
    this.EXPORTANDO = 'Exportando...';
    this.EXPORTANDO_GIA = 'Exportando GIA...';
    this.EXPORTANDO_SINTEGRA = 'Exportando SINTEGRA...';
    this.EXPORTANDO_SPED = 'Exportando SPED...';
    this.EXPORTANDO_LIVRO_ELETRONICO = 'Exportando Livro Eletronico...';
    this.EXPORTANDO_DIEF = 'Exportando DIEF...';
    this.EXPORTANDO_DAC_AL = 'Exportando DAC-AL...';
    this.EXPORTANDO_SEF_II = 'Exportando SEF II...';
    
    /**************************************
    *    Mensagens REINF                  * 
    **************************************/  

    this.PARAMETROS_REINF = 'Empresa não possui parâmetros para envio do Reinf cadastrados.';
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Messages_fiscal', Messages_fiscal);
});

// FILE: ./assets/js/utilities/Util.js
var UtilCadFis = function UtilCadFis(restEngine) {
    
    /*  Função para bloquear os fields filhos ligados a um field pai.
        Caso desbloqueiaComValor = true o field filho será habilitado 
        se o field pai possuir valor. No caso de valueDesbloqueia != null
        o valor para desbloquear o filho deve ser igual ao valor de valueDesbloqueia.
        
        @param field field 
    */
    this.alteraReadOnlyFilhos = function(field) {
        var widget = field.widget;
        field.filhos.forEach(function (filho) {
            var desbloqueiaComValor = (filho.desbloqueiaComValor) ? filho.desbloqueiaComValor : true;
            var valueDesbloqueia    = (filho.valueDesbloqueia)    ? filho.valueDesbloqueia    : null;
            var isRequired          = (filho.isRequired)          ? filho.isRequired          : false;
            
            var filhoField = widget.getField(filho.name);
            
            
            if(valueDesbloqueia == null) {
                filhoField.readOnly =  ((field.value() == "") == desbloqueiaComValor);
                if(((field.value() == "") == desbloqueiaComValor)) widget.currentRow[filho.name] = "";
                if(filhoField.filhos) this.alteraReadOnlyFilhos(filhoField, true);
                widget.getField(filho.name).reload();
            }
            else {
                var habilita = (field.value() == valueDesbloqueia);
                if(habilita) {
                    if(filhoField.readOnly) {
                        if(filho.clearFields) {
                            filho.clearFields.forEach(function (clearField)  {
                                widget.currentRow[clearField] = "";
                            });
                        }
                        widget.currentRow[filho.name] = "";
                    }
                    
                    filhoField.readOnly = false;
                    
                    if(isRequired) {
                        if(filhoField.validations) {
                            filhoField.validations.required = true;
                        }
                        else {
                            filhoField.validations = {required : true};
                        }
                    }
                }
                else {
                    var filhoOutData = filhoField.outData;
                    for(var fieldOut in filhoOutData) {
                        widget.currentRow[fieldOut] = "";
                    } 
                    widget.currentRow[filho.name] = "";
                    filhoField.readOnly = true;
                    if(isRequired) {
                        if(filhoField.validations) {
                            if(filhoField.validations.required) delete filhoField.validations.required;
                        }
                    }
                }
                if(filhoField.filhos) this.alteraReadOnlyFilhos(filhoField, true);
                widget.getField(filho.name).reload();
            }
        });
    };

    /*
        Percorre uma widget procurando por fields com a propiedade "filhos".
        Para os fields com a propiedade fields a função adiciona o evento 
        de alteraReadOnlyFilhos.
        
        @param widget widget
        @param boolean filter
    */
    this.blockFieldsFilhosAndSetEvents = function(widget, filter) {
        if(filter == undefined) filter = true;
        var fields = widget.fields;
        fields.forEach(function (field) {
            if(field.filhos) {
                field.events.push(
                    {
                        "name": "FieldOnChange",
                        "code": "UtilCadFis.alteraReadOnlyFilhos(args.owner.field)"
                    }
                );
                
                field.filhos.forEach(function (filho) {
                    if(filter) {
                        if(!widget.getField(filho.name).filterProperties) 
                            widget.getField(filho.name).filterProperties = {};
                        
                        widget.getField(filho.name).filterProperties.readOnly = false; 
                    }
                    else  {
                        if(filho.desbloqueiaComValor == true && field.value())
                            widget.getField(filho.name).readOnly = false; 
                        else 
                            widget.getField(filho.name).readOnly = true; 
                    }
                });
            }
        });
    };
    /*
        Salva o dataset inteiro.
        
        @param dataSet dataSet
        @param string name - datasource name
    */
    this.saveDataSetCrud = function(dataSet, name){
	    return restEngine.post("cadFis#/crud/"+name+"/save", {
            "requestType": "DataSet",
            "dataset": dataSet
        });
	};
	
	this.fixInlineEdit = function(row){
    	$.each(row, function(index, value){
    		if(row.hasOwnProperty('changed_'+index)){
    			row[index] = row[index+'_inline'] || row[index];
    			row['changed_'+index] = row[index+'_inline'] || row[index];
    		}
    	});
    	return row;
    };
    
    this.fixInlineEditDataSet = function(dataSet){
        dataSet.forEach( row => {
            row = this.fixInlineEdit(row);
        });
        return dataSet;
    };
    
    this.cancelInlineEdit = function(widget) {
	    /* jshint ignore:start */
	    
        // TODO criar função para desmarcar linhas editadas
        // GerUtil.desmarcaLinhasEditadas(lancamentoEncargoWidget, CANCELAR);

        for(var index in widget.dataSource.data){
            let row = widget.dataSource.data[index];
            Object.keys(row).forEach(function (key) {
                if(key.indexOf('changed_') > -1){
                    row[key.replace('changed_','')] = row[key];
                    delete row[key];
                }
            });
            delete row.changed;
        }
        
        widget.list();
        
        /* jshint ignore:end */
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('UtilCadFis', UtilCadFis);
});

// FILE: ./assets/js/repositories/Dfs47000_Valor_Maximo_Venda_Consumidor_Repository.js
var Dfs47000_Valor_Maximo_Venda_Consumidor_Repository = function(restEngine) {

    this.saveVRMAXVENPROD = function(row) {
        return restEngine.post('cadFis#/saveVRMAXVENPROD', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.replicacao_valor_max = function(row) {
        return restEngine.post('cadFis#/replicacao_valor_max', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.cadastramento_automatico = function(row) {
        return restEngine.post('cadFis#/cadastramento_automatico', {
            "requestType": "Row",
            "row": row
        });
    };

}; 

Configuration(function(ContextRegister) {
    ContextRegister.register('Dfs47000_Valor_Maximo_Venda_Consumidor_Repository', Dfs47000_Valor_Maximo_Venda_Consumidor_Repository);
});

// FILE: ./assets/js/repositories/Ger00200_Empresa_Repository.js
function Ger00200_Empresa_Repository(restEngine) {

	this.save = function(row) {
        return restEngine.post('cadFis#/empresaDadosAdicionais/save', {
            "requestType": "DataSet",
            "dataset": Array(row)
        });
	};

    this.saveInscricao = function(row) {
        return restEngine.post('cadFis#/saveInscricaoEstadual', {
            "requestType": "Row",
            "row": row
        });
    };

	this.saveNew = function(row) {
        return restEngine.post('cadFis#/salvarNovaEmpresa/save', {
            "requestType": "Row",
            "row": row
        });
	};
	
	this.saveLogoEmpresa = function(row) {
        return restEngine.post('cadFis#/saveLogoEmpresa', {
            "requestType": "Row",
            "row": row
        });
    };

}
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger00200_Empresa_Repository', Ger00200_Empresa_Repository);
});

// FILE: ./assets/js/repositories/Ger00250_ParametrizacaoInscricaoEstadual_Repository.js
function Ger00250_ParametrizacaoInscricaoEstadual_Repository(restEngine) {

	this.saveMensagem = function(row) {
        return restEngine.post('cadFis#/salvarMensagemInscricao', {
            "requestType": "Row",
            "row": row
        });
	};
	
	this.saveMensagemSubstituto = function(row) {
        return restEngine.post('cadFis#/salvarMensagemSubstituto', {
            "requestType": "Row",
            "row": row
        });
	};
	
	this.saveDiferncialAliquota = function(row) {
        return restEngine.post('cadFis#/saveDiferncialAliquota', {
            "requestType": "Row",
            "row": row
        });
	};

     this.saveSubstitutoTributario = function(row) {
        return restEngine.post('cadFis#/salvarSubstitutoTributario', {
            "requestType": "Row",
            "row": row
        });
    };

    this.replicacao_AliqInt = function(row) {
        return restEngine.post('cadFis#/replicacao_AliqInt', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.cadastramento_automatico_AliqInt = function(row) {
        return restEngine.post('cadFis#/cadastramento_automatico_AliqInt', {
            "requestType": "Row",
            "row": row
        });
    };

}
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger00250_ParametrizacaoInscricaoEstadual_Repository', Ger00250_ParametrizacaoInscricaoEstadual_Repository);
});

// FILE: ./assets/js/repositories/Ger01200_Estado_Repository.js
function Ger01200_Estado_Repository(restEngine) {

	this.save = function(row) {
        return restEngine.post('cadFis#/saveEstado', {
            "requestType": "Row",
            "row": row
        });
	};

}
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger01200_Estado_Repository', Ger01200_Estado_Repository);
});

// FILE: ./assets/js/repositories/Ger01300_Pais_Repository.js
function Ger01300_Pais_Repository(restEngine) {

	this.save = function(row) {
        return restEngine.post('cadFis#/savePais', {
            "requestType": "Row",
            "row": row
        });
	};
	
}
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger01300_Pais_Repository', Ger01300_Pais_Repository);
});

// FILE: ./assets/js/repositories/Ger01500_Municipio_Repository.js
function Ger01500_Municipio_Repository(restEngine) {

	this.save = function(row) {
        return restEngine.post('cadFis#/saveMunicipio', {
            "requestType": "Row",
            "row": row
        });
	};
	
	this.novoCodigoBairro = function(row) {
        return restEngine.post('cadFis#/novoCodigoBairro', {
            "requestType": "Row",
            "row": row
        });
	};
	
	this.novoCodigoRegiao = function(row) {
        return restEngine.post('cadFis#/novoCodigoRegiao', {
            "requestType": "Row",
            "row": row
        });
	};
	
}
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger01500_Municipio_Repository', Ger01500_Municipio_Repository);
});

// FILE: ./assets/js/repositories/Ger05500_produtosDesoneracaoImpostos_Repository.js
function Ger05500_produtosDesoneracaoImpostos_Repository (restEngine) {
    var self = this;

    self.removeProdutoDesoneracaoFornecedor = function (data) {
        return restEngine.post('cadFis#/crud/prodesoneraimfor/remove',
            {
                "requestType":"DataSet",
                "dataset": data
            }
        );
    };

    self.removeProdutoDesoneracaoCliente = function (data) {
        return restEngine.post('cadFis#/crud/prodesoneraimcli/remove',
            {
                "requestType":"DataSet",
                "dataset": data
            }
        );
    };

    self.removeProdutoDesoneracaoFilial = function (data) {
        return restEngine.post('cadFis#/crud/prodesoneraimfil/remove',
            {
                "requestType":"DataSet",
                "dataset": data
            }
        ); 
    };
}

Configuration(function (ContextRegister) {
	ContextRegister.register('Ger05500_produtosDesoneracaoImpostos_Repository', Ger05500_produtosDesoneracaoImpostos_Repository);
});

// FILE: ./assets/js/services/Dfs47000_Valor_Maximo_Venda_Consumidor_Service.js
var Dfs47000_Valor_Maximo_Venda_Consumidor_Service = function(localStorageEngine, Dfs47000_Valor_Maximo_Venda_Consumidor_Repository, ZHPromise, General) {

    this.saveVRMAXVENPROD = function(row) {
        return Dfs47000_Valor_Maximo_Venda_Consumidor_Repository.saveVRMAXVENPROD(row);
    };
    
    this.replicacao_valor_max = function(row) {
        return Dfs47000_Valor_Maximo_Venda_Consumidor_Repository.replicacao_valor_max(row);
    };
    
    this.cadastramento_automatico = function(row) {
        return Dfs47000_Valor_Maximo_Venda_Consumidor_Repository.cadastramento_automatico(row);
    };

};

Configuration(function(ContextRegister) {
    ContextRegister.register("Dfs47000_Valor_Maximo_Venda_Consumidor_Service", Dfs47000_Valor_Maximo_Venda_Consumidor_Service);
});

// FILE: ./assets/js/services/Ger00000CadastramentosAutomaticoService.js
var Ger00000CadastramentosAutomaticoService = function () {
    
    let glossary = {
        'MARCA': {
            'CDMARCA' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    },
      	    'NMMARCA' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    },
      	    'IDMARCAATIVA' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    }
        },
        'MARCPROD': {
            'CDARVPROD' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    },
      	    'CDMARCA' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    }
        },
        'PRODFORN': {
            'IDTPIJURFORN': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 5
            }, 
            'NRINSJURFORN': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            }, 
            'CDARVPROD': {
                'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
            }, 
            'QTDIASENTR': {
                'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
            }, 
            'QTMINAF': {
                'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
            }, 
            'SGUNIDADE': {
                'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
            }, 
            'VRARREDCMPFO': {
                'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
            }, 
            'VRPERPIPRFO': {
                'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
            }, 
            'VRARREDEMPE' : {
                'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
            }, 
            'VRPERVARPREPRFO': {
                'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
            }, 
            'NRDIASVALPRFORN': {
                'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
            }
        },
        'COMPRADOR': {
            'CDOPERADOR' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    },
      	    'VRLIMAFCOMP' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    },
      	    'VRLIMAFMES' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    }
        },
        'PRODCOMP': {
            'CDOPERADOR' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    },
      	    'CDARVPROD' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    }
        },
        'GERENTE': {
            'CDOPERADOR' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    },
      	    'VRLIMIAFGER' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    },
      	    'VRLIMAFMESG' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    }
        },
        'REGIAO': {
            'CDREGIAO' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    },
      	    'NMREGIAO' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    },
      	    'CDPAIS' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    },
      	    'SGESTADO' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    }
        },
        'FORMPGTO': {
            'CDFORMPGTO' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    },
      	    'NMFORMPGTO' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    },
      	    'IDTIPODTPGTO' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 8
      	    },
      	    'IDTPPERIODO' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 5
      	    },
      	    'IDREFECALCPARC' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 7
      	    },
      	    'IDCONSDIAUTIL' : {
      	        'desc'     : '',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 4
      	    }
        },
        //Fornecedor
        'FORNECEDOR': {
            'IDTPIJURFORN': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 5
    
            },
            'NRINSJURFORN': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'NRINSESTFORN': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'NMRAZSOCFORN': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'NMFANTFORN': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'IDENDEMISFOR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 4
    
            },
            'IDENDCFOPFOR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 4
    
            },
            'IDPRIPUBFORN': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 3
    
            }, //PRINCIPAL
            'IDTPENDEFORN': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'CDPAIS': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'SGESTADO': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'CDMUNICIPIO': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'NMMUNICIPIO': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'DSENDEFORN': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'DSCOMPENDFOR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'NMBAIRFORN': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'NRCEPFORN': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'DSEMAILFORN': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'DSEMAILFORNNFE': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'NRCELULARFOR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'NRTELRESIFOR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            }, //COBRANÇA
            'IDTPENDEFORNCOBR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'CDPAISCOBR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'SGESTADOCOBR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'CDMUNICIPIOCOBR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'NMMUNICIPIOCOBR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'DSENDEFORNCOBR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'DSCOMPENDFORCOBR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'NMBAIRFORNCOBR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'NRCEPFORNCOBR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'DSEMAILFORNCOBR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'DSEMAILFORNNFECOBR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'NRCELULARFORCOBR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'NRTELRESIFORCOBR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            }, //ENTREGA
            'IDTPENDEFORNENTR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'CDPAISENTR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'SGESTADOENTR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'CDMUNICIPIOENTR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'NMMUNICIPIOENTR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'DSENDEFORNENTR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'DSCOMPENDFORENTR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'NMBAIRFORNENTR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'NRCEPFORNENTR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'DSEMAILFORNENTR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'DSEMAILFORNNFEENTR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'NRCELULARFORENTR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            },
            'NRTELRESIFORENTR': {
                'desc': '',
                'template': 'field/textarea.html',
                'textRows': 1
    
            }   
        }
    };

    this.getGlossary = function(tableName) {
	    return glossary[tableName];
	};
	
};

Configuration(function (ContextRegister) {
	ContextRegister.register('Ger00000CadastramentosAutomaticoService', Ger00000CadastramentosAutomaticoService);
});

// FILE: ./assets/js/services/Ger00200_Empresa_Service.js
function Ger00200_Empresa_Service(Ger00200_Empresa_Repository, General) {

    this.salvarEmpresa = function(widget){
        var row = widget.currentRow;
		
	    return Ger00200_Empresa_Repository.save(row);
		/*this.validaBairro(widget).then( function(success){
		        row.NMBAIRRO = success.dataset.bairro[0].NMBAIRRO;
		        row.CDBAIRRO = success.dataset.bairro[0].CDBAIRRO;
		        return Ger00200_Empresa_Repository.save(row);
		    }
		);*/
		
	};
	
	this.validaBairro = function(widget){
	    var neighborhoodField;
	    if(widget.name == "widgetInscricaoEstadual"){
	        //widget.getField("NMBAIRIEST").dataSourceFilter[1].value = widget.getField("SGESTADO").value();
	        //widget.getField("NMBAIRIEST").dataSourceFilter[2].value = widget.getField("CDMUNICIPIO").value(); 
            neighborhoodField = widget.getField("NMBAIRIEST");
            neighborhoodField.dataSourceFilter.push(
                {
                    "name": "NMBAIRRO",
                    "operator": "=",
                    "value": widget.getField("NMBAIRIEST").value()
                }
            );
        }else if(widget.name == "EmpresaDadosAdicionaisWidget"){
            neighborhoodField = widget.getParent().getField("NMBAIRRO");
            neighborhoodField.dataSourceFilter.push(
                {
                    "name": "NMBAIRRO",
                    "operator": "=",
                    "value": widget.getParent().getField("NMBAIRRO").value()
                }
            );
            
        }else{
            neighborhoodField = widget.getField("NMBAIRRO");
            neighborhoodField.dataSourceFilter.push(
                {
                    "name": "NMBAIRRO",
                    "operator": "=",
                    "value": widget.getField("NMBAIRRO").value()
                }
            );
        }
        
	    if(neighborhoodField.dataSource.data.length == 0){
            var neighborhoodValue = neighborhoodField.dataSourceFilter.filter(function(data) {
                    return data.operator == 'LIKE_ALL' && data.value != '%%';
                } 
            );
            if(neighborhoodValue.length > 0){
                neighborhoodValue = neighborhoodValue[0].value.replace(/%/g, '');
                var neighborhoodSequentialFilter = neighborhoodField.dataSourceFilter;
                neighborhoodSequentialFilter.forEach( function(filter){
                    if(filter.name == 'NMMUNICIPIO')
                        filter.value = neighborhoodValue;
                });
                
                return General.callRestEngine('cadFis#/validateNeighborhood', 'FilterData', neighborhoodSequentialFilter);
            }else{
                return General.callRestEngine('cadFis#/validateNeighborhood', 'FilterData', neighborhoodField.dataSourceFilter.filter(function(filtros){ 
                            return filtros.operator != 'LIKE_ALL';
                        }
                    )
                );
            }
        }else{
            return General.callRestEngine('cadFis#/validateNeighborhood', 'FilterData', neighborhoodField.dataSourceFilter.filter(function(filtros){ 
                            return filtros.operator != 'LIKE_ALL';
                        }
                    )
                );
        }
	};

    this.salvarInscricao = function(widget){
        var row = widget.currentRow;
        
        return Ger00200_Empresa_Repository.saveInscricao(row);
		
		/*var bairro;
        if(widget.name == "widgetInscricaoEstadual"){
            bairro = widget.getField("NMBAIRIEST");
        } else{
            bairro = widget.getField("NMBAIRRO");
        }
        
        bairro.dataSourceFilter[0].value = General.getFieldValue('CDPAIS', 'EmpresaWidget');
		bairro.dataSourceFilter[1].value = General.getFieldValue('SGESTADO', 'EmpresaWidget');
		bairro.dataSourceFilter[2].value = General.getFieldValue('CDMUNICIPIO', 'EmpresaWidget');
		return this.validaBairro(widget).then( function(success){
		        if(widget.name == "widgetInscricaoEstadual"){
		            row.NMBAIRIEST = success.dataset.bairro[0].NMBAIRRO;
		            
		            widget.getField("NMBAIRIEST").dataSourceFilter.pop();
		        } else {
		            widget.getField("NMBAIRRO").dataSourceFilter.pop();
		        }
		        //row.NMBAIRRO = success.dataset.bairro[0].NMBAIRRO;
		        //row.CDBAIRRO = success.dataset.bairro[0].CDBAIRRO;
		return Ger00200_Empresa_Repository.saveInscricao(row);
		    }
		);*/
    };

	this.salvarNovaEmpresa = function(widget){
		var row = widget.currentRow;
		
		return Ger00200_Empresa_Repository.save(row);
		    
		/*var bairro = widget.getField("NMBAIRRO");
		
		bairro.dataSourceFilter[0].value = General.getFieldValue('CDPAIS', 'EmpresaWidget');
		bairro.dataSourceFilter[1].value = General.getFieldValue('SGESTADO', 'EmpresaWidget');
		bairro.dataSourceFilter[2].value = General.getFieldValue('CDMUNICIPIO', 'EmpresaWidget');
		return this.validaBairro(widget).then( function(success){
		    if(success.dataset.bairro.length > 0){
		        bairro.dataSource.data = success.dataset.bairro;
		    }
		    if(success.dataset.bairro.length == 1){
		        row.NMBAIRRO = success.dataset.bairro[0].NMBAIRRO;
		        row.CDBAIRRO = success.dataset.bairro[0].CDBAIRRO; 
		    }
		    return Ger00200_Empresa_Repository.save(row);
		    }.bind(this)
		);*/
		    
	};

	this.validateNumeroDeInscricao = function(inputValue) {
        var inscricao = General.inscricaoFormat(inputValue);
        if(!inscricao.valid) {
            //build appropriated error messages
            inscricao.error = {};
            switch(inscricao.tipo.cod) {
                case 'J':
                    inscricao.error.msg = "CNPJ \"" + inscricao.value + "\" inválido!";
                    break;
                case 'F':
                    inscricao.error.msg = "CPF \"" + inscricao.value + "\" inválido!";
                    break;
                case null:
                    break;
                case 'I':
                /* falls through */
                default:
                    inscricao.error.msg = inscricao.tipo.desc + " \"" + inscricao.value + "\" inválida!";
            }
        }
        return inscricao;
    };

    this.concatenaCamposInscricaoEstadual = function(row){
        if(!row.DSLOGRADOURO){
            row.DSENDEIEST = row.DSENDEIESTSEP+', '+row.NRENDEIESTSEP ;
        }else{
            row.DSENDEIEST = row.DSLOGRADOURO+' '+row.DSENDEIESTSEP+', '+row.NRENDEIESTSEP ;
        }


        row.NRTELEIEST = row.NRDDDTELEIEST+row.NRTELEIESTSEP ;
        if(row.NRTELEIEST){
            row.NRTELEIEST = row.NRTELEIEST.replace(/[^0-9]/g,'');
        }
        if(row.NRTELEIESTSEP){
            row.NRTELEIESTSEP = row.NRTELEIESTSEP.replace(/[^0-9]/g,'');
        }

        row.NRFAXIEST = row.NRDDDFAXIEST+row.NRFAXIESTSEP ;
        if(row.NRFAXIEST){
            row.NRFAXIEST = row.NRFAXIEST.replace(/[^0-9]/g,'');
        }
        if(row.NRFAXIESTSEP){
           row.NRFAXIESTSEP = row.NRFAXIESTSEP.replace(/[^0-9]/g,'');
        }
    };

    this.concatenaCamposEmpresa = function(row){
        if(!row.DSLOGRADOURO){
            row.DSENDEEMPR  = row.DSENDEEMPSEP+', '+row.NRENDEEMPSEP ;
        }else{
            row.DSENDEEMPR  = row.DSLOGRADOURO+' '+row.DSENDEEMPSEP+', '+row.NRENDEEMPSEP ;
        }


        row.NRTELEFOEMPR = row.NRDDDTELEEMP+row.NRTELEEMPSEP ;
        if(row.NRTELEFOEMPR){
            row.NRTELEFOEMPR = row.NRTELEFOEMPR.replace(/[^0-9]/g,'');
        }
        if(row.NRTELEEMPSEP){
            row.NRTELEEMPSEP = row.NRTELEEMPSEP.replace(/[^0-9]/g,'');
        }

        row.NRFAXEMP = row.NRDDDFAXEMP+row.NRFAXEMPSEP ;
        if(row.NRFAXEMP){
            row.NRFAXEMP = row.NRFAXEMP.replace(/[^0-9]/g,'');
        }
        if(row.NRFAXEMPSEP){
            row.NRFAXEMPSEP = row.NRFAXEMPSEP.replace(/[^0-9]/g,'');
        }

    };

    this.concatenaCamposInscricaoMunicipal = function(row){
        if(!row.DSLOGRADOURO){
            row.DSENDEIMUN = row.DSENDEIMUNSEP;
        }else{
            row.DSENDEIMUN = row.DSLOGRADOURO+' '+row.DSENDEIMUNSEP;
        }

        if(row.NRTELEIMUN){
            row.NRTELEIMUN = row.NRTELEIMUN.replace(/[^0-9]/g,'');
        }

        if(row.NRFAXIMUN){
            row.NRFAXIMUN = row.NRFAXIMUN.replace(/[^0-9]/g,'');
        }
    };
    
    this.salvarLogo = function(rowLogo){

        return Ger00200_Empresa_Repository.saveLogoEmpresa(rowLogo);
    };


}
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger00200_Empresa_Service', Ger00200_Empresa_Service);
});

// FILE: ./assets/js/services/Ger00250_ParametrizacaoInscricaoEstadual_Service.js
function Ger00250_ParametrizacaoInscricaoEstadual_Service(Ger00250_ParametrizacaoInscricaoEstadual_Repository, General) {

	this.salvarSubstitutoTributario = function (row) {
		return Ger00250_ParametrizacaoInscricaoEstadual_Repository.saveSubstitutoTributario(row);
	};

	this.saveDiferncialAliquota = function (row) {
		return Ger00250_ParametrizacaoInscricaoEstadual_Repository.saveDiferncialAliquota(row);
	};

	this.salvarMensagem = function (row) {
		return Ger00250_ParametrizacaoInscricaoEstadual_Repository.saveMensagem(row);
	};
	
	this.salvarMensagemSubstituto = function (row) {
		return Ger00250_ParametrizacaoInscricaoEstadual_Repository.saveMensagemSubstituto(row);
	};
	
	this.salvarApuracao = function (row) {
		return Ger00250_ParametrizacaoInscricaoEstadual_Repository.salvarApuracao(row);
	};

	this.concatenaCampoTipoOperacao = function (row, campo, campoSalvo, campoTipo) {
		var campoCodigo = row[campo];
		if (campoCodigo) {
			if (campoCodigo.length === 0) {
				row[campoSalvo] = null;
			} else {
				var campoES = row[campoTipo];
				var valor = '_';
				for (var i = 0; i < campoCodigo.length; i++) {
					valor = valor + campoES[i] + campoCodigo[i] + '_';
				}
				row[campoSalvo] = valor;
			}
		}
	};

	this.validaAliquota = function (row) {
		var aliquotaSaida = row.VRALIQTOTALSAIDA;
		var aliquotaImposto = row.VRALIQIMPOSREC;

		if (parseFloat(aliquotaSaida) !== 0) {
			if (parseFloat(aliquotaSaida) > 100) {
				return false;
			}
		}
		if (parseFloat(aliquotaImposto) !== 0) {
			if (parseFloat(aliquotaImposto) > 100) {
				return false;
			}
		}
		return true;
	};

	this.controlaValorCargaTributaria = function (row) {
		if (row.IDCARGA == '1') {
			row.IDCREDDEBNORM = 'S';
			row.IDOUTCREDDEB = 'N';
			row.CDAJSTCREDCARGA = null;
			row.DSOUTCREDCARGA = null;
			row.CDAJSTDEBICARGA = null;
			row.DSOUTDEBICARGA = null;
		} else if (row.IDCARGA == '2') {
			row.IDCREDDEBNORM = 'N';
			row.IDOUTCREDDEB = 'S';
		} else {
			row.IDCREDDEBNORM = 'N';
			row.IDOUTCREDDEB = 'N';
			row.CDAJSTCREDCARGA = null;
			row.DSOUTCREDCARGA = null;
			row.CDAJSTDEBICARGA = null;
			row.DSOUTDEBICARGA = null;
		}
	};

	this.validateNumeroDeInscricao = function (inputValue) {
		var inscricao = General.inscricaoFormat(inputValue);
		if (!inscricao.valid) {
			//build appropriated error messages
			inscricao.error = {};
			switch (inscricao.tipo.cod) {
			case 'J':
				inscricao.error.msg = "CNPJ \"" + inscricao.value + "\" inválido!";
				break;
			case 'F':
				inscricao.error.msg = "CPF \"" + inscricao.value + "\" inválido!";
				break;
			case null:
				break;
			case 'I':
				/* falls through */
			default:
				inscricao.error.msg = inscricao.tipo.desc + " \"" + inscricao.value + "\" inválida!";
			}
		}
		return inscricao;
	};
	
	this.replicacao_AliqInt = function(row) {
        return Ger00250_ParametrizacaoInscricaoEstadual_Repository.replicacao_AliqInt(row);
    };
    
    this.cadastramento_automatico_AliqInt = function(row) {
        return Ger00250_ParametrizacaoInscricaoEstadual_Repository.cadastramento_automatico_AliqInt(row);
    };

}
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger00250_ParametrizacaoInscricaoEstadual_Service', Ger00250_ParametrizacaoInscricaoEstadual_Service);
});

// FILE: ./assets/js/services/Ger01200_Estado_Service.js
function Ger01200_Estado_Service(Ger01200_Estado_Repository) {

	this.salvarEstado = function(row){
        return Ger01200_Estado_Repository.save(row);
    };

}
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger01200_Estado_Service', Ger01200_Estado_Service);
});

// FILE: ./assets/js/services/Ger01300_Pais_Service.js
function Ger01300_Pais_Service(Ger01300_Pais_Repository) {

	this.salvarPais = function(row){
        return Ger01300_Pais_Repository.save(row);
    };
    
}
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger01300_Pais_Service', Ger01300_Pais_Service);
});

// FILE: ./assets/js/services/Ger01500_Municipio_Service.js
function Ger01500_Municipio_Service(Ger01500_Municipio_Repository) {

	this.salvarMunicipio = function(row){
        return Ger01500_Municipio_Repository.save(row);
    };
    
    this.novoCodigoBairro = function(row){
        return Ger01500_Municipio_Repository.novoCodigoBairro(row);
    };
    
    this.novoCodigoRegiao = function(row){
        return Ger01500_Municipio_Repository.novoCodigoRegiao(row);
    };
    
}
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger01500_Municipio_Service', Ger01500_Municipio_Service);
});

// FILE: ./assets/js/services/Ger05500_produtosDesoneracaoImpostos_Service.js
function Ger05500_produtosDesoneracaoImpostos_Service(Ger05500_produtosDesoneracaoImpostos_Repository) {
    
    this.removeProdutoDesoneracaoFornecedor = function(data) {
        return Ger05500_produtosDesoneracaoImpostos_Repository.removeProdutoDesoneracaoFornecedor(data);
    };

    this.removeProdutoDesoneracaoCliente = function(data) {
        return Ger05500_produtosDesoneracaoImpostos_Repository.removeProdutoDesoneracaoCliente(data);
    }; 

    this.removeProdutoDesoneracaoFilial = function(data) {
        return Ger05500_produtosDesoneracaoImpostos_Repository.removeProdutoDesoneracaoFilial(data);
    };
     
}
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger05500_produtosDesoneracaoImpostos_Service', Ger05500_produtosDesoneracaoImpostos_Service);
});

// FILE: ./assets/js/services/Ger06800_SerieDocumentosEntrada_Service.js
var Ger06800_SerieDocumentosEntrada_Service = function() {

    this.validaCodigoNfeScan = function(codigo){
        if(codigo){
            var resul = false;
            if(codigo>='900' && codigo<='999')
                resul =true;
            return resul;
        }else{
            return true;
        }

    };
    this.validaCodigoNfe = function(codigo){
        if(codigo){
            var resul = false;
            if(codigo>='1' && codigo<='889')
                resul =true;
            return resul;
        }
        else{
            return true;
        }
    };

};
Configuration(function(ContextRegister) {
	ContextRegister.register("Ger06800_SerieDocumentosEntrada_Service", Ger06800_SerieDocumentosEntrada_Service);
});


// FILE: ./assets/js/controllers/Dfs47000_Valor_Maximo_Venda_Consumidor_Controller.js
function Dfs47000_Valor_Maximo_Venda_Consumidor_Controller(General, MessageService, ScreenService, templateManager, Dfs47000_Valor_Maximo_Venda_Consumidor_Service) {
    
    this.fieldOnChangePais = function() {
        var widget = templateManager.container.getWidget('valor_maximo_venda_consumidor');
        var dadosWidget = templateManager.container.getWidget('percentual_carga_tributaria_media_grid');
        
        widget.getField('SGESTADO').clearValue();
        widget.getField('NMESTADO').clearValue();
        
        if(!widget.getField('NMPAIS').value()) {
            widget.getField('NMESTADO').readOnly = true;
            dadosWidget.isVisible = false;
            dadosWidget.deactivate();
            dadosWidget.actions.forEach(function(action){
                if(action.showAsAction == 'never_list'){
                    action.isVisible = false;
                }
            });
            dadosWidget.reload();
        } else {
            widget.getField('NMESTADO').readOnly = false;
        }
        
        var field = widget.getField('NMESTADO');
        field.reload();
    };
    
    this.fieldOnChangePaisReplicacao_ORIG = function() {
        var widget = templateManager.container.getWidget('replicacao_pop_up');
        widget.getField('SGESTADO_ORIG').clearValue();
        widget.getField('NMESTADO_ORIG').clearValue();
        
        if(!widget.getField('NMPAIS_ORIG').value()) {
            widget.getField('NMESTADO_ORIG').readOnly = true;
        } else {
            widget.getField('NMESTADO_ORIG').readOnly = false;
        }
        
        var field = widget.getField('NMESTADO_ORIG');
        field.reload();
    };
    
    this.fieldOnChangePaisReplicacao_DEST = function() {
        var widget = templateManager.container.getWidget('replicacao_pop_up');
        widget.getField('SGESTADO_DEST').clearValue();
        widget.getField('NMESTADO_DEST').clearValue();
        
        if(!widget.getField('NMPAIS_DEST').value()) {
            widget.getField('NMESTADO_DEST').readOnly = true;
        } else {
            widget.getField('NMESTADO_DEST').readOnly = false;
        }
        
        var field = widget.getField('NMESTADO_DEST');
        field.reload();
    };
    
    this.fieldOnChangeEstado = function() {
        var widget = templateManager.container.getWidget('valor_maximo_venda_consumidor');
        var dadosWidget = templateManager.container.getWidget('valor_maximo_venda_consumidor_grid');
        if(!widget.getField('NMESTADO').value()){
            dadosWidget.isVisible = false;
            dadosWidget.deactivate();
            dadosWidget.actions.forEach(function(action){
                if(action.showAsAction == 'never_list'){
                    action.isVisible = false;
                }
            });
            dadosWidget.reload();
        } else {
            dadosWidget.isVisible = true;
            dadosWidget.activate();
            dadosWidget.actions.forEach(function(action){
                if(action.showAsAction == 'never_list'){
                    action.isVisible = true;
                }
            });
            dadosWidget.reload();
        }
    };
    
    this.verificaPorcentagem = function(field){
        var txt = "VALOR_ENTRE_0_100";
        var valor_porcentagem = parseFloat(field.value().toString().replace(",","."));
        if((valor_porcentagem < 0) || (valor_porcentagem > 100)){
            MessageService.showMessageByCode(txt, {"PARAMETRO": field.label}); 
            field.clearValue();
        }
    };
    
    this.verificaProduto = function(widget){
        var prodIni = parseFloat(widget.currentRow.CDARVPRODINI);
        var prodFin = parseFloat(widget.currentRow.CDARVPRODFIN);
        if(prodIni > prodFin){
            ScreenService.showMessage("Produto Final deve ser maior que o Produto Inicial.");
            widget.getField('CDPRODUTOINI').clearValue();
            widget.getField('CDARVPRODINI').clearValue();
            widget.getField('NMPRODUTOINI').clearValue();
            widget.getField('CDPRODUTOFIN').clearValue();
            widget.getField('CDARVPRODFIN').clearValue();
            widget.getField('NMPRODUTOFIN').clearValue();
        }
    };
    
    this.saveVRMAXVENPROD = function(widget){
        if(widget.currentRow.IDUTILVRMAX && widget.currentRow.IDUTILVRMAX != ""){
            if(widget.currentRow.VRMAXVENDA && widget.currentRow.VRMAXVENDA != ""){
                if(widget.currentRow.VRPEMAXVENDA && widget.currentRow.VRPEMAXVENDA != ""){
                    
                    widget.currentRow.CDPAIS = widget.getParent().currentRow.CDPAIS; 
                    widget.currentRow.SGESTADO = widget.getParent().currentRow.SGESTADO; 
                    
                    Dfs47000_Valor_Maximo_Venda_Consumidor_Service.saveVRMAXVENPROD(widget.currentRow).then(function(sucess){
                        var result = sucess.dataset["/result"][0];
                        if(result){
                            ScreenService.successNotification('Salvo com sucesso.');
                            ScreenService.goBack();
                            widget.reload();
                        } else {
                            ScreenService.showMessage('Erro ao salvar.');
                        }
                    });
                    
                } else {
                    ScreenService.showMessage('O Percentual deve ser informado.');
                } 
            } else {
                ScreenService.showMessage('O Preço Máximo deve ser informado.');
            }
        } else {
            ScreenService.showMessage('Utiliza deve ser informado.');
        }
    };
    
    this.replicacao_popUp = function(){
        var replicacao_pop_up = templateManager.container.getWidget('replicacao_pop_up');
        ScreenService.closePopup();
        replicacao_pop_up.isVisible = true;
        replicacao_pop_up.getField('CDPAIS_ORIG').clearValue();
        replicacao_pop_up.getField('NMPAIS_ORIG').clearValue();
        replicacao_pop_up.getField('SGESTADO_ORIG').clearValue();
        replicacao_pop_up.getField('NMESTADO_ORIG').clearValue();
        replicacao_pop_up.getField('CDPAIS_DEST').clearValue();
        replicacao_pop_up.getField('NMPAIS_DEST').clearValue();
        replicacao_pop_up.getField('SGESTADO_DEST').clearValue();
        replicacao_pop_up.getField('NMESTADO_DEST').clearValue();
        ScreenService.openPopup(replicacao_pop_up);
    };
    
    this.replicacao_popUp_close = function(){
        var replicacao_pop_up = templateManager.container.getWidget('replicacao_pop_up');
        replicacao_pop_up.isVisible = false;
        ScreenService.closePopup();
    };
    
    this.replicacao_popUp_confirm = function(widget){
        if(widget.currentRow.CDPAIS_ORIG &&(widget.currentRow.CDPAIS_ORIG != "")){
            if(widget.currentRow.SGESTADO_ORIG &&(widget.currentRow.SGESTADO_ORIG != "")){
                if(widget.currentRow.CDPAIS_DEST &&(widget.currentRow.CDPAIS_DEST != "")){
                    if(widget.currentRow.SGESTADO_DEST &&(widget.currentRow.SGESTADO_DEST != "")){
                        Dfs47000_Valor_Maximo_Venda_Consumidor_Service.replicacao_valor_max(widget.currentRow).then(function(sucess){
                            var result = sucess.dataset["/result"][0];
                            if(result){
                                ScreenService.showMessage('Replicado com sucesso.');
                                widget.isVisible = false;
                                ScreenService.closePopup();
                                templateManager.container.getWidget('valor_maximo_venda_consumidor_grid').reload();
                            } else {
                                ScreenService.showMessage('Erro ao replicar.');
                            }
                        }, function(error){
                            var texto = "SGESTADO_QUALQUER";
                            var sgestado = error.data.error.ESTADO;
                            var sgpais = error.data.error.PAIS;
                            MessageService.showMessageByCode(texto, {"SGESTADO": sgestado , "SGPAIS": sgpais});
                        });
                    } else {
                        ScreenService.showMessage('O Estado de Destino deve ser informado.');
                    }
                } else {
                    ScreenService.showMessage('O País de Destino deve ser informado.');
                }
            } else {
                ScreenService.showMessage('O Estado de Origem deve ser informado.');
            }
        } else {
            ScreenService.showMessage('O País de Origem deve ser informado.');
        }
    
    };
    
    this.cadastramento_automatico = function(){
        var cadastramento_automatico_pop_up = templateManager.container.getWidget('cadastramento_automatico_pop_up');
        ScreenService.closePopup();
        cadastramento_automatico_pop_up.isVisible = true;
        cadastramento_automatico_pop_up.getField('CDPRODUTOINI').clearValue();
        cadastramento_automatico_pop_up.getField('CDARVPRODINI').clearValue();
        cadastramento_automatico_pop_up.getField('NMPRODUTOINI').clearValue();
        cadastramento_automatico_pop_up.getField('CDPRODUTOFIN').clearValue();
        cadastramento_automatico_pop_up.getField('CDARVPRODFIN').clearValue();
        cadastramento_automatico_pop_up.getField('NMPRODUTOFIN').clearValue();
        
        cadastramento_automatico_pop_up.getField('VRMAXVENDA').clearValue();
        cadastramento_automatico_pop_up.getField('VRDESCMAXVENDA').clearValue();
        cadastramento_automatico_pop_up.getField('IDUTILVRMAX').clearValue();
        cadastramento_automatico_pop_up.getField('VRPEMAXVENDA').clearValue();
        
        ScreenService.openPopup(cadastramento_automatico_pop_up);
    };
    
    this.cadastramento_automatico_close = function(){
        var replicacao_pop_up = templateManager.container.getWidget('cadastramento_automatico_pop_up');
        replicacao_pop_up.isVisible = false;
        ScreenService.closePopup();
    };
    
    this.cadastramento_automatico_confirm = function(widget){
        if(widget.currentRow.CDPRODUTOINI &&(widget.currentRow.CDPRODUTOINI != "")){
            if(widget.currentRow.CDPRODUTOFIN &&(widget.currentRow.CDPRODUTOFIN != "")){
                if(widget.currentRow.IDUTILVRMAX &&(widget.currentRow.IDUTILVRMAX != "")){
                    if(widget.currentRow.VRMAXVENDA &&(widget.currentRow.VRMAXVENDA != "")){
                        if(widget.currentRow.VRPEMAXVENDA &&(widget.currentRow.VRPEMAXVENDA != "")){
                            
                            widget.currentRow.CDPAIS = widget.getParent().getParent().currentRow.CDPAIS; 
                            widget.currentRow.SGESTADO = widget.getParent().getParent().currentRow.SGESTADO; 
                    
                            Dfs47000_Valor_Maximo_Venda_Consumidor_Service.cadastramento_automatico(widget.currentRow).then(function(sucess){
                                var result = sucess.dataset["/result"][0];
                                if(result){
                                    ScreenService.showMessage('Cadastramento automático realizado com sucesso.');
                                    widget.isVisible = false;
                                    ScreenService.closePopup();
                                    templateManager.container.getWidget('valor_maximo_venda_consumidor_grid').reload();
                                } else {
                                    ScreenService.showMessage('Erro no cadastramento automático.');
                                }
                            }, function(error){
                                ScreenService.showMessage(error.data.error);
                            });
                            
                        } else {
                            ScreenService.showMessage('O Percentual deve ser informado.');
                        }
                    } else {
                        ScreenService.showMessage('O Preço Máximo deve ser informado.');
                    }
                } else {
                    ScreenService.showMessage('Utiliza deve ser informado.');
                }
            } else {
                ScreenService.showMessage('O Produto Final deve ser informado.');
            }
        } else {
            ScreenService.showMessage('O Produto Inicial deve ser informado.');
        }
    
    };
    
}
Configuration(function (ContextRegister) {
    ContextRegister.register('Dfs47000_Valor_Maximo_Venda_Consumidor_Controller', Dfs47000_Valor_Maximo_Venda_Consumidor_Controller);
});

// FILE: ./assets/js/controllers/Dfs53300_historico_cronograma_dfe_Controller.js
function Dfs53300_historico_cronograma_dfe_Controller(ScreenService, templateManager) {
    
    this.historicoAfterMoveRow = (widget) => {
        if(!widget.inlineEditing) {
            let impFuturas = templateManager.container.getWidget('implementacoes_futuras');
            let tabImpFuturas = templateManager.container.getWidget('tabimplementacoes_futuras');
            
            impFuturas.dataSourceFilter.forEach(data => {
                     if(data.name == 'CDPROCESSO')      data.value = widget.currentRow.CDPROCESSO;
                else if(data.name == 'CDNOTATECNICA')   data.value = widget.currentRow.CDNOTATECNICA;
                else if(data.name == 'CDVERSAONT')      data.value = widget.currentRow.CDVERSAONT;
            });
            
            impFuturas.reload();
            ScreenService.openSwipe(tabImpFuturas);
        }
    };
    
    this.cdProcessoOnChange = (valueCdProcesso) => {
        let widgetAtual = templateManager.container.getActiveWidget();
        let historico = templateManager.container.getWidget('historico');
        
        if(widgetAtual.name !== 'historico') ScreenService.goBack();
        
        historico.dataSourceFilter.forEach(data => {
            if(data.name == 'CDPROCESSO') data.value = valueCdProcesso;
        });
        historico.reload();
    };
    
    this.wdgOnSaveInline = (widget) => {
        let itens = widget.dataSource.data;
        let itensModificados = itens.filter(item => item.changed_DTINIVIGENCIAHOMO || item.changed_DTINIVIGENCIAPROD);
        
        widget.dataSource.save().then(() => {
            itensModificados.forEach (item => {
                if(item.changed_DTINIVIGENCIAHOMO) delete item.changed_DTINIVIGENCIAHOMO;
                if(item.changed_DTINIVIGENCIAPROD) delete item.changed_DTINIVIGENCIAPROD;
                if(item.DTINIVIGENCIAHOMO_inline)  delete item.DTINIVIGENCIAHOMO_inline;
                if(item.DTINIVIGENCIAPROD_inline)  delete item.DTINIVIGENCIAPROD_inline;
                delete item.changed;
            });
            widget.activate();
            widget.list();
            ScreenService.successNotification("Todas as alterações foram salvas com sucesso.");
            widget.reload();
        });
    };
    
    this.wdgOnCancelInline = (widget) => {
        widget.currentRow = [];
        widget.list();
        widget.reload();
    };
}
Configuration(function (ContextRegister) {
    ContextRegister.register('Dfs53300_historico_cronograma_dfe_Controller', Dfs53300_historico_cronograma_dfe_Controller);
});

// FILE: ./assets/js/controllers/Dfs87000_Autorizacao_Obter_Xml.js
function Dfs87000_Autorizacao_Obter_Xml(General, templateManager, ScreenService) {
    
    var self = this;
    
    this.inscricaoOnChange = function(field) {
        var inscricao = field.value();
        var inscricaoValida = false;
        
        if(inscricao) {
            if(inscricao.length == '11') {
                inscricaoValida = General.validateCPF(inscricao);
            }
            else if (inscricao.length == '14') {
                inscricaoValida = General.validateCNPJ(inscricao);
            }
        }
        
        if(!inscricaoValida) {
            ScreenService.showMessage('Inscrição Inválida', 'error');
            field.setValue('');
        }
    };
    
    this.habilitaCamposInscricao = function(widget, enable) {
        widget.getField('NMEMPRESA').isVisible = enable;
        widget.getField('CDINSCESTA').isVisible = enable;
        widget.redraw();
    };
    
    this.reloadWidgetInscricaoEstadual = function(field) {
        field.widget.widgets[1].reload();
        field.widget.widgets[1].getAction('adicionar').isVisible = (field.value()!="") ? true : false;
    };
    
    this.openReplicacao = function(widget) {
        var replicacao = widget.getParent().widgets[2];
        replicacao.currentRow = {
            CDINSCESTADEST: '',
            CDINSCESTAORIG: '',
            CDEMPRESADEST: '',
            NMEMPRESADEST: '',
            CDEMPRESAORIG: '',
            NMEMPRESAORIG: ''
        };
        replicacao.isVisible = true;
        ScreenService.openPopup(replicacao);
        replicacao.activate();
        replicacao.reload();
    };
    
    
    this.closeReplicacao = function(widget) {
        widget.isVisible = false;
        ScreenService.closePopup();
        widget.getParent().widgets[1].activate();
        widget.getParent().widgets[1].reload();
    };
    
    this.limpa = function(field, fields) {
        var widget = field.widget;
        var validations = {};
        if(field.value == 'N') {
            validations.required = true;
        }
        fields.forEach(function(fieldName) {
            widget.currentRow[fieldName] = '';  
            if(widget.getField(fieldName)) {
                widget.getField(fieldName).validations = validations;
            }
        });
    };
    
    this.limpaCheckBox = function(field, fields) {
        var widget = field.widget;
        var value = 'N';
        if(field.value().length != 0) {
            field.validations = { required: true };
            value = 'N';
        }
        else {
            field.validations = {};
            value = 'Y';
        }
        fields.forEach(function(fieldName) {
            widget.currentRow[fieldName] = value;  
        });
    };
    
    this.confirmarReplicacao = function(widget) {
        ScreenService.confirmMessage("Atenção! Todos os dados já existentes nas inscrições estaduais de destino serão perdidos. Confirma a operação?", 
        "warning", function(){
            General.callRestEngine("cadFis#/replicaAutorizacao", "Row", widget.currentRow).then(function() {
                 self.closeReplicacao(widget);
                 ScreenService.successNotification("Replicação realizada com sucesso.");
            });
        }, null);
    };
    
    this.reloadWidgetInscricaoEstadualEmpresa = function(widget) {
        widget.widgets[1].reload();  
    };
    
    this.activateShortCutKey = function(widget){
        var widgetGeral = templateManager.container.getWidget('autorizacao_geral');
        var widgetInscr = templateManager.container.getWidget('inscricao_estadual');
        
        if(widget.name == widgetGeral.name){
            widgetGeral.activate();
            widgetGeral.reload();
        }else{
            widgetInscr.activate();
            widgetInscr.reload();
        }
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Dfs87000_Autorizacao_Obter_Xml', Dfs87000_Autorizacao_Obter_Xml);
});

// FILE: ./assets/js/controllers/Fis03600_Pauta_Minima_Base_Calculo_Produtos_Controller.js
function Fis03600_Pauta_Minima_Base_Calculo_Produtos_Controller(General, ScreenService, templateManager) {
    
    this.fieldOnChangeEmpresa = function() {
        var widget = templateManager.container.getWidget('pauta_minima_base_calculo_produtos');
        var dadosWidget = templateManager.container.getWidget('pauta_minima_base_calculo_produtos_grid');
        
        widget.getField('CDINSCESTA').clearValue();
        widget.getField('IDENTRSAID').clearValue();
        widget.getField('CDTIPOOPER').clearValue();
        widget.getField('NMTIPOOPER').clearValue();
        widget.getField('CDPAIS').clearValue();
        widget.getField('NMPAIS').clearValue();
        widget.getField('SGESTADO').clearValue();
        widget.getField('NMESTADO').clearValue();
        
        if(!widget.getField('NMEMPRESA').value()) {
            widget.getField('CDINSCESTA').readOnly = true;  
            dadosWidget.isVisible = false;
            dadosWidget.deactivate();
            dadosWidget.actions.forEach(function(action){
                action.isVisible = false;
            });
            dadosWidget.reload();
        } else {
            widget.getField('CDINSCESTA').readOnly = false;
        }
        
        var field = widget.getField('CDINSCESTA');
        field.reload();
    };
    
    this.fieldOnChangeInscEst = function() {
        var widget = templateManager.container.getWidget('pauta_minima_base_calculo_produtos');
        var dadosWidget = templateManager.container.getWidget('pauta_minima_base_calculo_produtos_grid');
        
        widget.getField('IDENTRSAID').clearValue();
        widget.getField('CDTIPOOPER').clearValue();
        widget.getField('NMTIPOOPER').clearValue();
        widget.getField('CDPAIS').clearValue();
        widget.getField('NMPAIS').clearValue();
        widget.getField('SGESTADO').clearValue();
        widget.getField('NMESTADO').clearValue();
        
        if(!widget.getField('CDINSCESTA').value()) {
            widget.getField('NMTIPOOPER').readOnly = true;
            widget.getField('IDENTRSAID').readOnly = true;
            dadosWidget.isVisible = false;
            dadosWidget.deactivate();
            dadosWidget.actions.forEach(function(action){
                action.isVisible = false;
            });
            dadosWidget.reload();
        } else {
            widget.getField('IDENTRSAID').readOnly = false;
            widget.getField('NMTIPOOPER').readOnly = false;
        }
        
        widget.getField('IDENTRSAID').reload();
        widget.getField('NMTIPOOPER').reload();
    };
    
    this.fieldOnChangeEntrSaid = function() {
        var widget = templateManager.container.getWidget('pauta_minima_base_calculo_produtos');
        var dadosWidget = templateManager.container.getWidget('pauta_minima_base_calculo_produtos_grid');
        
        widget.getField('CDTIPOOPER').clearValue();
        widget.getField('NMTIPOOPER').clearValue();
        widget.getField('CDPAIS').clearValue();
        widget.getField('NMPAIS').clearValue();
        widget.getField('SGESTADO').clearValue();
        widget.getField('NMESTADO').clearValue();
        
        widget.getField('NMPAIS').readOnly = true;
        widget.getField('NMESTADO').readOnly = true;
        
        widget.getField('IDENTRSAID').reload();
        widget.getField('NMTIPOOPER').reload();
        widget.getField('NMPAIS').reload();
        widget.getField('NMESTADO').reload();
        
        dadosWidget.isVisible = false;
        dadosWidget.deactivate();
        dadosWidget.actions.forEach(function(action){
            action.isVisible = false;
        });
        dadosWidget.reload();
    };
    
    this.fieldOnChangeTipoOper = function() {
        var widget = templateManager.container.getWidget('pauta_minima_base_calculo_produtos');
        var dadosWidget = templateManager.container.getWidget('pauta_minima_base_calculo_produtos_grid');
        
        widget.getField('CDPAIS').clearValue();
        widget.getField('NMPAIS').clearValue();
        widget.getField('SGESTADO').clearValue();
        widget.getField('NMESTADO').clearValue();
        
        if(!widget.getField('NMTIPOOPER').value()) {
            widget.getField('NMPAIS').readOnly = true;
            dadosWidget.isVisible = false;
            dadosWidget.deactivate();
            dadosWidget.actions.forEach(function(action){
                action.isVisible = false;
            });
            dadosWidget.reload();
        } else {
            widget.getField('NMPAIS').readOnly = false;
        }
        
        var field = widget.getField('NMPAIS');
        field.reload();
    };
    
    this.fieldOnChangePais = function() {
        var widget = templateManager.container.getWidget('pauta_minima_base_calculo_produtos');
        var dadosWidget = templateManager.container.getWidget('pauta_minima_base_calculo_produtos_grid');
        
        widget.getField('SGESTADO').clearValue();
        widget.getField('NMESTADO').clearValue();
        
        if(!widget.getField('NMPAIS').value()) {
            widget.getField('NMESTADO').readOnly = true;
            dadosWidget.isVisible = false;
            dadosWidget.deactivate();
            dadosWidget.actions.forEach(function(action){
                action.isVisible = false;
            });
            dadosWidget.reload();
        } else {
            widget.getField('NMESTADO').readOnly = false;
        }
        
        var field = widget.getField('NMESTADO');
        field.reload();
    };
    
    this.fieldOnChangeEstado = function() {
        var widget = templateManager.container.getWidget('pauta_minima_base_calculo_produtos');
        var dadosWidget = templateManager.container.getWidget('pauta_minima_base_calculo_produtos_grid');
        if(!widget.getField('NMESTADO').value()){
            dadosWidget.isVisible = false;
            dadosWidget.deactivate();
            dadosWidget.actions.forEach(function(action){
                action.isVisible = false;
            });
            dadosWidget.reload();
        } else {
            dadosWidget.isVisible = true;
            dadosWidget.activate();
            dadosWidget.actions.forEach(function(action){
                action.isVisible = true;
            });
            dadosWidget.reload();
        }
    };
    
    this.newRowPauta = function(widget){
        widget.newRow();
        
        widget.currentRow.CDEMPRESA = widget.getParent().currentRow.CDEMPRESA; 
        widget.currentRow.CDINSCESTA = widget.getParent().currentRow.CDINSCESTA; 
        widget.currentRow.IDENTRSAIDOP = widget.getParent().currentRow.IDENTRSAID; 
        widget.currentRow.CDTIPOOPER = widget.getParent().currentRow.CDTIPOOPER; 
        widget.currentRow.CDPAIS = widget.getParent().currentRow.CDPAIS; 
        widget.currentRow.SGESTADO = widget.getParent().currentRow.SGESTADO; 
    };
    
}
Configuration(function (ContextRegister) {
    ContextRegister.register('Fis03600_Pauta_Minima_Base_Calculo_Produtos_Controller', Fis03600_Pauta_Minima_Base_Calculo_Produtos_Controller);
});

// FILE: ./assets/js/controllers/Fis04100_Cnae_Fiscal_Controller.js
function Fis04100_Cnae_Fiscal_Controller(General, ScreenService, templateManager) {
    
    this.salvarCnae = function(widget) {
        var cdcnae = widget.currentRow.CDCNAE;
        widget.currentRow.CDCNAE = cdcnae.replace(/[-/]+/g, '');
        General.saveCrud(widget);
    };
    

}
Configuration(function(ContextRegister) {
    ContextRegister.register('Fis04100_Cnae_Fiscal_Controller', Fis04100_Cnae_Fiscal_Controller);
});

// FILE: ./assets/js/controllers/Fis29000_Agrupamento_Inscesta_Controller.js
var Fis29000_Agrupamento_Inscesta_Controller = function(ScreenService, templateManager, General){
	/**
	 * Função para a chamada da Action Salvar.
	 */
	var self = this;
	 
	self.adicionarInscricaEstadual = function(widget){
        //var widgetInscEsta = templateManager.container.getWidget('titulos_por_empresa');
        widget.getField('CDINSCESTA').template = 'field/select-multiple.html';
        templateManager.updateTemplate();
        widget.newRow();
         
    };
    
    self.salvarInscricaEstadual = function(){
        var widgetAgrupamento = templateManager.container.getWidget('grid_agrupamento');
        var widgetInscEsta = templateManager.container.getWidget('grid_inscricao_estadual');
        widgetInscEsta.currentRow.CDGRUPINSCESTA = widgetAgrupamento.currentRow.CDGRUPINSCESTA;
        widgetInscEsta.currentRow.NRORG = getLocalVar('NRORG');
        widgetInscEsta.currentRow.CDOPERADOR = getLocalVar('CDOPERADOR');
        widgetInscEsta.currentRow.DATA = moment().format('DD/MM/YYYY');
        General.callRestEngine('cadFis#/saveAgrupInscEsta','Row', widgetInscEsta.currentRow).then(
           function(success){
                widgetInscEsta.list();
                widgetInscEsta.getField('CDINSCESTA').template = 'field/text-edit.html';
                widgetInscEsta.reload();
               
           }, function(error){
               ScreenService.showMessage(error.dataset.error);
           });
    };
    
};

Configuration(function (ContextRegister){
    ContextRegister.register('Fis29000_Agrupamento_Inscesta_Controller', Fis29000_Agrupamento_Inscesta_Controller);
});

// FILE: ./assets/js/controllers/Fis94500_formula_ajuste_fiscal_Controller.js
var Fis94500_formula_ajuste_fiscal_Controller = function (ScreenService, General, templateManager){

	var self = this;
    /*
    status possiveis V de vazio, N de numero, A abre parentesi, F fecha parentesi, O de operação
    */
    this.state = 'V';
    //uma pilha de parentesis
	this.parentesis = [];
	/*só listanto
	this.fieldsToControl =["TECNUM", "SELECTVALOR", "APAGA", "MAIS", "MENOS", "MULTIP", "DIVISAO", "ABREP", "FECHAP"];
	*/
	this.setState = function(widget, state = 'V'){
        this.state = state;
        this.updateState(widget);
    };

	this.updateState = function(widget){
        this.setBackspace(widget);
		switch(this.state){
			case 'N':
            case 'F':
                this.setNumbers(widget, true);
                this.setOperacoes(widget, false);
                widget.getField('ABREP').readOnly = true;
                this.setFecha(widget, true);
                break;
			default:
			case 'V':
            case 'O':
            case 'A':
				this.setNumbers(widget, false);
                this.setOperacoes(widget, true);
                widget.getField('ABREP').readOnly = this.state == 'A';
                this.setFecha(widget, false);
        }
        templateManager.updateTemplate();
	};
    
    this.setBackspace = function(widget){
        widget.getField('APAGA').readOnly = this.state == 'V';
    };

    this.setFecha = function(widget, value){
        widget.getField('FECHAP').readOnly = !(this.parentesis.length && value);
    };

    this.setOperacoes = function(widget, value){
        widget.getField('MAIS').readOnly    = value;
        widget.getField('MENOS').readOnly   = value;
        widget.getField('MULTIP').readOnly  = value;
        widget.getField('DIVISAO').readOnly = value;
    };

       
    this.setNumbers = function(widget, value){
        widget.getField('TECNUM').readOnly = value;
        widget.getField('SELECTVALOR').readOnly = value;
    };
	
	
	this.operacaoOnClick = function(field){
        field.widget.currentRow.DSFORMULA += field.label;
        this.setState(field.widget, 'O');
	};
	
	this.apagaOnClick = function(field){
	    //talvez seja um parentesis
	    let tempLastChar = field.widget.currentRow.DSFORMULA.slice(-1);
	    if(tempLastChar == ')'){
	        this.parentesis.push(true);
	    }
	    if(tempLastChar == '('){
	        this.parentesis.pop();
	    }
	    
	    //apaga
        field.widget.currentRow.DSFORMULA = field.widget.currentRow.DSFORMULA.slice(0, -1);
        //carrega estado anterior 
        this.changeState(field.widget, field.widget.currentRow.DSFORMULA.slice(-1));
	};
	
	this.changeState = function(widget, lastValue){
	    let numbers = ['I','B','C','0','1','2','3','4','5','6','7','8','9', ',', '.'];
	    let operations = ['*','/','+','-'];
            if(lastValue == '('){
                this.setState(widget, 'A');
            }else if(lastValue == ')'){
                this.setState(widget, 'F');
            }else if(numbers.indexOf(lastValue) > -1){
                this.setState(widget, 'N');
            }else if(operations.indexOf(lastValue) > -1){
                this.setState(widget, 'O');
            }else if(lastValue == ''){
                this.setState(widget, 'V');
            }
    };
	
		
	this.abreOnClick = function(field){
        field.widget.currentRow.DSFORMULA += field.label;
        this.parentesis.push(true);
        this.setState(field.widget, 'A');
	};
	
	this.fechaOnClick = function(field){
        field.widget.currentRow.DSFORMULA += field.label;
        this.parentesis.pop();
        this.setState(field.widget, 'F');
	};
	
	this.selectOnChange = function(field){
	    if(field.value()){
	        field.widget.currentRow.DSFORMULA += field.value();
	        field.setValue('');
	        this.setState(field.widget, 'N');
	    }
	};
	this.tecladoOnChange = function(field){
        if(field.value()){
	        field.widget.currentRow.DSFORMULA += field.value();
	        field.setValue('');
	        this.setState(field.widget, 'N');
	    }
	};
	
	this.editWidget = function(widget){
        this.changeState(widget, widget.currentRow.DSFORMULA.slice(-1));
        General.edit(widget);
        widget.getField('CDFORMULA').readOnly = true;
	};
	
	this.saveWidget = function(widget){
        try {
            //checa se ta funcionando
            var resultado = eval(widget.currentRow.DSFORMULA.replace("C", '1').replace('I', '1').replace('B','1'));
            if (!Number.isFinite(resultado)){
                 throw "O resultado foi infinito."; // gera uma exceção
            }
            if (Number.isNaN(resultado)){
                 throw "O resultado não foi um numero."; // gera uma exceção
            }
            General.saveCrud(widget);   
        }
        catch (e) {
           // declarações para manipular quaisquer exceções
           ScreenService.showMessage("Ocorreu um erro ao tentar executar a formula :"+e); // passa o objeto de exceção para o manipulador de erro
        }
	};
	
	function checkIfInView(element){
        var offset = element.offset().top - $(window).scrollTop();
    
        if(offset > window.innerHeight){
            // Not in view so scroll to it
            $('html,body').animate({scrollTop: offset}, 1000);
            return false;
        }
       return true;
    }
	
};
Configuration(function (ContextRegister) {
	ContextRegister.register('Fis94500_formula_ajuste_fiscal_Controller', Fis94500_formula_ajuste_fiscal_Controller);
});

// FILE: ./assets/js/controllers/Ger00000CadastramentosAutomaticoController.js
function Ger00000_Cadastramentos_Automatico_Controller(ScreenService, metaDataFactory, General, ZHPromise, templateManager, ZhFilterPreferences, restEngine, localStorageEngine, MessageService, Ger00000CadastramentosAutomaticoService, Endereco, UtilCadFis) {

    var self = this;
    var campos = [];
    var fields;

    var erros = [];

    const ServiceImportacao = Ger00000CadastramentosAutomaticoService;

    var glossary = {

        //Tabela Fornecedor
        'IDTPIJURFORN': {
            'desc': 'Utilizado para identificar o tipo do fornecedor.\nJ – Jurídico;\nF- Físico;\nI – Internacional;\nO – Outros;',
            'template': 'field/textarea.html',
            'textRows': 5

        },
        'NRINSJURFORN': {
            'desc': 'Informar o CNPJ do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NRINSESTFORN': {
            'desc': 'Informar a inscrição estadual do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NMRAZSOCFORN': {
            'desc': 'Informar a razão social do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NMFANTFORN': {
            'desc': 'Informar o nome fantasia do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'IDENDEMISFOR': {
            'desc': 'Informar o endereço para emissão, neste campo as informações são pré-definidas.\nP - Endereço do Fornecedor;\nC - Endereço de Cobrança;\nE - Endereço do Exterior;\nX - Endereço de Exportação;\nT - Endereço de Entrega;\nI - Endereço da Inscrição Estadual;',
            'template': 'field/textarea.html',
            'textRows': 6

        },
        'IDENDCFOPFOR': {
            'desc': 'Informar o endereço para o CFOP, neste campo as informações são pré-definidas.\nP - Endereço do Fornecedor;\nC - Endereço de Cobrança;\nE - Endereço do Entrega;', /*Exterior;\nX - Endereço de Exportação;\nT - Endereço de Entrega;\nI - Endereço da Inscrição Estadual;',*/
            'template': 'field/textarea.html',
            'textRows': 4

        },
        'IDPRIPUBFORN': {
            'desc': 'Informar se o fornecedor é público ou privado.\nV – Privado;\nB – Público;',
            'template': 'field/textarea.html',
            'textRows': 3

        }, //PRINCIPAL
        'IDTPENDEFORN': {
            'desc': 'Informar o valor "P" para cadastrar o endereço principal.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'CDPAIS': {
            'desc': 'Informar o pais do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'SGESTADO': {
            'desc': 'Informar o estado do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'CDMUNICIPIO': {
            'desc': 'Informar o código do município do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NMMUNICIPIO': {
            'desc': 'Informar o nome do município do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSENDEFORN': {
            'desc': 'Informar a descrição do endereço do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSCOMPENDFOR': {
            'desc': 'Informar o descrição do complemento do endereço do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NMBAIRFORN': {
            'desc': 'Informar o nome do bairro do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NRCEPFORN': {
            'desc': 'Informar o CEP do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSEMAILFORN': {
            'desc': 'Informar o nome do bairro do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSEMAILFORNNFE': {
            'desc': 'Informar o email do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NRCELULARFOR': {
            'desc': 'Informar o telefone celular do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NRTELRESIFOR': {
            'desc': 'Informar o telefone fixo do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        }, //COBRANÇA
        'IDTPENDEFORNCOBR': {
            'desc': 'Informar o valor "C" para cadastrar o endereço de cobrança do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'CDPAISCOBR': {
            'desc': 'Informar o pais de cobrança do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'SGESTADOCOBR': {
            'desc': 'Informar o estado (sigla) de cobrança do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'CDMUNICIPIOCOBR': {
            'desc': 'Informar o município de cobrança do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NMMUNICIPIOCOBR': {
            'desc': 'Informar o nome do município de cobrança do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSENDEFORNCOBR': {
            'desc': 'Informar o endereço de cobrança do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSCOMPENDFORCOBR': {
            'desc': 'Informar o complemento do endereço de cobrança do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NMBAIRFORNCOBR': {
            'desc': 'Informar o bairro de cobrança do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NRCEPFORNCOBR': {
            'desc': 'Informar o CEP de cobrança do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSEMAILFORNCOBR': {
            'desc': 'Informar o email de cobrança do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSEMAILFORNNFECOBR': {
            'desc': 'Informar o email XML NF-e de cobrança do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NRCELULARFORCOBR': {
            'desc': 'Informar o telefone celular de cobrança do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NRTELRESIFORCOBR': {
            'desc': 'Informar o telefone fixo de cobrança do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        }, //ENTREGA
        'IDTPENDEFORNENTR': {
            'desc': 'Informar o valor "E" para cadastrar o endereço de entrega do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'CDPAISENTR': {
            'desc': 'Informar o pais de entrega do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'SGESTADOENTR': {
            'desc': 'Informar o estado de entrega do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'CDMUNICIPIOENTR': {
            'desc': 'Informar o código do município de entrega do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NMMUNICIPIOENTR': {
            'desc': 'Informar o nome do município de entrega do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSENDEFORNENTR': {
            'desc': 'Informar o endereço de entrega do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSCOMPENDFORENTR': {
            'desc': 'Informar o complemento do endereço de entrega do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NMBAIRFORNENTR': {
            'desc': 'Informar o bairro de entrega do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NRCEPFORNENTR': {
            'desc': 'Informar o CEP de entrega do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSEMAILFORNENTR': {
            'desc': 'Informar o email de entrega do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSEMAILFORNNFEENTR': {
            'desc': 'Informar o email XML NF-e de entrega do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NRCELULARFORENTR': {
            'desc': 'Informar o telefone celular de entrega do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NRTELRESIFORENTR': {
            'desc': 'Informar o telefone fixo de entrega do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },

        //Tabela Conta Contabil
        'CDCONTCTBL': {
            'desc': 'Código da Conta Contábil até 20 dígitos.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'CDCONTREDU': {
            'desc': 'Código da Conta reduzido até 20 dígitos.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NMCONTCTBL': {
            'desc': 'Nome.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'CDNVCONTCTBL': {
            'desc': 'Nível da Conta.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'CDCONTANTE': {
            'desc': 'Código da Conta Anterior.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'IDTIPOCONT': {
            'desc': 'A - Analitico;\nS - Sintetico;',
            'template': 'field/textarea.html',
            'textRows': 2

        },
        'IDNATUCONT': {
            'desc': 'Identificador Natureza Conta.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'IDPADRREL': {
            'desc': 'Padrão de Relatório.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'IDGRUPOCONTA': {
            'desc': 'Identificado de Grupo de Conta.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'IDCONTCCUS': {
            'desc': 'O - Oficilal;\nR - Gerencial;\nG - Oficial/Gerencial;',
            'template': 'field/textarea.html',
            'textRows': 3

        },
        'CDCONTPLANREFE': {
            'desc': 'Conta Referencial Lucro Real.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'CDCONTREFEPRE': {
            'desc': 'Conta Referencial Lucro Presumido.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'CDCONTREFEIMUISEN': {
            'desc': 'Informar o telefone fixo de entrega do fornecedor.',
            'template': 'field/textarea.html',
            'textRows': 1

        },

        //Tabela Centro Custo
        'CDCENTCUST': {
            'desc': 'Código do Centro de Custo.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NMCENTCUST': {
            'desc': 'Nome do do Centro de Custo.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'CDFILIAL': {
            'desc': 'Código da Filial.\nPassando como parâmetro apenas a letra T, indica para adicionar todas as filiais.\nPara adicionar as filiais manualmente basta digitar o seu código e separa-las por ;',
            'template': 'field/textarea.html',
            'textRows': 3

        },

        //Tabela Tipo Recebimento
        'CDTIPORECE': {
            'desc': 'Código do Tipo de Recebimento.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NMTIPORECE': {
            'desc': 'Nome do Tipo de Recebimento.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'VRTAXAADMI': {
            'desc': 'Valor da Taxa Administrativa.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NRDIASADMI': {
            'desc': 'Numero de dias para receber a Taxa Administrativa.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'CDTPCTRECEB': {
            'desc': 'Código do Tipo de Conta do Recebimento.',
            'template': 'field/textarea.html',
            'textRows': 1

        },

        //Transportadora
        'NRINSJURTRAN': {
            'desc': 'Número da Inscrição Jurídica.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NMRAZSOCTRAN': {
            'desc': 'Razão Social',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'IDTPIJURTRAN': {
            'desc': 'Tipo de Inscrição Jurídica.\nSendo "J" para Jurídica e "F" para Física.',
            'template': 'field/textarea.html',
            'textRows': 2

        },
        'NMFANTTRAN': {
            'desc': 'Nome Fantasia.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NRINSESTTRAN': {
            'desc': 'Inscrição Estadual.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSENDETRAN': {
            'desc': 'Endereço.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NMBAIRTRAN': {
            'desc': 'Bairro.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NRCEPTRAN': {
            'desc': 'CEP.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'IDCOMPARQXMLTRA': {
            'desc': 'Informar se o arquivo será compactado ao enviar e-mail da NF-e;\n"S" e "N" para Compactar ou Não Compactar',
            'template': 'field/textarea.html',
            'textRows': 2

        },

        //Tipo de Títulos a Receber
        'CDCLASSFINA': {
            'desc': 'Código da Classificação Financeira.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSTPCTRECEB': {
            'desc': 'Descrição do Tipo de Conta.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'IDCTBLCTREC': {
            'desc': 'Identificador de Contabilização da Conta;\nS - Sim;\nN - Não;',
            'template': 'field/textarea.html',
            'textRows': 3

        },
        'DSDEFACTREC': {
            'desc': 'Descrição Padrão da Conta.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'CDHISTPADR': {
            'desc': 'Campo utilizado para informar o código do histório padrão.\nÉ obrigatória a informação, suporta até 4 dígitos e não é alfanumérico.',
            'template': 'field/textarea.html',
            'textRows': 2

        },
        'CDCONTCTBLCNC': {
            'desc': 'Código da Conta Contábil Conciliador.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'IDTPCTRECEBER': {
            'desc': 'Identificador do Tipo de Conta;\n1 - Normal;\n2 - Adiantamento;',
            'template': 'field/textarea.html',
            'textRows': 3

        },

        //Tipo de Títulos a Pagar
        'CDTPCTPAGAR': {
            'desc': 'Código do Tipo de Conta.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSTPCTPAGAR': {
            'desc': 'Descrição do Tipo de Conta.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'IDCTBLCTPAG': {
            'desc': 'Identificador de Contabilização da Conta;\nS - Sim;\nN - Não;',
            'template': 'field/textarea.html',
            'textRows': 3

        },
        'DSDEFACTPAG': {
            'desc': 'Descrição Padrão da Conta.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'IDTPCTPAGAR': {
            'desc': 'Identificador do Tipo de Conta;\n1 - Normal;\n2 - Adiantamento;\n3 - Empréstimo;',
            'template': 'field/textarea.html',
            'textRows': 4

        },

        //Tipo de Credito Bancario
        'CDTPCREDBANC': {
            'desc': 'Código do Tipo de Crédito Bancário.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSTPCREDBANC': {
            'desc': 'Descrição do Tipo de Crédito Bancário.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'IDCTBLCRBANC': {
            'desc': 'Identificador de Contabilização Crédito Bancário;\nS - Sim;\nN - Não;',
            'template': 'field/textarea.html',
            'textRows': 3

        },

        //Tipo de Débito Bancario
        'CDTPDEBIBANC': {
            'desc': 'Código do Tipo de Débito Bancário.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSTPDEBIBANC': {
            'desc': 'Descrição do Tipo de Débito Bancário.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'IDCTBLDBBANC': {
            'desc': 'Identificador de Contabilização Débito Bancário;\nS - Sim;\nN - Não;',
            'template': 'field/textarea.html',
            'textRows': 3

        },

        //Tipo de Ajuste Títulos a Pagar
        'CDAJUCTPAG': {
            'desc': 'Código do Tipo de Ajuste Títulos a Pagar.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSAJUCTPAG': {
            'desc': 'Descrição do Tipo de Ajuste Títulos a Pagar.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'IDAJUCTPAG': {
            'desc': 'Tratamento do Ajuste;\nA - Acrescimo;\nD - Desconto;',
            'template': 'field/textarea.html',
            'textRows': 3

        },
        'IDTPAJPAGAR': {
            'desc': 'Identificador de Tipo de Ajuste;\nN - Normal;\nD - Devolução;\nA - Adiantamento;',
            'template': 'field/textarea.html',
            'textRows': 4

        },
        'IDCTBAJCTPAG': {
            'desc': 'Identificador de Contabilização na Baixa;\nS - Sim;\nN - Não;',
            'template': 'field/textarea.html',
            'textRows': 3

        },

        //Tipo de Ajuste Títulos a Receber
        'CDAJUCTREC': {
            'desc': 'Código do Tipo de Ajuste Títulos a Receber.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSAJUCTREC': {
            'desc': 'Descrição do Tipo de Ajuste Títulos a Receber.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'IDAJUCTREC': {
            'desc': 'Tratamento do Ajuste;\nA - Acrescimo;\nD - Desconto;',
            'template': 'field/textarea.html',
            'textRows': 3

        },
        'IDTPAJRECEBER': {
            'desc': 'Identificador de Tipo de Ajuste;\nN - Normal;\nD - Devolução;\nA - Adiantamento;',
            'template': 'field/textarea.html',
            'textRows': 4

        },
        'IDCTBAJCTREC': {
            'desc': 'Identificador de Contabilização na Baixa;\nS - Sim;\nN - Não;',
            'template': 'field/textarea.html',
            'textRows': 3

        },

        //Histórico Padrão
        'DSHISTPADR': {
            'desc': 'Campo utilizado para informar a descrição do histório padrão.\nÉ obrigatória a informação, suporta até 60 caracteres.',
            'template': 'field/textarea.html',
            'textRows': 2

        },

        //Motivo de Parcelamento
        'CDMOTIPARC': {
            'desc': 'Campo utilizado para informar o código do motivo de parcelamento.\nÉ obrigatória a informação, suporta até 2 dígitos e não é alfanumérico.',
            'template': 'field/textarea.html',
            'textRows': 2

        },
        'DSMOTIPARC': {
            'desc': 'Campo utilizado para informar a descrição do motivo de parcelamento.\nÉ obrigatória a informação, suporta até 40 caracteres.',
            'template': 'field/textarea.html',
            'textRows': 2

        },

        //Motivo de Prorrogação
        'CDMOTIPROR': {
            'desc': 'Campo utilizado para informar o código do motivo de prorrogação.\nÉ obrigatória a informação, suporta até 2 dígitos e não é alfanumérico.',
            'template': 'field/textarea.html',
            'textRows': 2

        },
        'DSMOTIPROR': {
            'desc': 'Campo utilizado para informar a descrição do motivo de prorrogação.\nÉ obrigatória a informação, suporta até 40 caracteres.',
            'template': 'field/textarea.html',
            'textRows': 2

        },
        //Produto
        'CDARVPROD': {
            'desc': 'Código da árvore do produto (código do produto visualizado na tela)',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'CDNVPRODUTO': {
            'desc': 'Código do nível do produto na árvore. Nível ao qual o produto será incluído.\n Exemplo: 4 (quarto nível)',
            'template': 'field/textarea.html',
            'textRows': 2
        },
        'CDPRODESTO': {
            'desc': 'Código da árvore do produto de estoque associado ao produto',
            'template': 'field/textarea.html',
            'textRows': 1
        },
        'NMPRODUTO': {
            'desc': 'Nome do produto',
            'template': 'field/textarea.html',
            'textRows': 1
        },
        'SGUNIDADE': {
            'desc': 'Sigla da unidade de medida do produto',
            'template': 'field/textarea.html',
            'textRows': 1
        },
        'VRARREDCMP': {
            'desc': 'Valor referente ao arredondamento de compras',
            'template': 'field/textarea.html',
            'textRows': 1
        },
        'VRARREDREQ': {
            'desc': 'Valor referente ao arredondamento de requisição',
            'template': 'field/textarea.html',
            'textRows': 1
        },
        'VRARREDEMPPR': {
            'desc': 'Valor referente ao arredondamento de empenho',
            'template': 'field/textarea.html',
            'textRows': 1
        },
        'VRFATOCONV': {
            'desc': 'Fator de conversão do produto (quantidade por embalagem conforme produto de estoque associado)',
            'template': 'field/textarea.html',
            'textRows': 1
        },
        'VRPEFATOCORR': {
            'desc': 'Fator de correção do produto',
            'template': 'field/textarea.html',
            'textRows': 1
        },
        'VRPESOUNID': {
            'desc': 'Valor do peso do produto',
            'template': 'field/textarea.html',
            'textRows': 1
        },
        'CDBARPRODUTO': {
            'desc': 'Código de barras do produto',
            'template': 'field/textarea.html',
            'textRows': 1
        },
        'CDCLASFISC': {
            'desc': 'Classificação fiscal do produto (NCM)',
            'template': 'field/textarea.html',
            'textRows': 1
        },
        'CDCEST': {
            'desc': 'Código CEST associado ao produto)',
            'template': 'field/textarea.html',
            'textRows': 1
        },
        'IDPRODESTO': {
            'desc': 'Identificador de produtos de estoque \n(S - Produto de Estoque /  N ou Sem Valor - Produto de Compra)',
            'template': 'field/textarea.html',
            'textRows': 2
        },
        //Cliente
        'IDTPIJURCLIE': {
            'desc': 'Utilizado para identificar o código do cliente\nF - Pessoa Física (CPF)\nI - Insc. Jurídica\nJ - Pessoa Júridica (CNPJ)\nO - Outros',
            'template': 'field/textarea.html',
            'textRows': 5

        },
        'NRINSJURCLIE': {
            'desc': 'Informar o código de identificação do cliente (CPF,CNPJ, etc)',
            'template': 'field/textarea.html',
            'textRows': 1
        },
        //Produto
        'NRINSESTCLIE': {
            'desc': 'Informar a inscrição estadual do cliente',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NMRAZSOCCLIE': {
            'desc': 'Informar a razão social do cliente',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NMFANTCLIE': {
            'desc': 'Informar o nome fantasia do cliente',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'IDENDEMISCLI': {
            'desc': 'Identificador do tipo de endereço utilizado na emissão de documentos\nP - Principal\nC - Cobrança\nE - Exterior\nX - Exportação\nT - Entrega',
            'template': 'field/textarea.html',
            'textRows': 6

        },
        'IDENDCFOPCLI': {
            'desc': 'Identificador do tipo de endereço considerado na geração do CFOP \nP - Principal\nC - Cobrança\nE - Exterior\nX - Exportação\nT - Entrega',
            'template': 'field/textarea.html',
            'textRows': 6

        },
        'IDCLIEATIV': {
            'desc': 'Identificador de cliente ativo\nS - Sim\nN - Não',
            'template': 'field/textarea.html',
            'textRows': 3

        },
        'IDPRIPUBCLIE': {
            'desc': 'Identificador do tipo do cliente\nV - Privado\nB - Público',
            'template': 'field/textarea.html',
            'textRows': 3

        },
        'IDVERSALDCLI': {
            'desc': 'Identificador de verificação do saldo do cliente\nS - Sim\nN - Não',
            'template': 'field/textarea.html',
            'textRows': 3

        },
        'IDUTSALDCLI': {
            'desc': 'Identificador de utilização do saldo do cliente pelo consumidor\nS - Sim\nN - Não',
            'template': 'field/textarea.html',
            'textRows': 3

        },
        'IDCALCDVCLIE': {
            'desc': 'Indentificador de cálculo do dígito verificador do crachá\n1 - Não calcula\n2 - Calcula - módulo 11\n3 - Buscar de dll',
            'template': 'field/textarea.html',
            'textRows': 4

        },
        'IDUTSUBCLIEN': {
            'desc': 'Identificador de utilização de subsídio\nS - Sim\nN - Não',
            'template': 'field/textarea.html',
            'textRows': 3

        },
        'IDTPENDECLIE': {
            'desc': 'Informar o valor "P" para cadastrar o endereço principal (O cadastro do endereço principal é obrigatório.)',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSENDECLIE': {
            'desc': 'Informar a descrição do endereço do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSCOMPENDCLI': {
            'desc': 'Informar o descrição do complemento do endereço do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NMBAIRCLIE': {
            'desc': 'Informar o nome do bairro do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NRCEPCLIE': {
            'desc': 'Informar o CEP do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSEMAILCLIE': {
            'desc': 'Informar o email do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSEMAILCLIENFE': {
            'desc': 'Informar o email para XML NF-e do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NRCELULARCLI': {
            'desc': 'Informar o telefone celular do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'IDTPENDECLIECOBR': {
            'desc': 'Informar o valor "C" para cadastrar o endereço de cobrança (O cadastro de um endereço de cobrança é opcional.)',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSENDECLIECOBR': {
            'desc': 'Informar a descrição do endereço de cobrança do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSCOMPENDCLICOBR': {
            'desc': 'Informar o descrição do complemento do endereço de cobrança do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NMBAIRCLIECOBR': {
            'desc': 'Informar o nome do bairro de cobrança do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NRCEPCLIECOBR': {
            'desc': 'Informar o CEP de cobrança do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSEMAILCLIECOBR': {
            'desc': 'Informar o email de cobrança do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NRCELULARCLICOBR': {
            'desc': 'Informar o telefone celular de cobrança do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NRTELRESICLICOBR': {
            'desc': 'Informar o telefone de cobrança',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'IDTPENDECLIEENTR': {
            'desc': 'Informar o valor "T" para cadastrar o endereço de entrega do cliente (O cadastro de um endereço de entrega é opcional.)',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSENDECLIEENTR': {
            'desc': 'Informar a descrição do endereço de entregas do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSCOMPENDCLIENTR': {
            'desc': 'Informar o descrição do complemento do endereço de entregas do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NMBAIRCLIEENTR': {
            'desc': 'Informar o nome do bairro de entregas do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NRCEPCLIEENTR': {
            'desc': 'Informar o CEP de entregas do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSEMAILCLIEENTR': {
            'desc': 'Informar o email de entregas do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NRCELULARCLIENTR': {
            'desc': 'Informar o telefone celular de entregas do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NRTELRESICLIENTR': {
            'desc': 'Informar o telefone de entregas do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'NRTELRESICLI': {
            'desc': 'Informar o telefone do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1

        },
        'DSEMAILCLIENFEENTR': {
            'desc': 'Informar o email para XML NF-e de entrega do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1
        },
        'DSEMAILCLIENFECOBR': {
            'desc': 'Informar o email para XML NF-e de cobrança do cliente.',
            'template': 'field/textarea.html',
            'textRows': 1
		},
        'CDJUSTEXCHIS': {
            'desc': 'Código da justificativa de exclusão de histórico.',
            'template': 'field/textarea.html',
            'textRows': 1
        },
        'DSJUSTEXCHIS': {
            'desc': 'Descrição da justificativa de exclusão de histórico.',
            'template': 'field/textarea.html',
            'textRows': 1
        },
        // META DE VENDA POR VENDEDOR 
        
         'CDVENDEDOR': {
            'desc': 'Corresponde ao código do vendedor. Campo obrigatório de 4 dígitos.',
            'template': 'field/textarea.html',
            'textRows': 1
        },
         'CDMETAVENDA': {
            'desc': 'Corresponde ao código da meta do vendedor. Campo obrigatório de 3 dígitos.',
            'template': 'field/textarea.html',
            'textRows': 1
        },
         'DTINIMETVEND': {
            'desc': 'Corresponde a Data inicial da meta. Campo de data obrigatório no formato DD/MM/YYYY.',
            'template': 'field/textarea.html',
            'textRows': 1
        },
         'DTFINMETAVEND': {
            'desc': 'Corresponde a Data final da meta. Campo de data obrigatório no formato DD/MM/YYYY.',
            'template': 'field/textarea.html',
            'textRows': 1
        },
         'QTMETAVENDA': {
            'desc': 'Corresponde ao objetivo da meta referente a quantidade. Campo não obrigatório numérico de até 3 casas decimais.',
            'template': 'field/textarea.html',
            'textRows': 1
        },
         'VRMETAVENDA': {
            'desc': 'Corresponde ao objetivo da meta referente ao valor. Campo não obrigatório numérico de até 2 casas decimais.',
            'template': 'field/textarea.html',
            'textRows': 1
        },
        
        // Tabela de Preco
        
        
         'CDPRECOBASE': {
            'desc': 'Código da tabela de Preço base.',
            'template': 'field/textarea.html',
            'textRows': 1
         },
         'DSPRECOBASE': {
            'desc': 'Deacrição da tabela de Preço base.',
            'template': 'field/textarea.html',
            'textRows': 1
         },
         'VRITEPREBASE': {
            'desc': 'Valor Item tabela de Preço base.',
            'template': 'field/textarea.html',
            'textRows': 1
         },
         'DTINIVALIPB': {
            'desc': 'Data inicial de validade tabela de Preço base.',
            'template': 'field/textarea.html',
            'textRows': 1
         },
         'DTFIMVALIPB': {
            'desc': 'Data final de validade tabela de Preço base.',
            'template': 'field/textarea.html',
            'textRows': 1
         },
         'DTHRATZIPB': {
            'desc': 'Data/hora da atualização do item de preço base.',
            'template': 'field/textarea.html',
            'textRows': 1
         },
         'CDOPERATZIPB': {
            'desc': 'Código do Operador.',
            'template': 'field/textarea.html',
            'textRows': 1
         }


    };

    /**
     * Parte referente aos métodos de importação da planilha,
     * juntamente com a chamada das validações e carregamento
     * dos erros encontrados nos dados colocado na planilha
     */

    this.abreImportacao = function() {
        const widgetImportacao = templateManager.container.getWidget('importaXls');
        const tabbedWidget = templateManager.container.getWidget('tabbedWidget');

        if (tabbedWidget.isValid()) {
            widgetImportacao.currentRow = {};
            widgetImportacao.currentRow.__is_new = true;

            ScreenService.openPopup(widgetImportacao);
        }
    };

    self.getFields = function() {
        var widget = templateManager.container.getWidget('tabbedWidget');
        var widgetErro = templateManager.container.getWidget('widgetErros');
        var widgetCampos = templateManager.container.getWidget('widgetCampos');
        var widgetInfos = templateManager.container.getWidget('widgetInfos');
        var route;
        campos = [];
        var table_name = widget.currentRow.NMTABELA;

        widgetErro.getField('COLUMN').isVisible = false;
        widgetErro.getField('VALUE').isVisible = false;
        widgetErro.dataSource.data = [];
        widgetErro.dataSource.data.push({ 'IDREF': 0, 'DESCERROR': "Não há erros" });

        //Tecfood
        if(isTecfood(table_name)) {
            getFieldsTecfood();
            return true;
        }

        switch (table_name) {

            case 'FILIAL':
                table_name = table_name.concat('_').concat('ENDEFILI');
                route = 'cadFis#/crud/all_tab_column';
                break;

            case 'PRODUTO':
                route = 'cadFis#/crud/tab_column_produto';
                break;

            case 'TIPOCTPAGAR':
                route = 'cadFis#/crud/tab_column_tipoctpagar';
                break;

            case 'TIPOCTRECEBER':
                route = 'cadFis#/crud/tab_column_tipoctreceber';
                break;

            case 'HISTPADR':
                route = 'cadFis#/crud/tab_column_histpadr';
                break;

            case 'CLIENTE_ENDECLIE':
                route = 'cadFis#/crud/tab_column_cliente_endeclie';
                break;
			case 'PRECOBASE':
                route = 'cadFis#/crud/tab_column_precobase';
            break;

            case 'FORNECEDOR_ENDEFORN':
                route = 'cadFis#/crud/tab_column_fornecedor_endeforn';
                break;

            case 'CENTCUST_CENTCUSTFIL':
                route = 'cadFis#/crud/tab_column_centcust_centcustfil';
                break;

            case 'CONTCTBL':
                route = 'cadFis#/crud/tab_column_contctbl';
                break;

            case 'TIPORECE':
                route = 'cadFis#/crud/tab_column_tiporece';
                break;

            case 'TRANSPORT':
                route = 'cadFis#/crud/tab_column_transport';
                break;

            case 'TPCREDBANC':
                route = 'cadFis#/crud/tab_column_tpcredbanc';
                break;

            case 'TPDEBIBANC':
                route = 'cadFis#/crud/tab_column_tpdebibanc';
                break;

            case 'TIPOAJPAGAR':
                route = 'cadFis#/crud/tab_column_tipoajpagar';
                break;

            case 'TIPOAJRECEBER':
                route = 'cadFis#/crud/tab_column_tipoajreceber';
                break;
            case 'JUSTEXCHIS':
                route = 'cadFis#/crud/tab_column_justexchis';
                break; 
            case 'METAVENDEDOR':
                route = 'cadFis#/crud/tab_column_metavendedor';
                break;      

            default:
                route = 'cadFis#/crud/all_tab_column';
        }

        var filter = [{
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            },
            {
                "name": "TABLE_NAME",
                "operator": "=",
                "value": table_name
            }
        ];

        General.callRestEngine(route, 'FilterData', filter).then(function(success) {
            widgetCampos.fields = [];
            widgetInfos.fields = [];
            //EXPORTA TODAS AS COLUNAS DO SELECT DO BANCO PARA A TELA
            switch (widget.currentRow.NMTABELA) {
                case 'PRODUTO':
                    fields = success.dataset.tab_column_produto;
					fields[3] = ({COLUMN_NAME: "IDPRODESTO", DATA_TYPE: "CHAR", DATA_LENGTH: "1", DATA_DEFAULT: null, NULLABLE: "Y", ROWNUM: "4"});
                    break;

                case 'TIPOCTPAGAR':
                    fields = success.dataset.tab_column_tipoctpagar;
                    break;

                case 'TIPOCTRECEBER':
                    fields = success.dataset.tab_column_tipoctreceber;
                    break;

                case 'HISTPADR':
                    fields = success.dataset.tab_column_histpadr;
                    break;

                case 'CLIENTE_ENDECLIE':
                    fields = success.dataset.tab_column_cliente_endeclie;
                    fields.forEach(function(data) {
                        if (data.ROWNUM > 25 && data.ROWNUM < 38) {
                            data.COLUMN_NAME = data.COLUMN_NAME.concat("COBR");
                        }
                        else if (data.ROWNUM > 37 && data.ROWNUM < 55) {
                            data.COLUMN_NAME = data.COLUMN_NAME.concat("ENTR");
                        }
                    });
                    break;
                    
                case 'JUSTEXCHIS':
                    fields = success.dataset.tab_column_justexchis;
                    break;
                 case 'METAVENDEDOR':
                    fields = success.dataset.tab_column_metavendedor;
                    break;

                case 'FORNECEDOR_ENDEFORN':
                    fields = success.dataset.tab_column_fornecedor_endeforn;
                    fields.forEach(function(data) {
                        if (data.ROWNUM > 19 && data.ROWNUM < 32) {
                            data.COLUMN_NAME = data.COLUMN_NAME.concat("COBR");
                        }
                        else if (data.ROWNUM > 31 && data.ROWNUM <= 43) {
                            data.COLUMN_NAME = data.COLUMN_NAME.concat("ENTR");
                        }
                    });
                    break;

                case 'CENTCUST_CENTCUSTFIL':
                    fields = success.dataset.tab_column_centcust_centcustfil;
                    // fields.forEach(function(data){
                    //     if(data.ROWNUM>4){
                    //         data.COLUMN_NAME=data.COLUMN_NAME.concat("FIL");
                    //   }
                    // });
                    break;

                case 'CONTCTBL':
                    fields = success.dataset.tab_column_contctbl;
                    break;

                case 'TIPORECE':
                    fields = success.dataset.tab_column_tiporece;
                    break;

                case 'TRANSPORT':
                    fields = success.dataset.tab_column_transport;
                    break;

                case 'TPCREDBANC':
                    fields = success.dataset.tab_column_tpcredbanc;
                    break;

                case 'TPDEBIBANC':
                    fields = success.dataset.tab_column_tpdebibanc;
                    break;
                    
                case 'PRECOBASE':
                    fields = success.dataset.tab_column_precobase;
                    break;

                case 'TIPOAJPAGAR':
                    fields = success.dataset.tab_column_tipoajpagar;
                    break;

                case 'TIPOAJRECEBER':
                    fields = success.dataset.tab_column_tipoajreceber;
                    break;

                default:
                    fields = success.dataset.all_tab_column;
            }
            var data = {};
            var tabela;
            switch (widget.currentRow.NMTABELA) {
                case 'MOTIVOPROR':
                    tabela = 'Motivo de Prorrogação';
                    break;

                case 'MOTIVOPARC':
                    tabela = 'Motivo de Parcelamento';
                    break;

                case 'TPDEBIBANC':
                    tabela = 'Tipo de Débito Bancário';
                    break;

                case 'TPCREDBANC':
                    tabela = 'Tipo de Crédito Bancário';
                    break;

                case 'TIPOAJPAGAR':
                    tabela = 'Tipo de Ajuste Títulos a Pagar';
                    break;

                case 'TIPOAJRECEBER':
                    tabela = 'Tipo de Ajuste Títulos a Receber';
                    break;

                case 'PRODUTO':
                    tabela = 'Produto';
                    break;

                case 'TIPOCTPAGAR':
                    tabela = 'Tipo de Títulos a Pagar';
                    break;

                case 'TIPOCTRECEBER':
                    tabela = 'Tipo de Títulos a Receber';
                    break;

                case 'HISTPADR':
                    tabela = 'Histórico Padrão';
                    break;

                case 'CLIENTE_ENDECLIE':
                    tabela = 'Cliente';
                    break;
                case 'PRECOBASE':
                    tabela = 'Tabela de Preço';
                    break;
				case 'JUSTEXCHIS':
                    tabela = 'Justificativa de Exclusão de Histórico';
                    break;
               
                case 'METAVENDEDOR':
                    tabela = 'Meta de Venda do Vendedor';
                    break;

                case 'FORNECEDOR_ENDEFORN':
                    tabela = 'Fornecedor';
                    break;

                case 'CONTCTBL':
                    tabela = 'Conta Contabil';
                    break;

                case 'CENTCUST_CENTCUSTFIL':
                    tabela = 'Centro de Custo';
                    break;

                case 'TIPORECE':
                    tabela = 'Tipo de Recebimento';
                    break;

                case 'TRANSPORT':
                    tabela = 'Transportadora';
                    break;
            }

            //SELECIONA QUAIS COLUNAS IRÃO APARECER NA TELA
            fields = self.filtraCamposTabelas(table_name, fields);

            for (var i = 0; i < fields.length; i++) {
                geraFields(fields[i], widgetCampos, false, table_name);
                geraFieldsInfo(fields[i], widgetInfos, table_name);

                campos[i] = fields[i].COLUMN_NAME;
                data[fields[i].COLUMN_NAME] = '';
            }
            widgetCampos.dataSource.data = [data];
            widgetCampos.label = tabela; //exibe nome da tabela
            var banco = "cadFis#/crud/".concat(widget.currentRow.NMTABELA.toLowerCase());
            widgetCampos.dataSource.name = banco;
            widgetCampos.actions[1].isVisible = false;

            widgetCampos.activate();

            if (!widgetErro.isActive()) {
                widgetCampos.redraw(true);
                widgetInfos.redraw(true);
            }
        });

        this.checkParamAction(widgetCampos,table_name);

    };

    function geraFields(field, widget, info, table_name = null) {
        var deferred = ZHPromise.defer();
        
        if ((field.COLUMN_NAME == 'CDARVPROD'||field.COLUMN_NAME == 'CDPRODESTO') && (table_name == 'PRODUTO')) {
            field = {
                "name": field.COLUMN_NAME,
                "label": field.COLUMN_NAME,
                "template": "field/text-edit.html",
                "isVisible": false,
                "showOnList": false,
                "showOnForm": false,
                "showOnView": false,
                "readOnly": true,
                "filterProperties": {
                    "isVisible": false,
                    "showOnForm": false
                }
            };
        }
        if (field.COLUMN_NAME == 'VRTAXAADMI') {
            if (!info) {
                field = {
                    "name": field.COLUMN_NAME,
                    "label": field.COLUMN_NAME,
                    "template": "field/text-edit.html",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnForm": true,
                    "showOnView": true,
                    "readOnly": true,
                    "filterProperties": {
                        "isVisible": false,
                        "showOnForm": false
                    },
                    "mask": {
                        "type": "float",
                        "params": {
                            "symbol": " ",
                            "precision": 2,
                            "thousands": ".",
                            "decimal": ",",
                            "operator": "="
                        }
                    },
                };
            }
            else {
                field = {
                    "name": field.COLUMN_NAME,
                    "label": field.COLUMN_NAME,
                    "template": "field/text-edit.html",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnForm": true,
                    "showOnView": true,
                    "readOnly": true,
                    "filterProperties": {
                        "isVisible": false,
                        "showOnForm": false
                    },
                };
            }
        }
        if (field.COLUMN_NAME == 'IDATIVO') {
            field = {
                "name": field.COLUMN_NAME,
                "label": field.COLUMN_NAME,
                "template": "field/text-edit.html",
				"isVisible": false,
				"showOnList": true,
				"showOnForm": true,
				"showOnView": true,
				"readOnly": true,
				"filterProperties": {
					"isVisible": false,
					"showOnForm": false
                }
			};
		}else {
                field = {
                    "name": field.COLUMN_NAME,
                    "label": field.COLUMN_NAME,
                    "template": "field/text-edit.html",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnForm": true,
                    "showOnView": true,
                    "readOnly": true,
                    "filterProperties": {
                        "isVisible": false,
                        "showOnForm": false
                    },
                };
            }
            metaDataFactory.fieldFactory(field, widget, widget);

        deferred.resolve();
        return deferred.promise;
    }

    function setDescriptionValue(code, fieldColumn){
        let promises = [];
        let description = '';

        code.forEach(function(row) {
			var messagePromise = MessageService.getMessageByCode('cadFis#'.concat(row)).then(function(message) {
				description += message.concat('\n');
			});
			promises.push(messagePromise);
		});

		ZHPromise.all(promises).then(function() {
			setTimeout(function() {
				fieldColumn.setValue(description);
			}, 350);
		});
    }

    function setDescription(columnName, fieldColumn) {
        let code;

        if(columnName == 'IDTPIJURFORN') {
            code = ['IDTPIJURFORN', 'FISICA', 'JURIDICA', 'INTERNACIONAL', 'OUTROS'];
            setDescriptionValue(code, fieldColumn);
        } else if (columnName == 'IDTIPODTPGTO') {
            code = ['IDTIPODTPGTO', 'EMIN', 'EMEX', 'ENIN', 'ENEX', 'DSIN', 'DSEX'];
            setDescriptionValue(code, fieldColumn);
        } else if (columnName == 'IDTPPERIODO') {
            code = ['IDTPPERIODO', 'POR_DIA_MES', 'POR_DIA_SEMANA', 'AMBOS_DIAS'];
            setDescriptionValue(code, fieldColumn);
        } else if (columnName == 'IDREFECALCPARC') {
            code = ['IDREFECALCPARC', 'DIA_DE_REFERENCIA', 'FORA_QUINZENA', 'FORA_SEMANA', 'FORA_DEZENA', 'FORA_MES'];
            setDescriptionValue(code, fieldColumn);
        } else if (columnName == 'IDCONSDIAUTIL') {
            code = ['IDCONSDIAUTIL', 'S_SIM', 'N_NAO'];
            setDescriptionValue(code, fieldColumn);
        } else if(columnName == 'IDENDEMISFOR') {
            code = ['IDENDEMISFOR', 'ENDEFORN_P', 'ENDEFORN_C', 'ENDEFORN_E'];
            setDescriptionValue(code, fieldColumn);
        } else if(columnName == 'IDENDCFOPFOR') {
            code = ['IDENDCFOPFOR', 'ENDEFORN_P', 'ENDEFORN_C', 'ENDEFORN_E'];
            setDescriptionValue(code, fieldColumn);
        } else if(columnName == 'IDPRIPUBFORN') {
            code = ['IDPRIPUBFORN', 'FORN_PRIVATE', 'FORN_PUBLIC'];
            setDescriptionValue(code, fieldColumn);
        } else {
            MessageService.getMessageByCode('cadFis#'.concat(columnName)).then(function(message) {
                fieldColumn.setValue(message);
            });
        }
    }

    function setaFields (field, widget){
        var deferred = ZHPromise.defer();
        const columnName = field.COLUMN_NAME;
        const fieldColumn = widget.getField(columnName);
        const nmtabela = templateManager.container.getWidget('tabbedWidget').currentRow.NMTABELA;

        const glossaryTecfood = ServiceImportacao.getGlossary(nmtabela);
        let data = {};

        if(glossaryTecfood) {
            if (glossaryTecfood.hasOwnProperty(columnName))
                for (data in glossaryTecfood[columnName]) {
                    if(data == 'desc') {
                        setDescription(columnName, fieldColumn);
                    } else {
                        fieldColumn[data] = glossaryTecfood[columnName][data];
                    }
                }
        } else {
            if (glossary.hasOwnProperty(field.COLUMN_NAME))
                for (data in glossary[field.COLUMN_NAME]) {
                    if (data == 'desc')
                        widget.getField(field.COLUMN_NAME).setValue(glossary[field.COLUMN_NAME].desc);
                    else
                        widget.getField(field.COLUMN_NAME)[data] = glossary[field.COLUMN_NAME][data];
                }
        }

        deferred.resolve();
        return deferred.promise;
    }

    this.importarXls = function(widget) {
        if (widget.isValid()) {
            var widgetCampos = templateManager.container.getWidget('widgetCampos');
            var errorMessage;
            var file = widget.currentRow.FILEXLS;
            var pos = file[0].b64File.indexOf(',') + 1;
            const tableName = widget.getParent().currentRow.NMTABELA;

            erros = [];

            file = {
                'name': file[0].name,
                'content': file[0].b64File.substr(pos)
            };

            var row = {
                'FILE': file,
                'CAMPOS': campos,
                'TABLE_NAME': tableName
            };

            //Tecfood
            if (isTecfood(tableName)) {
                fileLoad(widget);
                ScreenService.closePopup();
                return true;
            }

            General.callRestEngine("cadFis#/cadastramento_automatico_xls", "Row", row).then(function(success) {
                widgetCampos.dataSource.data = success.dataset.import;
                widgetCampos.dataSource.data.forEach(function(data) {
                    if ((!data.CDFORNECED && data.IDTPIJURFORN) || (!data.CDFORNECED && data.NRINSJURFORN)) {
                        data.CDFORNECED = data.IDTPIJURFORN.concat(data.NRINSJURFORN);
                    }
                    else if ((!data.CDCLIENTE && data.IDTPIJURCLIE) || (!data.CDCLIENTE && data.NRINSJURCLIE)) {
                        data.CDCLIENTE = data.IDTPIJURCLIE.concat(data.NRINSJURCLIE);
                    }
                    else if (data.IDCTBLCTPAG == 'S' || data.IDCTBLCTPAG == 's') {
                        data.IDCTBLCTPAG = 'Sim';
                    }
                    else if (data.IDCTBLCTPAG == 'N' || data.IDCTBLCTPAG == 'n') {
                        data.IDCTBLCTPAG = 'Não';
                    }
                    else if (data.IDCTBLCTREC == 'S' || data.IDCTBLCTREC == 's') {
                        data.IDCTBLCTREC = 'Sim';
                    }
                    else if (data.IDCTBLCTREC == 'N' || data.IDCTBLCTREC == 'n') {
                        data.IDCTBLCTREC = 'Não';
                    }
                    if (data.IDTPCTPAGAR == '1') {
                        data.IDTPCTPAGAR = 'Normal';
                    }
                    else if (data.IDTPCTPAGAR == '2') {
                        data.IDTPCTPAGAR = 'Adiantamento';
                    }
                    else if (data.IDTPCTPAGAR == '3') {
                        data.IDTPCTPAGAR = 'Empréstimo';
                    }
                    else if (data.IDTPCTRECEBER == '1') {
                        data.IDTPCTRECEBER = 'Normal';
                    }
                    else if (data.IDTPCTRECEBER == '2') {
                        data.IDTPCTRECEBER = 'Adiantamento';
                    }
                    if (data.IDTPIJURCLIE == 'F' || data.IDTPIJURCLIE == 'f') {
                        data.IDTPIJURCLIE = 'Físico';
                    }
                    else if (data.IDTPIJURCLIE == 'J' || data.IDTPIJURCLIE == 'j') {
                        data.IDTPIJURCLIE = 'Jurídico';
                    }
                    else if (data.IDTPIJURCLIE == 'I' || data.IDTPIJURCLIE == 'i') {
                        data.IDTPIJURCLIE = 'Internacional';
                    }
                    else if (data.IDTPIJURCLIE == 'O' || data.IDTPIJURCLIE == 'o') {
                        data.IDTPIJURCLIE = 'Outros';
                    }

                    //fornecedor
                    if (data.IDTPIJURFORN == 'F' || data.IDTPIJURFORN == 'f') {
                        data.IDTPIJURFORN = 'Físico';
                    }
                    else if (data.IDTPIJURFORN == 'J' || data.IDTPIJURFORN == 'j') {
                        data.IDTPIJURFORN = 'Jurídico';
                    }
                    else if (data.IDTPIJURFORN == 'I' || data.IDTPIJURFORN == 'i') {
                        data.IDTPIJURFORN = 'Internacional';
                    }
                    else if (data.IDTPIJURFORN == 'O' || data.IDTPIJURFORN == 'o') {
                        data.IDTPIJURFORN = 'Outros';
                    }

                    if (data.IDENDEMISCLI == 'P' || data.IDENDEMISCLI == 'p') {
                        data.IDENDEMISCLI = 'Endereço do Cliente';
                    }
                    else
                    if (data.IDENDEMISCLI == 'X' || data.IDENDEMISCLI == 'x') {
                        data.IDENDEMISCLI = 'Endereço de Exportação';
                    }
                    else
                    if (data.IDENDEMISCLI == 'C' || data.IDENDEMISCLI == 'c') {
                        data.IDENDEMISCLI = 'Endereço de Cobrança';
                    }
                    else
                    if (data.IDENDEMISCLI == 'E' || data.IDENDEMISCLI == 'e') {
                        data.IDENDEMISCLI = 'Endereço do Exterior';
                    }
                    else
                    if (data.IDENDEMISCLI == 'T' || data.IDENDEMISCLI == 't') {
                        data.IDENDEMISCLI = 'Endereço de Entrega';
                    }
                    else
                    if (data.IDENDEMISCLI == 'I' || data.IDENDEMISCLI == 'i') {
                        data.IDENDEMISCLI = 'Endereço da Inscrição Estadual';
                    }

                    //fornecedor
                    if (data.IDENDEMISFOR == 'P' || data.IDENDEMISFOR == 'p') {
                        data.IDENDEMISFOR = 'Endereço do Fornecedor';
                    }
                    else if (data.IDENDEMISFOR == 'X' || data.IDENDEMISFOR == 'x') {
                        data.IDENDEMISFOR = 'Endereço de Exportação';
                    }
                    else if (data.IDENDEMISFOR == 'C' || data.IDENDEMISFOR == 'c') {
                        data.IDENDEMISFOR = 'Endereço de Cobrança';
                    }
                    else if (data.IDENDEMISFOR == 'X' || data.IDENDEMISFOR == 'x') {
                        data.IDENDEMISFOR = 'Endereço do Exterior';
                    }
                    else if (data.IDENDEMISFOR == 'E' || data.IDENDEMISFOR == 'e') {
                        data.IDENDEMISFOR = 'Endereço de Entrega';
                    }
                    else if (data.IDENDEMISFOR == 'I' || data.IDENDEMISFOR == 'i') {
                        data.IDENDEMISFOR = 'Endereço da Inscrição Estadual';
                    }

                    if (data.IDENDCFOPCLI == 'P' || data.IDENDCFOPCLI == 'p') {
                        data.IDENDCFOPCLI = 'Endereço do Cliente';
                    }
                    else
                    if (data.IDENDCFOPCLI == 'X' || data.IDENDCFOPCLI == 'x') {
                        data.IDENDCFOPCLI = 'Endereço de Exportação';
                    }
                    else
                    if (data.IDENDCFOPCLI == 'C' || data.IDENDCFOPCLI == 'c') {
                        data.IDENDCFOPCLI = 'Endereço de Cobrança';
                    }
                    else
                    if (data.IDENDCFOPCLI == 'E' || data.IDENDCFOPCLI == 'e') {
                        data.IDENDCFOPCLI = 'Endereço do Exterior';

                    }
                    else
                    if (data.IDENDCFOPCLI == 'T' || data.IDENDCFOPCLI == 't') {
                        data.IDENDCFOPCLI = 'Endereço de Entrega';
                    }
                    else
                    if (data.IDENDCFOPCLI == 'I' || data.IDENDCFOPCLI == 'i') {
                        data.IDENDCFOPCLI = 'Endereço da Inscrição Estadual';
                    }

                    //fornecedor
                    if (data.IDENDCFOPFOR == 'P' || data.IDENDCFOPFOR == 'p') {
                        data.IDENDCFOPFOR = 'Endereço do Fornecedor';
                    }
                    else if (data.IDENDCFOPFOR == 'X' || data.IDENDCFOPFOR == 'x') {
                        data.IDENDCFOPFOR = 'Endereço de Exportação';
                    }
                    else if (data.IDENDCFOPFOR == 'C' || data.IDENDCFOPFOR == 'c') {
                        data.IDENDCFOPFOR = 'Endereço de Cobrança';
                    }
                    else if (data.IDENDCFOPFOR == 'X' || data.IDENDCFOPFOR == 'x') {
                        data.IDENDCFOPFOR = 'Endereço do Exterior';
                    }
                    else if (data.IDENDCFOPFOR == 'E' || data.IDENDCFOPFOR == 'e') {
                        data.IDENDCFOPFOR = 'Endereço de Entrega';
                    }
                    else if (data.IDENDCFOPFOR == 'I' || data.IDENDCFOPFOR == 'i') {
                        data.IDENDCFOPFOR = 'Endereço da Inscrição Estadual';
                    }

                    if (data.IDCLIEATIV == 'S' || data.IDCLIEATIV == 's') {
                        data.IDCLIEATIV = 'Ativo';
                    }
                    else if (data.IDCLIEATIV == 'N' || data.IDCLIEATIV == 'n') {
                        data.IDCLIEATIV = 'Inativo';
                    }
                    if (data.IDVERSALDCLI == 'S' || data.IDVERSALDCLI == 's') {
                        data.IDVERSALDCLI = 'Sim';
                    }
                    else if (data.IDVERSALDCLI == 'N' || data.IDVERSALDCLI == 'n') {
                        data.IDVERSALDCLI = 'Não';
                    }
                    if (data.IDVERSALDCLI == 'S' || data.IDVERSALDCLI == 's') {
                        data.IDVERSALDCLI = 'Ativo';
                    }
                    else if (data.IDVERSALDCLI == 'N' || data.IDVERSALDCLI == 'n') {
                        data.IDVERSALDCLI = 'Inativo';
                    }
                    if (data.IDUTSALDCLI == 'S' || data.IDUTSALDCLI == 's') {
                        data.IDUTSALDCLI = 'Sim';
                    }
                    else if (data.IDUTSALDCLI == 'N' || data.IDUTSALDCLI == 'n') {
                        data.IDUTSALDCLI = 'Não';
                    }
                    if (data.IDUTSUBCLIEN == 'S' || data.IDUTSUBCLIEN == 's') {
                        data.IDUTSUBCLIEN = 'Sim';
                    }
                    else if (data.IDUTSUBCLIEN == 'N' || data.IDUTSUBCLIEN == 'n') {
                        data.IDUTSUBCLIEN = 'Não';
                    }
                    if (data.IDPRIPUBCLIE == 'V' || data.IDPRIPUBCLIE == 'v') {
                        data.IDPRIPUBCLIE = 'Privado';
                    }
                    else if (data.IDPRIPUBCLIE == 'B' || data.IDPRIPUBCLIE == 'b') {
                        data.IDPRIPUBCLIE = 'Público';
                    }

                    //fornecedor
                    if (data.IDPRIPUBFORN == 'V' || data.IDPRIPUBFORN == 'v') {
                        data.IDPRIPUBFORN = 'Privado';
                    }
                    else if (data.IDPRIPUBFORN == 'B' || data.IDPRIPUBFORN == 'b') {
                        data.IDPRIPUBFORN = 'Público';
                    }

                    if (data.IDTPENDECLIE == 'P' || data.IDTPENDECLIE == 'p') {
                        data.IDTPENDECLIE = 'Principal';
                    }
                    if (data.IDTPENDECLIECOBR == 'c' || data.IDTPENDECLIECOBR == 'C') {
                        data.IDTPENDECLIECOBR = 'Cobrança';
                    }
                    if (data.IDTPENDECLIEENTR == 'T' || data.IDTPENDECLIEENTR == 't') {
                        data.IDTPENDECLIEENTR = 'Endereço de Entrega';
                    }

                    //fornecedor
                    if (data.IDTPENDEFORN == 'P' || data.IDTPENDEFORN == 'p') {
                        data.IDTPENDEFORN = 'Principal';
                    }
                    if (data.IDTPENDEFORNCOBR == 'c' || data.IDTPENDEFORNCOBR == 'C') {
                        data.IDTPENDEFORNCOBR = 'Cobrança';
                    }
                    if (data.IDTPENDEFORNENTR == 'E' || data.IDTPENDEFORNENTR == 'e') {
                        data.IDTPENDEFORNENTR = 'Endereço de Entrega';
                    }

                    //conta contabil
                    if (data.IDTIPOCONT == 'A' || data.IDTIPOCONT == 'a') {
                        data.IDTIPOCONT = 'Analitico';
                    }
                    else if (data.IDTIPOCONT == 'S' || data.IDTIPOCONT == 's') {
                        data.IDTIPOCONT = 'Sintetico';
                    }

                    if (data.IDNATUCONT == '00') {
                        data.IDNATUCONT = 'Vazio';
                    }
                    else if (data.IDNATUCONT == '01') {
                        data.IDNATUCONT = 'Ativo';
                    }
                    else if (data.IDNATUCONT == '02') {
                        data.IDNATUCONT = 'Passivo';
                    }
                    else if (data.IDNATUCONT == '03') {
                        data.IDNATUCONT = 'Patrimonio Liquido';
                    }
                    else if (data.IDNATUCONT == '04') {
                        data.IDNATUCONT = 'Resultado';
                    }
                    else if (data.IDNATUCONT == '05') {
                        data.IDNATUCONT = 'Compensação';
                    }
                    else if (data.IDNATUCONT == '09') {
                        data.IDNATUCONT = 'Outras';
                    }

                    if (data.IDCONTCCUS == 'O' || data.IDCONTCCUS == 'o') {
                        data.IDCONTCCUS = 'Oficial';
                    }
                    else if (data.IDCONTCCUS == 'R' || data.IDCONTCCUS == 'r') {
                        data.IDCONTCCUS = 'Gerencial';
                    }
                    else if (data.IDCONTCCUS == 'G' || data.IDCONTCCUS == 'g') {
                        data.IDCONTCCUS = 'Oficial/Gerencial';
                    }

                    if (data.IDPADRREL == 'A' || data.IDPADRREL == 'a') {
                        data.IDPADRREL = 'Ativo';
                    }
                    else if (data.IDPADRREL == 'P' || data.IDPADRREL == 'p') {
                        data.IDPADRREL = 'Passivo';
                    }
                    else if (data.IDPADRREL == 'R' || data.IDPADRREL == 'r') {
                        data.IDPADRREL = 'Receita';
                    }
                    else if (data.IDPADRREL == 'D' || data.IDPADRREL == 'd') {
                        data.IDPADRREL = 'Despesa';
                    }
                    else if (data.IDPADRREL == 'C' || data.IDPADRREL == 'c') {
                        data.IDPADRREL = 'Custo';
                    }
                    else if (data.IDPADRREL == 'N' || data.IDPADRREL == 'n') {
                        data.IDPADRREL = 'Não tem';
                    }

                    //Transportadora
                    if (data.IDTPIJURTRAN == 'J' || data.IDTPIJURTRAN == 'j') {
                        data.IDTPIJURTRAN = 'Jurídico';
                    }
                    else if (data.IDTPIJURTRAN == 'F' || data.IDTPIJURTRAN == 'f') {
                        data.IDTPIJURTRAN = 'Físico';
                    }
                    if (data.IDCOMPARQXMLTRA == 'S' || data.IDCOMPARQXMLTRA == 's') {
                        data.IDCOMPARQXMLTRA = 'Sim';
                    }
                    else if (data.IDCOMPARQXMLTRA == 'N' || data.IDCOMPARQXMLTRA == 'n') {
                        data.IDCOMPARQXMLTRA = 'Não';
                    }

                    //tipo de credito bancario
                    if (data.IDCTBLCRBANC == 'S' || data.IDCTBLCRBANC == 's') {
                        data.IDCTBLCRBANC = 'Sim';
                    }
                    else if (data.IDCTBLCRBANC == 'N' || data.IDCTBLCRBANC == 'n') {
                        data.IDCTBLCRBANC = 'Não';
                    }

                    //tipo de debito bancario
                    if (data.IDCTBLDBBANC == 'S' || data.IDCTBLDBBANC == 's') {
                        data.IDCTBLDBBANC = 'Sim';
                    }
                    else if (data.IDCTBLDBBANC == 'N' || data.IDCTBLDBBANC == 'n') {
                        data.IDCTBLDBBANC = 'Não';
                    }

                    //Tipo de Ajuste Títulos a Pagar
                    if (data.IDCTBAJCTPAG == 'S' || data.IDCTBAJCTPAG == 's') {
                        data.IDCTBAJCTPAG = 'Sim';
                    }
                    else if (data.IDCTBAJCTPAG == 'N' || data.IDCTBAJCTPAG == 'n') {
                        data.IDCTBAJCTPAG = 'Não';
                    }
                    if (data.IDAJUCTPAG == 'A' || data.IDAJUCTPAG == 'a') {
                        data.IDAJUCTPAG = 'Acréscimo';
                    }
                    else if (data.IDAJUCTPAG == 'D' || data.IDAJUCTPAG == 'd') {
                        data.IDAJUCTPAG = 'Desconto';
                    }
                    if (data.IDTPAJPAGAR == 'A' || data.IDTPAJPAGAR == 'a') {
                        data.IDTPAJPAGAR = 'Adiantamento';
                    }
                    else if (data.IDTPAJPAGAR == 'N' || data.IDTPAJPAGAR == 'n') {
                        data.IDTPAJPAGAR = 'Normal';
                    }

                    //Tipo de Ajuste Títulos a Receber
                    if (data.IDCTBAJCTREC == 'S' || data.IDCTBAJCTREC == 's') {
                        data.IDCTBAJCTREC = 'Sim';
                    }
                    else if (data.IDCTBAJCTREC == 'N' || data.IDCTBAJCTREC == 'n') {
                        data.IDCTBAJCTREC = 'Não';
                    }
                    if (data.IDAJUCTREC == 'A' || data.IDAJUCTREC == 'a') {
                        data.IDAJUCTREC = 'Acréscimo';
                    }
                    else if (data.IDAJUCTREC == 'D' || data.IDAJUCTREC == 'd') {
                        data.IDAJUCTREC = 'Desconto';
                    }
                    if (data.IDTPAJRECEBER == 'A' || data.IDTPAJRECEBER == 'a') {
                        data.IDTPAJRECEBER = 'Adiantamento';
                    }
                    else if (data.IDTPAJRECEBER == 'N' || data.IDTPAJRECEBER == 'n') {
                        data.IDTPAJRECEBER = 'Normal';
                    }
                    else if (data.IDTPAJRECEBER == 'D' || data.IDTPAJRECEBER == 'd') {
                        data.IDTPAJRECEBER = 'Devolução';
                    }

                });
                if (success.dataset.import.length != 0) {
                    /* 
                    * Valida importação dos dados da planilha    
                    */
                    self.validaImport(success.dataset.import);
                }
                widget.redraw();
                ScreenService.successNotification("Tabela importada");
                ScreenService.closePopup();
                widgetCampos.actions[1].isVisible = true;
            }).catch(function(error) {
                if (error.error == 'XLS_READER_HEADER_SIZE_ERROR') {
                    errorMessage = 'Erro no cabeçalho das colunas do arquivo XLS.';
                    ScreenService.showMessage(errorMessage);
                }
                else if (error.errorCode == 500) {
                    errorMessage = 'Tabela do arquivo XLS incorreta.';
                    ScreenService.showMessage(errorMessage);
                }
            });

            ScreenService.closePopup();
        }
    };

    self.validaImport = function(campos) {
        var tabbedWidget = templateManager.container.getWidget('tabbedWidget');
        var nmtabela = tabbedWidget.currentRow.NMTABELA;
        //Reseta a tabela de erros
        erros = [];

        var campoPrimaryKey = self.getPrimaryKey(nmtabela);
        General.callRestEngine("cadFis#/verificaPrimaryKey", "DataSet", [
            campos, [{
                'primaryKey': campoPrimaryKey,
                'table_name': nmtabela
            }],
            fields
        ]).then(function(response) {
            erros = response.dataset.errors;
            response.dataset.errors.forEach(function(error) {
                templateManager.container.getWidget('widgetCampos').dataSource.data[error.IDREF].IDERROR = 'S';
            });
        });
    };

    function setDescriptionError(){
        let widgetCampos = templateManager.container.getWidget('widgetCampos');
        let widget = templateManager.container.getWidget('widgetErros');
        let promises = [];

        widget.dataSource.data = [];
        widgetCampos.dataSource.data.forEach(function(row){
            if(row.ERROS) {
                widget.getField('COLUMN').isVisible = true;
                widget.getField('VALUE').isVisible = true;
                row.ERROS.forEach(function(rowError){
                    var messagePromise =  MessageService.getMessageByCode('cadFis#'.concat(rowError.ERROR_CODE)).then(function(message) {
                        rowError.DESCERROR = message;
                    });
                    promises.push(messagePromise);

                    ZHPromise.all(promises).then(function(response) {
            			setTimeout(function() {
            				widget.dataSource.data.push(rowError);
            			}, 350);
            		});
                });
            }
        });
    }

    //VERIFICA SE HÁ ERROS REGISTRADOS NA LINHA
    self.mostraErros = function(widgetName) {
        const tabbedWidget = templateManager.container.getWidget('tabbedWidget');
        var widgetCampos = templateManager.container.getWidget('widgetCampos');
        var widget = templateManager.container.getWidget('widgetErros');
        var k = 0;

        if(tabbedWidget.currentRow.NMTABELA == 'CLIENTE_ENDECLIE'){
            return true;
        }else{
			widget.dataSource.data = [];

			if(isTecfood(tabbedWidget.currentRow.NMTABELA)) {
			    setDescriptionError();
			    return true;
			}

			for (var i = 0; i < widgetCampos.dataSource.data.length; i++) {
				for (var j = 0; j < erros.length; j++) {
					if (erros[j].IDREF == widgetCampos.dataSource.data[i].ROWNUM) {
						widget.dataSource.data.push(Util.clone(erros[j]));
						widget.dataSource.data[k++].IDREF++;
					}
				}
			}
			if (widget.dataSource.data.length == 0) {
			    widget.getField('COLUMN').isVisible = false;
			    widget.getField('VALUE').isVisible = false;
			    widget.dataSource.data.push({ 'IDREF': 0, 'DESCERROR': "Não há erros" });
			    return false;
			}
			return true;
		}

    };

    self.ExisteErros = function() {
        if (erros == null || erros.length == 0)
            return false;
        else
            return true;
    };

    self.salvarCampos = function() {
        if (!self.ExisteErros()) {
            var widgetCampos = templateManager.container.getWidget('widgetCampos');
            var tabbedWidget = templateManager.container.getWidget('tabbedWidget');
            var data = widgetCampos.dataSource.data;
            var route;
            var name_tabble = tabbedWidget.currentRow.NMTABELA;
            widgetCampos.currentRow.__is_new = true;

            if(isTecfood(name_tabble)) {
                saveImport();
                return true;
            }

            switch (name_tabble) {

                case 'PRODUTO':
                    data.forEach(function(data) {
                        data.CDPRODUTO = data.CDARVPROD;
                        data.__is_new = true;
                    });
                    break;

                default:
                    data.forEach(function(data) {
                        if (data.IDCTBLCTPAG == 'Sim') {
                            data.IDCTBLCTPAG = 'S';
                        }
                        else if (data.IDCTBLCTPAG == 'Não') {
                            data.IDCTBLCTPAG = 'N';
                        }
                        else if (data.IDCTBLCTREC == 'Sim') {
                            data.IDCTBLCTREC = 'S';
                        }
                        else if (data.IDCTBLCTREC == 'Não') {
                            data.IDCTBLCTREC = 'N';
                        }
                        if (data.IDTPCTPAGAR == 'Normal') {
                            data.IDTPCTPAGAR = '1';
                        }
                        else if (data.IDTPCTPAGAR == 'Adiantamento') {
                            data.IDTPCTPAGAR = '2';
                        }
                        else if (data.IDTPCTPAGAR == 'Empréstimo') {
                            data.IDTPCTPAGAR = '3';
                        }
                        else if (data.IDTPCTRECEBER == 'Normal') {
                            data.IDTPCTRECEBER = '1';
                        }
                        else if (data.IDTPCTRECEBER == 'Adiantamento') {
                            data.IDTPCTRECEBER = '2';
                        }
                        if (data.IDTPIJURCLIE == 'Físico') {
                            data.IDTPIJURCLIE = 'F';
                        }
                        else if (data.IDTPIJURCLIE == 'Jurídico') {
                            data.IDTPIJURCLIE = 'J';
                        }
                        else if (data.IDTPIJURCLIE == 'Internacional') {
                            data.IDTPIJURCLIE = 'I';
                        }
                        else if (data.IDTPIJURCLIE == 'Outros') {
                            data.IDTPIJURCLIE = 'O';
                        }

                        //fornecedor
                        if (data.IDTPIJURFORN == 'Físico') {
                            data.IDTPIJURFORN = 'F';
                        }
                        else if (data.IDTPIJURFORN == 'Jurídico') {
                            data.IDTPIJURFORN = 'J';
                        }
                        else if (data.IDTPIJURFORN == 'Internacional') {
                            data.IDTPIJURFORN = 'I';
                        }
                        else if (data.IDTPIJURFORN == 'Outros') {
                            data.IDTPIJURFORN = 'O';
                        }

                        if (data.IDENDEMISCLI == 'Endereço do Cliente') {
                            data.IDENDEMISCLI = 'P';
                        }
                        else
                        if (data.IDENDEMISCLI == 'Endereço de Exportação') {
                            data.IDENDEMISCLI = 'X';
                        }
                        else
                        if (data.IDENDEMISCLI == 'Endereço de Cobrança') {
                            data.IDENDEMISCLI = 'C';
                        }
                        else
                        if (data.IDENDEMISCLI == 'Endereço do Exterior') {
                            data.IDENDEMISCLI = 'E';
                        }
                        else
                        if (data.IDENDEMISCLI == 'Endereço de Entrega') {
                            data.IDENDEMISCLI = 'T';
                        }
                        else
                        if (data.IDENDEMISCLI == 'Endereço da Inscrição Estadual') {
                            data.IDENDEMISCLI = 'I';
                        }

                        //fornecedor
                        if (data.IDENDEMISFOR == 'Endereço do Fornecedor') {
                            data.IDENDEMISFOR = 'P';
                        }
                        else if (data.IDENDEMISFOR == 'Endereço de Exportação') {
                            data.IDENDEMISFOR = 'X';
                        }
                        else if (data.IDENDEMISFOR == 'Endereço de Cobrança') {
                            data.IDENDEMISFOR = 'C';
                        }
                        else if (data.IDENDEMISFOR == 'Endereço do Exterior') {
                            data.IDENDEMISFOR = 'E';
                        }
                        else if (data.IDENDEMISFOR == 'Endereço de Entrega') {
                            data.IDENDEMISFOR = 'T';
                        }
                        else if (data.IDENDEMISFOR == 'Endereço da Inscrição Estadual') {
                            data.IDENDEMISFOR = 'I';
                        }

                        if (data.IDENDCFOPCLI == 'Endereço do Cliente') {
                            data.IDENDCFOPCLI = 'P';
                        }
                        else
                        if (data.IDENDCFOPCLI == 'Endereço de Exportação') {
                            data.IDENDCFOPCLI = 'X';
                        }
                        else
                        if (data.IDENDCFOPCLI == 'Endereço de Cobrança') {
                            data.IDENDCFOPCLI = 'C';
                        }
                        else
                        if (data.IDENDCFOPCLI == 'Endereço do Exterior') {
                            data.IDENDCFOPCLI = 'E';
                        }
                        else
                        if (data.IDENDCFOPCLI == 'Endereço de Entrega') {
                            data.IDENDCFOPCLI = 'T';
                        }
                        else
                        if (data.IDENDCFOPCLI == 'Endereço da Inscrição Estadual') {
                            data.IDENDCFOPCLI = 'I';
                        }

                        //fornecedor
                        if (data.IDENDCFOPFOR == 'Endereço do Fornecedor') {
                            data.IDENDCFOPFOR = 'P';
                        }
                        else
                        if (data.IDENDCFOPFOR == 'Endereço de Exportação') {
                            data.IDENDCFOPFOR = 'X';
                        }
                        else
                        if (data.IDENDCFOPFOR == 'Endereço de Cobrança') {
                            data.IDENDCFOPFOR = 'C';
                        }
                        else
                        if (data.IDENDCFOPFOR == 'Endereço do Exterior') {
                            data.IDENDCFOPFOR = 'E';
                        }
                        else
                        if (data.IDENDCFOPFOR == 'Endereço de Entrega') {
                            data.IDENDCFOPFOR = 'T';
                        }
                        else
                        if (data.IDENDCFOPFOR == 'Endereço da Inscrição Estadual') {
                            data.IDENDCFOPFOR = 'I';
                        }

                        if (data.IDCLIEATIV == 'Ativo') {
                            data.IDCLIEATIV = 'S';
                        }
                        else if (data.IDCLIEATIV == 'Inativo') {
                            data.IDCLIEATIV = 'N';
                        }
                        if (data.IDVERSALDCLI == 'Sim') {
                            data.IDVERSALDCLI = 'S';
                        }
                        else if (data.IDVERSALDCLI == 'Não') {
                            data.IDVERSALDCLI = 'N';
                        }
                        if (data.IDUTSALDCLI == 'Sim') {
                            data.IDUTSALDCLI = 'S';
                        }
                        else if (data.IDUTSALDCLI == 'Não') {
                            data.IDUTSALDCLI = 'N';
                        }
                        if (data.IDUTSUBCLIEN == 'Sim') {
                            data.IDUTSUBCLIEN = 'S';
                        }
                        else if (data.IDUTSUBCLIEN == 'Não') {
                            data.IDUTSUBCLIEN = 'N';
                        }
                        if (data.IDPRIPUBCLIE == 'Privado') {
                            data.IDPRIPUBCLIE = 'V';
                        }
                        else if (data.IDPRIPUBCLIE == 'Público') {
                            data.IDPRIPUBCLIE = 'B';
                        }

                        //fornecedor
                        if (data.IDPRIPUBFORN == 'Privado') {
                            data.IDPRIPUBFORN = 'V';
                        }
                        else if (data.IDPRIPUBFORN == 'Público') {
                            data.IDPRIPUBFORN = 'B';
                        }

                        if (data.IDTPENDECLIE == 'Principal') {
                            data.IDTPENDECLIE = 'P';
                        }
                        if (data.IDTPENDECLIECOBR == 'Cobrança') {
                            data.IDTPENDECLIECOBR = 'C';
                        }
                        if (data.IDTPENDECLIEENTR == 'Endereço de Entrega') {
                            data.IDTPENDECLIEENTR = 'T';
                        }

                        //fornecedor
                        if (data.IDTPENDEFORN == 'Principal') {
                            data.IDTPENDEFORN = 'P';
                        }
                        if (data.IDTPENDEFORNCOBR == 'Cobrança') {
                            data.IDTPENDEFORNCOBR = 'C';
                        }
                        if (data.IDTPENDEFORNENTR == 'Endereço de Entrega') {
                            data.IDTPENDEFORNENTR = 'E';
                        }

                        //conta contabil
                        if (data.IDTIPOCONT == 'Analitico') {
                            data.IDTIPOCONT = 'A';
                        }
                        if (data.IDTIPOCONT == 'Sintetico') {
                            data.IDTIPOCONT = 'S';
                        }

                        if (data.IDNATUCONT == 'Vazio') {
                            data.IDNATUCONT = '00';
                        }
                        if (data.IDNATUCONT == 'Ativo') {
                            data.IDNATUCONT = '01';
                        }
                        if (data.IDNATUCONT == 'Passivo') {
                            data.IDNATUCONT = '02';
                        }
                        if (data.IDNATUCONT == 'Patrimonio Liquido') {
                            data.IDNATUCONT = '03';
                        }
                        if (data.IDNATUCONT == 'Resultado') {
                            data.IDNATUCONT = '04';
                        }
                        if (data.IDNATUCONT == 'Compensação') {
                            data.IDNATUCONT = '05';
                        }
                        if (data.IDNATUCONT == 'Outras') {
                            data.IDNATUCONT = '09';
                        }

                        if (data.IDCONTCCUS == 'Oficial') {
                            data.IDCONTCCUS = 'O';
                        }
                        if (data.IDCONTCCUS == 'Gerencial') {
                            data.IDCONTCCUS = 'R';
                        }
                        if (data.IDCONTCCUS == 'Oficial/Gerencial') {
                            data.IDCONTCCUS = 'G';
                        }

                        if (data.IDPADRREL == 'Ativo') {
                            data.IDPADRREL = 'A';
                        }
                        if (data.IDPADRREL == 'Passivo') {
                            data.IDPADRREL = 'P';
                        }
                        if (data.IDPADRREL == 'Receita') {
                            data.IDPADRREL = 'R';
                        }
                        if (data.IDPADRREL == 'Despesa') {
                            data.IDPADRREL = 'D';
                        }
                        if (data.IDPADRREL == 'Custo') {
                            data.IDPADRREL = 'C';
                        }
                        if (data.IDPADRREL == 'Não tem') {
                            data.IDPADRREL = 'N';
                        }
                        //transportadora
                        if (data.IDTPIJURTRAN == 'Físico') {
                            data.IDTPIJURTRAN = 'F';
                        }
                        else if (data.IDTPIJURTRAN == 'Jurídico') {
                            data.IDTPIJURTRAN = 'J';
                        }
                        if (data.IDCOMPARQXMLTRA == 'Sim') {
                            data.IDCOMPARQXMLTRA = 'S';
                        }
                        else if (data.IDCOMPARQXMLTRA == 'Não') {
                            data.IDCOMPARQXMLTRA = 'N';
                        }
                        //tipo de credito bancario
                        if (data.IDCTBLCRBANC == 'Sim') {
                            data.IDCTBLCRBANC = 'S';
                        }
                        else if (data.IDCTBLCRBANC == 'Não') {
                            data.IDCTBLCRBANC = 'N';
                        }
                        //tipo de debito bancario
                        if (data.IDCTBLDBBANC == 'Sim') {
                            data.IDCTBLDBBANC = 'S';
                        }
                        else if (data.IDCTBLDBBANC == 'Não') {
                            data.IDCTBLDBBANC = 'N';
                        }
                        //Tipo de Ajuste Títulos a Pagar
                        if (data.IDCTBAJCTPAG == 'Sim') {
                            data.IDCTBAJCTPAG = 'S';
                        }
                        else if (data.IDCTBAJCTPAG == 'Não') {
                            data.IDCTBAJCTPAG = 'N';
                        }
                        if (data.IDAJUCTPAG == 'Acréscimo') {
                            data.IDAJUCTPAG = 'A';
                        }
                        else if (data.IDAJUCTPAG == 'Desconto') {
                            data.IDAJUCTPAG = 'D';
                        }
                        if (data.IDTPAJPAGAR == 'Adiantamento') {
                            data.IDTPAJPAGAR = 'A';
                        }
                        else if (data.IDTPAJPAGAR == 'Normal') {
                            data.IDTPAJPAGAR = 'N';
                        }
                        //Tipo de Ajuste Títulos a Receber
                        if (data.IDCTBAJCTREC == 'Sim') {
                            data.IDCTBAJCTREC = 'S';
                        }
                        else if (data.IDCTBAJCTREC == 'Não') {
                            data.IDCTBAJCTREC = 'N';
                        }
                        if (data.IDAJUCTREC == 'Acréscimo') {
                            data.IDAJUCTREC = 'A';
                        }
                        else if (data.IDAJUCTREC == 'Desconto') {
                            data.IDAJUCTREC = 'D';
                        }
                        if (data.IDTPAJRECEBER == 'Adiantamento') {
                            data.IDTPAJRECEBER = 'A';
                        }
                        else if (data.IDTPAJRECEBER == 'Normal') {
                            data.IDTPAJRECEBER = 'N';
                        }
                        else if (data.IDTPAJRECEBER == 'Devolução') {
                            data.IDTPAJRECEBER = 'D';
                        }
                        
                        // justificativa de exclusão de historico
                        if(data.CDJUSTEXCHIS){
                            data.CDJUSTEXCHIS = ("0000" + data.CDJUSTEXCHIS).slice(-4);
                        }
                        
                        // justificativa de exclusão de historico
                        if(data.CDARVPROD){
                            data.CDPRODUTO = data.CDARVPROD;
                        }

                        data.__is_new = true;
                    });
                    break;
            }

            route = 'cadFis#/crud/';
            route = route.concat(name_tabble.toLowerCase());
            route = route.concat('/save');

            //para todas as tabelas que não são dependentes de outras tabelas
            if (name_tabble != 'FORNECEDOR' && 
				name_tabble != 'FORNECEDOR_ENDEFORN' && 
				name_tabble != 'CLIENTE_ENDECLIE' &&
                name_tabble != 'FILIAL' && 
                name_tabble != 'CENTCUST_CENTCUSTFIL' &&
				name_tabble != 'PRODUTO' &&
				name_tabble != 'CONTCTBL' &&
				name_tabble != 'METAVENDEDOR' &&
				name_tabble != 'JUSTEXCHIS' &&
				name_tabble != 'PRECOBASE') {
                General.callRestEngine(route, 'DataSet', data).then(function(success) {
                    ScreenService.showMessage("Dados salvos com sucesso");
                    self.getFields();
                    widgetCampos.dataSource.name = "";
                }).catch(function(error) {
                    if (error.errorCode == 500) {
                        ScreenService.showMessage("Código inexistente");
                    }
                    else {
                        var errorMessage = error.data.error;
                        ScreenService.showMessage(errorMessage);
                        widgetCampos.dataSource.name = "";
                    }
                });
            }

            else if (name_tabble == 'CONTCTBL') {
                var routeContctbl = 'cadFis#/saveContaContabil';
                General.callRestEngine(routeContctbl, 'DataSet', data).then(function(success) {
                    ScreenService.showMessage("Dados salvos com sucesso");
                    self.getFields();
                    widgetCampos.dataSource.name = "";
                }).catch(function(error) {
                    if (error.errorCode == 500) {
                        ScreenService.showMessage("Código inexistente");
                    }
                    else {
                        var errorMessage = error.data.error;
                        ScreenService.showMessage(errorMessage);
                        widgetCampos.dataSource.name = "";
                    }
                });
            }
            else if (name_tabble == 'FORNECEDOR') {
                var routeEndeForn = 'cadFis#/crud/endeforn/save';
                General.callRestEngine(route, 'DataSet', data).then(function(success) {
                    General.callRestEngine(routeEndeForn, 'DataSet', data).then(function(success) {
                        ScreenService.showMessage("Dados salvos com sucesso");
                        self.getFields();
                        widgetCampos.dataSource.name = "";
                    }).catch(function(error) {
                        if (error.errorCode == 500) {
                            ScreenService.showMessage("Código inexistente");
                        }
                        else {
                            var errorMessage = error.data.error;
                            ScreenService.showMessage(errorMessage);
                            widgetCampos.dataSource.name = "";
                        }
                    });

                }).catch(function(error) {
                    if (error.errorCode == 500) {
                        ScreenService.showMessage("Código inexistente");
                    }
                    else {
                        var errorMessage = error.data.error;
                        ScreenService.showMessage(errorMessage);
                        widgetCampos.dataSource.name = "";
                    }
                });
            }

            else if (name_tabble == 'CLIENTE_ENDECLIE') {
                var sucesso = [];
                var erro = [];
                var i = 2;
                data.forEach(function(data) {

                    data.IDREF = i;

                    switch(data.IDTPIJURCLIE){
                        case 'J':
                            if(General.validateCNPJ(data.NRINSJURCLIE) == true){
                                sucesso.push(data);
                            }else{
                                data.DESCERROR = "CNPJ inválido. (Campo: NRINSJURCLIE)";
                                erro.push(data);
                            }
                            break;

                        case 'F':
                            if(General.validateCPF(data.NRINSJURCLIE) == true){
                                sucesso.push(data);
                            }else{
                                data.DESCERROR = "CPF inválido. (Campo: NRINSJURCLIE)";
                                erro.push(data);
                            }
                            break;

                        case 'O':
                            if(data.NRINSJURCLIE){
                                while((data.NRINSJURCLIE).length < 5){
                                    data.NRINSJURCLIE = "0"+data.NRINSJURCLIE;
                                }
                                sucesso.push(data);
                            }else{
                                data.DESCERROR = "Inscrição inválida. (Campo: NRINSJURCLIE)";
                                erro.push(data);
                            }
                            break;

                        case 'I':
                            if(data.NRINSJURCLIE){
                                while((data.NRINSJURCLIE).length < 20){
                                    data.NRINSJURCLIE = "0"+data.NRINSJURCLIE;
                                }
                                sucesso.push(data);
                            }else{
                                data.DESCERROR = "Inscrição inválida. (Campo: NRINSJURCLIE)";
                                erro.push(data);
                            }
                            break;
                    }

                    i++;
                });
                    General.callRestEngine('cadFis#/salvaImportacaoCliente', 'DataSet', sucesso).then(function(success) {
                        ScreenService.showMessage("Clientes salvos. Os clientes que apresentaram algum problema nos dados e não foram salvos podem ser visualizados na aba Erros de validação.");
                        var widgetErro = templateManager.container.getWidget('widgetErros');
                        if(erro > 0){
                            widgetErro.dataSource.data = erro;
                            widgetErro.activate();
                            widgetErro.reload();
                        }else{
                            widgetErro.dataSource.data = [{
                                'IDREF': 0,
                                'DESCERROR': "Não há erros"
                            }];
                            widgetErro.activate();
                            widgetErro.reload();
                        }
                    }).catch(function(error){
                        ScreenService.showMessage("Clientes salvos. Os clientes que apresentaram algum problema nos dados e não foram salvos podem ser visualizados na aba Erros de validação.");
                        var widgetErro = templateManager.container.getWidget('widgetErros');
                        widgetErro.dataSource.data = error.dataset.errors.concat(erro);
                        widgetErro.activate();
                        widgetErro.reload();

                    });

            }
            else if (name_tabble == 'FORNECEDOR_ENDEFORN') {
                var routeEndeForn2 = 'cadFis#/crud/endeforn/save';
                General.callRestEngine('cadFis#/crud/fornecedor/save', 'DataSet', data).then(function(success) {
                    General.callRestEngine(routeEndeForn2, 'DataSet', data).then(function(success) {
                        data.forEach(function(dados) {
                            var data;
                            if (dados.IDTPENDEFORNCOBR) {
                                var passed = [];
                                data = Util.clone(dados);
                                data.IDTPENDEFORN = data.IDTPENDEFORNCOBR;
                                data.CDMUNICIPIO = data.CDMUNICIPIOCOBR;
                                data.CDPAIS = data.CDPAISCOBR;
                                data.DSCOMPENDFOR = data.DSCOMPENDFORCOBR;
                                data.DSEMAILFORN = data.DSEMAILFORNCOBR;
                                data.DSEMAILFORNNFE = data.DSEMAILFORNNFECOBR;
                                data.DSENDEFORN = data.DSENDEFORNCOBR;
                                data.NMBAIRFORN = data.NMBAIRFORNCOBR;
                                data.NRCELULARFOR = data.NRCELULARFORCOBR;
                                data.NRCEPFORN = data.NRCEPFORNCOBR;
                                data.NRTELRESIFOR = data.NRTELRESIFORCOBR;
                                data.SGESTADO = data.SGESTADOCOBR;
                                passed.push(data);
                                General.callRestEngine(routeEndeForn2, 'DataSet', passed).then().catch(function(error) {
                                    if (error.errorCode == 500) {
                                        ScreenService.showMessage("Código inexistente");
                                    }
                                    else {
                                        var errorMessage = error.data.error;
                                        ScreenService.showMessage(errorMessage);
                                        widgetCampos.dataSource.name = "";
                                    }
                                });
                            }
                            if (dados.IDTPENDEFORNENTR) {
                                var passedA = [];
                                data = Util.clone(dados);
                                data.IDTPENDEFORN = data.IDTPENDEFORNENTR;
                                data.CDMUNICIPIO = data.CDMUNICIPIOENTR;
                                data.CDPAIS = data.CDPAISENTR;
                                data.DSCOMPENDFOR = data.DSCOMPENDFORENTR;
                                data.DSEMAILFORN = data.DSEMAILFORNENTR;
                                data.DSEMAILFORNNFE = data.DSEMAILFORNNFEENTR;
                                data.DSENDEFORN = data.DSENDEFORNENTR;
                                data.NMBAIRFORN = data.NMBAIRFORNENTR;
                                data.NRCELULARFOR = data.NRCELULARFORENTR;
                                data.NRCEPFORN = data.NRCEPFORNENTR;
                                data.NRTELRESIFOR = data.NRTELRESIFORENTR;
                                data.SGESTADO = data.SGESTADOENTR;
                                passedA.push(data);
                                General.callRestEngine(routeEndeForn2, 'DataSet', passedA).then().catch(function(error) {
                                    if (error.errorCode == 500) {
                                        ScreenService.showMessage("Código inexistente");
                                    }
                                    else {
                                        var errorMessage = error.data.error;
                                        ScreenService.showMessage(errorMessage);
                                        widgetCampos.dataSource.name = "";
                                    }
                                });
                            }
                        });
                        ScreenService.showMessage("Dados salvos com sucesso");
                        self.getFields();
                        widgetCampos.dataSource.name = "";
                    }).catch(function(error) {
                        if (error.errorCode == 500) {
                            ScreenService.showMessage("Código inexistente");
                        }
                        else {
                            var errorMessage = error.data.error;
                            ScreenService.showMessage(errorMessage);
                            widgetCampos.dataSource.name = "";
                        }
                    });

                }).catch(function(error) {
                    if (error.errorCode == 500) {
                        ScreenService.showMessage("Código inexistente");
                    }
                    else {
                        var errorMessage = error.data.error;
                        ScreenService.showMessage(errorMessage);
                        widgetCampos.dataSource.name = "";
                    }
                });
            }
            else if (name_tabble == 'FILIAL') {
                var routeEndeFili = 'cadFis#/crud/endefili/save';
                General.callRestEngine(route, 'DataSet', data).then(function(success) {
                    General.callRestEngine(routeEndeFili, 'DataSet', data).then(function(success) {
                        ScreenService.showMessage("Dados salvos com sucesso");
                        self.getFields();
                        widgetCampos.dataSource.name = "";
                    }).catch(function(error) {
                        if (error.errorCode == 500) {
                            ScreenService.showMessage("Código inexistente");
                        }
                        else {
                            var errorMessage = error.data.error;
                            ScreenService.showMessage(errorMessage);
                            widgetCampos.dataSource.name = "";
                        }
                    });
                }).catch(function(error) {
                    if (error.errorCode == 500) {
                        ScreenService.showMessage("Código inexistente");
                    }
                    else {
                        var errorMessage = error.data.error;
                        ScreenService.showMessage(errorMessage);
                        widgetCampos.dataSource.name = "";
                    }
                });
            }
            else if (name_tabble == 'CENTCUST_CENTCUSTFIL') {
                var routeCentcustFil = 'cadFis#/crud/centcustfil/save';
                General.callRestEngine('cadFis#/crud/centcust/save', 'DataSet', data).then(function(success) {
                    data.forEach(function(dados) {
                        var filiais = dados.CDFILIAL.split(' ').join('');
                        filiais = filiais.split(";");
                        var data;
                        if (dados.CDFILIAL != 'T') {
                            for (var i = 0; i < filiais.length; i++) {
                                if (filiais[i].CDFILIAL != "") {
                                    var passed = [];
                                    data = Util.clone(dados);
                                    data.CDFILIAL = filiais[i];
                                    passed.push(data);

                                    self.insertCentcustfil(routeCentcustFil, passed, widgetCampos);
                                }
                            }
                        }
                        else {
                            General.callRestEngine('cadFis#/crud/filial', 'FilterData', []).then(function(result) {
                                var filiais = result.dataset.filial;

                                if (filiais.length > 0) {
                                    filiais.forEach(function(filial) {
                                        var passed = [];
                                        data = Util.clone(dados);
                                        data.CDFILIAL = filial.CDFILIAL;
                                        passed.push(data);

                                        self.insertCentcustfil(routeCentcustFil, passed, widgetCampos);
                                    });
                                }

                            });

                        }

                    });
                }).catch(function(error) {
                    if (error.errorCode == 500) {
                        ScreenService.showMessage("Código inexistente");
                    }
                    else {
                        var errorMessage = error.data.error;
                        ScreenService.showMessage(errorMessage);
                        widgetCampos.dataSource.name = "";
                    }
                });
            }
            else if(name_tabble == 'PRODUTO') {
                var routeProduct = 'cadFis#/saveImportXlsProduct';
                General.callRestEngine(routeProduct, 'DataSet', data).then(function(success) {
                    ScreenService.showMessage("Dados salvos com sucesso");
                    self.getFields();
                    widgetCampos.dataSource.name = ""; 
                }).catch(function(error) {
                    if (error.errorCode == 500) {
                        ScreenService.showMessage("Código inexistente");
                        widgetCampos.dataSource.name = "";
                    }
                    else {
                        var errorMessage = error.data.error;
                        ScreenService.showMessage(errorMessage);
                        widgetCampos.dataSource.name = "";
                    }
                });
            } 
            else if(name_tabble == 'JUSTEXCHIS'){
                var routeJustexchis = 'cadFis#/crud/justexchis/save';
                General.callRestEngine(routeJustexchis, 'DataSet', data).then(function(success) {
                    ScreenService.showMessage("Dados salvos com sucesso");
                    self.getFields();
                    widgetCampos.dataSource.name = "";
                }).catch(function(error) {
					if (error.errorCode == 500) {
                        ScreenService.showMessage("Descrição deve ser preenchida!");
                    }
                    else {
                        var errorMessage = error.data.error;
                        ScreenService.showMessage(errorMessage);
                        widgetCampos.dataSource.name = "";
                    }
				});
            
            }
            
            else if(name_tabble == 'METAVENDEDOR'){
                var routeMetavendedor = 'cadFis#/crud/metavendedor/save';
                General.callRestEngine(routeMetavendedor, 'DataSet', data).then(function(success) {
                    ScreenService.showMessage("Dados salvos com sucesso");
                    self.getFields();
                    widgetCampos.dataSource.name = "";
                }).catch(function(error) {
                    if (error.errorCode == 500) {
                        var erro = error.data.error;
                        var erroOra = erro.search("ORA-02291");
                        var erroVendedorFk = erro.search("FKPED00140VENDEDOR");
                        var erroMetavendaFk = erro.search("FKPED00142METAVEND");
                        if(erroOra > 0 && erroVendedorFk > 0)
                            ScreenService.showMessage("Vendedor não cadastrado!");
                        else if(erroOra > 0 && erroMetavendaFk > 0)
                            ScreenService.showMessage("Meta de Venda não cadastrada!");
                        else
                            ScreenService.showMessage("Erro ao inserir metas.");
                    }
                    else {
                        var errorMessage = error.data.error;
                        ScreenService.showMessage(errorMessage);
                        widgetCampos.dataSource.name = "";
                    }
                });

            }
            
            else if(name_tabble == 'PRECOBASE'){
                
                var filterPrecobase = [{
                        "name": "CDPRECOBASE",
                        "operator": "=",
                        "value": data[0].CDPRECOBASE
                    }
                ];

                var routePrecobase = 'cadFis#/crud/precobase/save';
                var routeItemprebase = 'cadFis#/crud/itemprebase/save';
                
                var dataPrecobase = [];
                var dataItemprebase = [];

                // VERIFICO SE O PREÇO BASE JÁ EXISTE
                General.callRestEngine('cadFis#/crud/precobase', 'FilterData', filterPrecobase).then(function(success) {
                    
                    dataPrecobase[0] = {"CDPRECOBASE": data[0].CDPRECOBASE,
                                        "DSPRECOBASE": data[0].DSPRECOBASE,
                                        "__is_new": true
                    };
                    
                    if(success.dataset.precobase.length > 0){
                        dataPrecobase[0].__is_new = false;
                        dataPrecobase[0].changed = true;
                    }
                    
                    for(var z =0; z<data.length; z++){
                        
                        var objItemprebase = {"CDPRECOBASE": data[z].CDPRECOBASE,
                                            "DSPRECOBASE": data[z].DSPRECOBASE,
                    						"CDPRODUTO": data[z].CDPRODUTO,
                    						"VRITEPREBASE": data[z].VRITEPREBASE,
                    						"DTINIVALIPB": data[z].DTINIVALIPB,
                    						"DTFIMVALIPB": data[z].DTFIMVALIPB,
                    						"CDOPERATZIPB": data[z].CDOPERATZIPB,
                    						"DTHRATZIPB": data[z].DTHRATZIPB,
                                            "__is_new": true
                        };
                    
                        dataItemprebase.push(objItemprebase);
                    }
                    
                    General.callRestEngine(routePrecobase, 'DataSet', dataPrecobase).then(function(success) {
                        
                        General.callRestEngine(routeItemprebase, 'DataSet', dataItemprebase).then(function(success) {
                            ScreenService.showMessage("Dados salvos com sucesso");
                            self.getFields();
                            widgetCampos.dataSource.name = "";
                            
                        }).catch(function(error) {
                            if (error.errorCode == 500) {
                                var erro = error.data.error;
                                var erroOra = erro.search("ORA-00001");
                                var erroItemprebase = erro.search("PK_ITEMPREBASE");
                                if(erroOra > 0 && erroItemprebase > 0)
                                    ScreenService.showMessage("Chave primaria violada!");
                                else
                                    ScreenService.showMessage("Erro ao inserir Item da Tabela de Preço.");
                            }
                        });
                            
                    }).catch(function(error) {
                        if (error.errorCode == 500) {
                            ScreenService.showMessage("Erro ao inserir Tabela de Preço.");
                        }
                        else {
                            var errorMessage = error.data.error;
                            ScreenService.showMessage(errorMessage);
                            widgetCampos.dataSource.name = "";
                        }
                    });
                }).catch(function(error) {
                    
                    
                });


            }

            ScreenService.closePopup();
        }
        else {
            ScreenService.showMessage('Dados com erros. Não foi possível efetuar salvamento.');
            ScreenService.closePopup();
        }
    };

    self.insertCentcustfil = function(routeCentcustFil, passed, widgetCampos) {

        General.callRestEngine(routeCentcustFil, 'DataSet', passed).then(function(success) {
            ScreenService.showMessage("Dados salvos com sucesso");
            self.getFields();
            widgetCampos.dataSource.name = "";
        }).catch(function(error) {
            if (error.errorCode == 500) {
                ScreenService.showMessage("Código inexistente");
            }
            else {
                var errorMessage = error.data.error;
                ScreenService.showMessage(errorMessage);
                widgetCampos.dataSource.name = "";
            }
        });

    };

    self.getPrimaryKey = function(nmtabela) {
        var name;
        switch (nmtabela) {
            case 'MOTIVOPROR':
                name = 'CDMOTIPROR';
                break;
            case 'MOTIVOPARC':
                name = 'CDMOTIPARC';
                break;
            case 'TPDEBIBANC':
                name = 'CDTPDEBIBANC';
                break;
            case 'TPCREDBANC':
                name = 'CDTPCREDBANC';
                break;
            case 'TIPOAJPAGAR':
                name = 'CDAJUCTPAG';
                break;
            case 'TIPOAJRECEBER':
                name = 'CDAJUCTREC';
                break;
            case 'FORNECEDOR':
                name = 'CDFORNECED';
                break;
            case 'CLIENTE_ENDECLIE':
                name = 'CDCLIENTE';
                break;
            case 'JUSTEXCHIS':
                name = 'CDJUSTEXCHIS';
                break;
            case 'METAVENDEDOR':
                name = 'CDMETAVENDA';
                break;
            case 'FILIAL':
                name = 'CDFILIAL';
                break;
            case 'PRODUTO':
                name = 'CDARVPROD';
                break;
            case 'TIPOCTPAGAR':
                name = 'CDTPCTPAGAR';
                break;
            case 'TIPOCTRECEBER':
                name = 'CDTPCTRECEB';
                break;
            case 'HISTPADR':
                name = 'CDHISTPADR';
                break;
            case 'CLIENTE_ENDECLIE':
                name = 'CDCLIENTE';
                break;
            case 'FORNECEDOR_ENDEFORN':
                name = 'CDFORNECED';
                break;
            case 'CONTCTBL':
                name = 'CDCONTCTBL';
                break;
            case 'CENTCUST_CENTCUSTFIL':
                name = 'CDCENTCUST';
                break;
            case 'TIPORECE':
                name = 'CDTIPORECE';
                break;
            case 'TRANSPORT':
                name = 'NRINSJURTRAN';
                break;
            case 'PRECOBASE':
                name = 'CDPRECOBASE';
                break;
            default:
                break;
        }
        return name;

    };

    self.filtraCamposTabelas = function(table_name, dataset) {
        var objeto = [];
        for (var j = 0; j < dataset.length; j++) {
            var column_name = dataset[j].COLUMN_NAME;
            if (self.colunas(objeto, column_name) < 1) {
                objeto.push(fields[j]);
            }
        }
        return objeto;
    };

    self.colunas = function(dataset, column_name) {
        var numeroDeRepeticoes = 0;
        for (var i = 0; i < dataset.length; i++) {
            if (dataset[i].COLUMN_NAME == column_name)
                numeroDeRepeticoes++;
        }
        return numeroDeRepeticoes;
    };

    /**
     * Habilita widget
     * @param widget
     */

    self.habilitaWidgetInfos = function(widget_name) {
        var widget = templateManager.container.getWidget(widget_name);
        var widget_table = templateManager.container.getWidget('tabbedWidget');
        var table_name = widget_table.currentRow.NMTABELA;
        if (table_name != 'FORNECEDOR_ENDEFORN' && table_name != 'CONTCTBL' &&
            table_name != 'CENTCUST_CENTCUSTFIL' &&
            table_name != 'TIPORECE' &&
            table_name != 'TRANSPORT' &&
            table_name != 'CLIENTE_ENDECLIE' &&
            table_name != 'TIPOCTRECEBER' &&
            table_name != 'TIPOCTPAGAR' &&
            table_name != 'TPCREDBANC' &&
            table_name != 'TPDEBIBANC' &&
            table_name != 'TIPOAJPAGAR' &&
            table_name != 'TIPOAJRECEBER' &&
            table_name != 'MOTIVOPROR' &&
            table_name != 'MOTIVOPARC' &&
            table_name != 'HISTPADR' &&
            table_name != 'PRODUTO' &&
            table_name != 'MARCA' &&
            table_name != 'MARCPROD' &&
            table_name != 'PRODFORN' &&
            table_name != 'COMPRADOR' &&
            table_name != 'PRODCOMP' &&
            table_name != 'REGIAO' &&
            table_name != 'GERENTE' &&
            table_name != 'FORMPGTO' &&
            table_name != 'FORNECEDOR' &&
            table_name != 'METAVENDEDOR' &&
            table_name != 'JUSTEXCHIS' &&
            table_name != 'JUSTEXCHIS'&&
            table_name != 'PRECOBASE') {
            widget.isVisible = false;
        } else {
            widget.isVisible = true;
        }
    };

    self.geraGlossario = function(field, widget) {
        field = {
            "name": field.COLUMN_NAME,
            "label": field.COLUMN_NAME,
            "template": "field/text-edit.html",
            "isVisible": true,
            "showOnList": true,
            "filterProperties": {
                "isVisible": false,
                "showOnForm": false
            },
        };
        metaDataFactory.fieldFactory(field, widget, widget);
    };
    
    this.checkParamAction = function(widgetCampos,table_name){
        let paramField = widgetCampos.getAction('parametros');
        if(table_name === 'PRODUTO'){
            paramField.isVisible = true;
        }else{
            paramField.isVisible = false;
        }
    };

    this.openPopUpParametros = function(){
        var PopUpParametros = templateManager.container.getWidget('PopUpParametros');
		ScreenService.openPopup(PopUpParametros);
	};

    self.backProductParametrization = function(){
        let widgetCampos = templateManager.container.getWidget('widgetCampos');
        ScreenService.closePopup();
        widgetCampos.activate();
        widgetCampos.reload();

    };

    self.saveProductParametrization = function (widgetParam){
        let widgetCampos = templateManager.container.getWidget('widgetCampos');
        widgetParam.currentRow.__is_new = false;
        let dataSet = widgetParam.dataSource.data;

        UtilCadFis.saveDataSetCrud(dataSet,'paramimpprod').then((sucess)=>{
            ScreenService.closePopup();
            widgetCampos.activate();
            widgetCampos.reload();
        });


    };

    self.checkSequentialField = function(widget){
        let needCheck = false;
        let rowEditedInline = (row)=>{
            let boolEdited = false;
            
            $.each(row, function(index, value) {
                if(row.hasOwnProperty('changed_'+index)){
                    boolEdited = true;
                }
            }); 
        
            return boolEdited;
        };
        let changedRows = widget.dataSource.data.filter((row)=>{
            return row.changed === true && (!row.__is_new || rowEditedInline(row));
        });
        
        changedRows = UtilCadFis.fixInlineEditDataSet(changedRows);
            
        changedRows.forEach((newData)=>{
            if(newData.CDSEQNIVPROD <= 0 || newData.CDSEQNIVPROD == ""){
                needCheck = true;
            }
        });
        
        if(needCheck){
            ScreenService.showMessage("Valor Sequencial inválido!");
            widget.mode = 'inline_edit';
        }else{
            UtilCadFis.cancelInlineEdit(widget);
        }
    };

    /**
  	 * Essa parte diz respeito ao carregamento dos campos no grid.
  	 * Basicamente quando o campo de tabela é prenchido, é feito uma busca
  	 * retornando os campos da tabela e as configurações
  	 * e posteriormente criando colunas no grid de acordo com a quantidade de campos
  	 * e com o nome de cada campo retornado
  	 */

    function setDataSourceRoute(tableName) {
        const route = 'cadFis#/crud/tab_column_';
        return route.concat(tableName.toLowerCase());
    }

    function colunasTecfood(dataset, column_name) {
        return dataset.filter((data) => data.COLUMN_NAME == column_name).length;
    }

    function filtraCamposTabelasTecfood(table_name, dataset) {
        let objeto = [];
        for (let i = 0; i < dataset.length; i++) {
            let column_name = dataset[i].COLUMN_NAME;
            if (colunasTecfood(objeto, column_name) < 1) {
                objeto.push(fields[i]);
            }
        }

        return objeto;
    }

    function geraFieldsInfo(field, widget, table_name = null) {
        geraFields(field, widget, true, table_name).then(function() {
            setaFields(field, widget);
        });
    }

    function getFieldsTecfood() {
        const widget = templateManager.container.getWidget('tabbedWidget');
        const widgetErro = templateManager.container.getWidget('widgetErros');
        const widgetCampos = templateManager.container.getWidget('widgetCampos');
        const widgetInfos = templateManager.container.getWidget('widgetInfos');
        const table_name = widget.currentRow.NMTABELA;
        const filter = [{
                "name": "TABLE_NAME",
                "operator": "=",
                "value": table_name
            }
        ];
        let route;
        let data = {};
        let tabela;

        MessageService.getMessageByCode('cadFis#NO_ERRORS').then(function(message) {
            widgetErro.dataSource.data = [{
                'IDREF': 0,
                'DESCERROR': message
            }];

            route = setDataSourceRoute(table_name);

            General.callRestEngine(route, 'FilterData', filter).then(function(success) {
                widgetCampos.fields = [];
                widgetInfos.fields = [];

                MessageService.getMessageByCode('cadFis#'.concat(table_name)).then(function(tableDescription) {
                    tabela = tableDescription;

                    //EXPORTA TODAS AS COLUNAS DO SELECT DO BANCO PARA A TELA
                    switch (table_name) {
                        case 'MARCA':
                            fields = success.dataset.tab_column_marca;
                            break;
                        case 'MARCPROD':
                            fields = success.dataset.tab_column_marcprod;
                            break;
                        case 'PRODFORN':
                            fields = success.dataset.tab_column_prodforn;
                            break;
                        case 'COMPRADOR':
                            fields = success.dataset.tab_column_comprador;
                            break;
                        case 'PRODCOMP':
                            fields = success.dataset.tab_column_prodcomp;
                            break;
                        case 'GERENTE':
                            fields = success.dataset.tab_column_gerente;
                            break;
                        case 'REGIAO':
                            fields = success.dataset.tab_column_regiao;
                            break;
                        case 'FORMPGTO':
                            fields = success.dataset.tab_column_formpgto;
                            break;
                        case 'FORNECEDOR':
                            fields = success.dataset.tab_column_fornecedor;
                            break;
                    }

                    //SELECIONA QUAIS COLUNAS IRÃO APARECER NA TELA
                    fields = filtraCamposTabelasTecfood(table_name, fields);

                    for (var i = 0; i < fields.length; i++) {
                        geraFields(fields[i], widgetCampos, false);
                        geraFieldsInfo(fields[i], widgetInfos);

                        campos[i] = fields[i].COLUMN_NAME;
                        data[fields[i].COLUMN_NAME] = '';
                    }

                    widgetCampos.dataSource.data = [data];
                    widgetCampos.label = tabela; //exibe nome da tabela

                    const banco = "cadFis#/crud/".concat(table_name.toLowerCase());
                    widgetCampos.dataSource.name = banco;
                    widgetCampos.activate();

                    if (!widgetErro.isActive()) {
                        widgetCampos.redraw(true);
                        widgetInfos.redraw(true);
                    }

                });
            });
        });
    }

    function showImportMessage(rows) {
        let existsError = false;
        let row = [];

        for(row of rows) {
            if(row.IDERROR === 'S') {
                existsError = true;
                break;
            }
        }
        if(existsError) {
            MessageService.showMessageByCode('cadFis#IMPORT_ERROR', null, { type: 'ALERT' });
        } else {
            MessageService.successNotificationByCode('cadFis#IMPORT_SUCCESS');
        }
    }

    function fileLoad(widget) {
        const widgetCampos = templateManager.container.getWidget('widgetCampos');

        let file = widget.currentRow.FILEXLS;
        let pos = file[0].b64File.indexOf(',') + 1;

        file = {
            'name': file[0].name,
            'content': file[0].b64File.substr(pos)
        };

        const row = {
            'FILE': file,
            'CAMPOS': campos,
            'TABLE_NAME': widget.getParent().currentRow.NMTABELA
        };

        General.callRestEngine("cadFis#/importXls", "Row", row).then(function(success) {
            widgetCampos.dataSource.data = success.dataset.import;
            widget.redraw();
            showImportMessage(success.dataset.import);
            ScreenService.closePopup();
            widgetCampos.actions[1].isVisible = true;
        }).catch(function(error) {
            if (error.error) {
                MessageService.showMessageByCode('cadFis#' + error.error, null, { type: 'ERROR' });
                widgetCampos.actions[1].isVisible = false;
                ScreenService.closePopup();
            }
        });
    }

    function saveImport() {
        const widgetCampos = templateManager.container.getWidget('widgetCampos');
        const tabbedWidget = templateManager.container.getWidget('tabbedWidget');
        const widData = widgetCampos.dataSource.data;

        const data = [{
            "ROWS": widData,
            "TABLE_NAME": tabbedWidget.currentRow.NMTABELA
        }];

        if (widData.length) {
            General.callRestEngine("cadFis#/saveImport", 'DataSet', data).then(function(success) {
                MessageService.successNotificationByCode('cadFis#SAVE_IMP_SUCCESS');
                self.getFields();
                ScreenService.closePopup();
            }).catch(function(error) {
                MessageService.showMessageByCode('cadFis#' + error.data.error, null, { type: 'ERROR' });
                ScreenService.closePopup();
            });
        }
    }

    function isTecfood(tableName) {
        return tableName == 'MARCA' ||
               tableName == 'MARCPROD' ||
               tableName == 'PRODFORN' ||
               tableName == 'COMPRADOR' ||
               tableName == 'PRODCOMP' ||
               tableName == 'GERENTE' ||
               tableName == 'REGIAO' ||
               tableName == 'FORMPGTO' ||
               tableName == 'FORNECEDOR';
    }

}

/* global Configuration */
Configuration(function(ContextRegister) {
    ContextRegister.register('Ger00000_Cadastramentos_Automatico_Controller', Ger00000_Cadastramentos_Automatico_Controller);
});

// FILE: ./assets/js/controllers/Ger00200_Empresa_Controller.js
var Ger00200_Empresa_Controller = function (Ger00200_Empresa_Service, MessageService, ScreenService, General, templateManager, restEngine, localStorageEngine, Endereco) {
	var self = this;
	var empresaSelecionada = null;

	this.recarregarWidgets = function (widget) {
		if (!widget.currentRow.__is_new) {
			widget.widgets.forEach(function (widg) {
				if (widg.widgets) {
					widg.widgets.forEach(function (widgFilhas) {
						widgFilhas.reload();
					});
				}
				widg.reload();
			});
		}
	};

	self.newRow = function (widget) {
		widget.backupRow = Util.clone(widget.currentRow);
		widget.edit();
		widget.newRow();
		ScreenService.openSwipe(widget);
	};

	this.setFieldsAddress = function (widgetName, fieldName) {
		return General.getFieldValue(fieldName, widgetName);
	};

	this.excluir = function (widget) {
		General.deleteCrud(widget);
	};

	this.excluirSignatario = function (widget) {
		var msg = "Deseja excluir o signatário " + widget.currentRow.NMSIGESCSPED + "?";
		ScreenService.confirmMessage(msg, "question", function () {
			widget.remove(widget.currentRow).then(
				function success(success) {
					ScreenService.goBack();
					widget.reload();
				},
				function error(error) {
					if (error.data) {
						msg = ScreenService.i18n(error.data.error);
						ScreenService.showMessage(msg);
					} else {
						ScreenService.showMessage("Verifique sua conexão e tente novamente");
					}
				}
			);
		}, function () {
			templateManager.updateTemplate();
		});
	};

	this.empresaWidgetOnEnter = function (widget) {
		widget.currentRow = empresaSelecionada;
		widget.currentRow.IDFORMAPUREMPR = widget.currentRow.IDFORMAPUREMPR || "N";
	};

	this.empresaFormWidgetOnEnter = function (widget) {
		//dataSourceFilter[0].value = widget.currentRow['SGESTADO'];
	};

	this.empresaWidgetAfterMoveRow = function (widget) {
		empresaSelecionada = widget.currentRow;
		this.recarregarWidgets(widget);
	};

	this.novo = function (widget) {
		var parentRow = widget.getParent().currentRow;
		widget.template = "widget/form.html";
		widget.edit();
		widget.newRow();
		widget.currentRow.CDEMPRESA = parentRow.CDEMPRESA;
	};

	this.novoSignatario = function (widget) {
		var parentRow = widget.getParent().currentRow;
		widget.edit();
		widget.newRow();
		widget.currentRow.CDEMPRESA = parentRow.CDEMPRESA;
	};

	this.editar = function (widget) {
		widget.template = widget.templateToForm;
		General.edit(widget);
	};
	this.editarDados = function (widget) {
		widget.template = widget.templateToForm;
		widget.fieldGroups[0].opened = false;
		widget.fieldGroups[1].opened = false;
		General.edit(widget);
	};

	this.salvar = function (widget, nomeWidgetAtual) {
		
		if(widget.currentRow.IDFORMAPUREMPR === "S"){
			widget.currentRow.IDFORMAPUREMPR = 'P';
		}else{
			widget.currentRow.IDFORMAPUREMPR = null;
		}
		
		widget.saveRow().then(function () {
			var widgetPrincial = templateManager.container.getWidget('EmpresaWidget');
			this.controlaStatusWidgets(widgetPrincial, nomeWidgetAtual, true);
			if (widget.name === 'EmpresaParametrizacaoNFEWidget') {
				var widgetTabbed = templateManager.container.getWidget('DadosFiscais');
				this.controlaStatusWidgets(widgetTabbed, 'EmpresaParametrizacaoNFEWidget', true);
			}
			widget.template = "widget/form-view.html";
			widget.list();
			//ScreenService.showMessage(ScreenService.i18n('Salvo com sucesso.'));
		}.bind(this), function (callback) {
			ScreenService.showMessage(callback.data.error);
		});
	};

	this.salvarDadosAdicionais = function (widget, nomeWidgetAtual) {
		if(widget.currentRow.CDSITUCRT == "3"){
			widget.currentRow.IDOPTSIMPLES = 'N';
		}else{
				widget.currentRow.IDOPTSIMPLES = 'S';
		}
		
		if (widget.currentRow.valorInicialRegimeApuracao !== widget.currentRow.IDCUMUPICOEMP) {
			ScreenService.confirmMessage(ScreenService.i18n('Atenção. Todas as unidades pertencentes a empresa serão alteradas para o mesmo regime de apuração selecionado. Deseja confirmar a operacão?'), 'question',
				function (success) {
					Ger00200_Empresa_Service.salvarEmpresa(widget).then(function (success) {
							var widgetPrincial = templateManager.container.getWidget('EmpresaWidget');
							this.controlaStatusWidgets(widgetPrincial, nomeWidgetAtual, true);
							widget.template = widget.templateToView;
							widget.view();
							widget.activate();
							widget.list();
						}.bind(this),
						function (callback) {
							if (callback.data) {
								ScreenService.showMessage(callback.data.error);
							}
						}.bind(this));
				}.bind(this),
				function (error) {
					widget.currentRow.IDCUMUPICOEMP = widget.currentRow.valorInicialRegimeApuracao;
					this.salvar(widget, 'EmpresaDadosAdicionaisWidget');
				}.bind(this)
			);
		} else {
			this.salvar(widget, 'EmpresaDadosAdicionaisWidget');
		}
		widget.fieldGroups['0'].collapsible = true;
	};

	this.salvarEmpresa = function (args) {
		var widget = args.owner.widget;
		widget.currentRow = args.row;
		//widget.saveRow().then(
		let dslogomarca = widget.currentRow.DSLOGOMARCA;
	//	delete widget.currentRow.DSARQLOGOEMP;
		if(widget.currentRow.IDFORMAPUREMPR === "S"){
			widget.currentRow.IDFORMAPUREMPR = 'P';
		}else{
			widget.currentRow.IDFORMAPUREMPR = null;
		}
		if (widget.currentRow.NRCEPEMPR) {
			widget.currentRow.NRCEPEMPR = widget.currentRow.NRCEPEMPR.replace(/[^0-9]/g, '');
		}
		if(widget.currentRow.NRINSCESTA){
			widget.currentRow.NRINSCESTA = widget.currentRow.NRINSCESTA.replace(/[^a-zA-Z0-9]/g, '');
		}
		if (widget.isValid()) {
			if(this.verificaTamanhoCnpj(widget)){
				widget.currentRow.NRINSJUREMPR = widget.currentRow.NRINSJUREMPR.replace(/[^0-9]/g, '');
				Ger00200_Empresa_Service.concatenaCamposEmpresa(widget.currentRow);
				Ger00200_Empresa_Service.salvarNovaEmpresa(widget).then(
					function success() {
						this.controlaStatusWidgets(widget, 'EmpresaWidget', true);
						if (widget.currentRow.__is_new) {
							widget.list(true);
							ScreenService.goBack();
							widget.reload();
						} else {
							widget.view();
						}
					}.bind(this),
					function error(error) {
						if (error.data && error.data.error.indexOf('ORA-00001') !== -1) {
							ScreenService.showMessage(ScreenService.i18n("Inscrição já cadastrada."));
						} else if (error.data && error.data.error.indexOf('ORA-01400') !== -1) {
							ScreenService.showMessage(ScreenService.i18n("Existem campos em branco que precisam ser preenchidos."));
						} else if (error.data.error) {
							ScreenService.showMessage(ScreenService.i18n("Impossível adicionar. Código já existe."));
						} else {
							ScreenService.showMessage(ScreenService.i18n("Verifique sua conexão e tente novamente"));
						}
					}
				);	
			}
		}
	
		if(widget.currentRow.DSLOGOMARCA){
			let rowLogo = {
				"DSDIRLOGOMARCA" : dslogomarca,
				"CDEMPRESA" : 	widget.currentRow.CDEMPRESA
			};
			
			Ger00200_Empresa_Service.salvarLogo(rowLogo);
		}
	};

	this.salvarSignatario = function (widget) {
		widget.currentRow.CDEMPRESA = General.getFieldValue('CDEMPRESA', 'EmpresaWidget');
		widget.currentRow.NRCPFSIGESCSPED = widget.currentRow.NRCPFSIGESCSPED.replace(/[^0-9]/g, '');
		if (widget.isValid()) {
			widget.dataSource.name = 'cadFis#/crud/signatarios_empresa';
			widget.saveRow().then(
				function success(success) {
					ScreenService.goBack();
					widget.reload().then(function () {
						if (widget.isNewRow()) {
							widget.reload();
						}
					});
				widget.dataSource.name = 'cadFis#/signatarios_empresa';
				},
				function error(error) {
					console.log(error.data.error.indexOf('ORA-01400'));
					if (error.data && error.data.error.indexOf('ORA-00001') !== -1) {
						ScreenService.showMessage(ScreenService.i18n("Informação já cadastrada."));
					} else if (error.data && error.data.error.indexOf('ORA-01400') !== -1) {
						ScreenService.showMessage(ScreenService.i18n("Existem campos em branco que precisam ser preenchidos."));
					} else if (error.data.error) {
						ScreenService.showMessage(ScreenService.i18n(error.data.error));
					} else {
						ScreenService.showMessage(ScreenService.i18n("Verifique sua conexão e tente novamente"));
					}
				}
			);
		}
	};

	this.salvarParametrizacao = function(widget){
        General.saveCrud(widget).then(function(sucesso){
            var currentRow = widget.currentRow;
            widget.view();
            currentRow.__is_new = false;
            currentRow.changed = true;
            widget.template = widget.templateToView;
            widget.getAction('editarParametrizacao').isVisible = true;
        }.bind(this), function(callback){
            if(callback.data){
                ScreenService.showMessage(callback.data.error);
            }
        });
   };
	
	this.cancelar = function (widget) {
		for (var i in widget.backupRow) {
			widget.currentRow[i] = widget.backupRow[i];
		}
		widget.template = widget.templateToView;
		widget.view();
		widget.activate();
		widget.list();
	};

	this.buscaEndereco = function (row) {};

	this.validarCepEnd = function (args) {
		var widget = args.owner.owner.widget;
		var CEP = '';
		if (widget.name == 'EmpresaWidget') {
			CEP = widget.currentRow.NRCEPEMPR;
		}
		if (widget.name == 'widgetInscricaoEstadual') {
			CEP = widget.currentRow.NRCEPIEST;
		}
		if (widget.name == 'widgetInscricaoMunicipal') {
			CEP = widget.currentRow.NRCEPIMUN;
		}
		if (CEP) {
			Endereco.buscarCep(CEP).then(function (response) {
				var endereco = response.dataset.ENDERECO;
				if (endereco) {
					if (widget.name == 'EmpresaWidget') {
						widget.currentRow.NRCEPEMPR    = CEP;
						widget.currentRow.DSENDEEMPSEP = (endereco.DSENDERECO) ? endereco.DSENDERECO : '';
						widget.currentRow.NMBAIRRO     = (endereco.NMBAIRRO)   ? endereco.NMBAIRRO   : '';
					
					} else if (widget.name == 'widgetInscricaoEstadual') {
						widget.currentRow.NRCEPIEST     = CEP;
						widget.currentRow.DSENDEIESTSEP = (endereco.DSENDERECO) ? endereco.DSENDERECO            : '';
						widget.currentRow.NMBAIRIEST    = (endereco.NMBAIRRO)   ? endereco.NMBAIRRO.slice(0, 29) : '';
					
					} else if (widget.name == 'widgetInscricaoMunicipal') {
						widget.currentRow.NRCEPIMUN     = CEP;
						widget.currentRow.DSENDEIMUNSEP = (endereco.DSENDERECO) ? endereco.DSENDERECO : '';
						widget.currentRow.NMBAIRRO      = (endereco.NMBAIRRO)   ? endereco.NMBAIRRO   : '';
					}

					widget.currentRow.CDPAIS       = (endereco.CDPAIS)       ? endereco.CDPAIS : '';
					widget.currentRow.NMPAIS       = (endereco.NMPAIS)       ? endereco.NMPAIS : '';
					widget.currentRow.SGESTADO     = (endereco.SGESTADO)     ? endereco.SGESTADO : '';
					widget.currentRow.NMESTADO     = (endereco.NMESTADO)     ? endereco.NMESTADO : '';
					widget.currentRow.CDMUNICIPIO  = (endereco.CDMUNICIPIO)  ? endereco.CDMUNICIPIO : '';
					widget.currentRow.NMMUNICIPIO  = (endereco.NMMUNICIPIO)  ? endereco.NMMUNICIPIO : '';
					widget.currentRow.CDBAIRRO     = (endereco.CDBAIRRO)     ? endereco.CDBAIRRO : '';
					widget.currentRow.CDLOGRADOURO = (endereco.CDLOGRADOURO) ? endereco.CDLOGRADOURO : '';
					widget.currentRow.DSLOGRADOURO = (endereco.DSLOGRADOURO) ? endereco.DSLOGRADOURO : '';

					if (widget.name == 'EmpresaWidget') {
						this.verificaFieldOnChangePais(endereco);
					} else {
						if (widget.name == 'widgetInscricaoEstadual') {
							this.controlaVisibilidadeCampoPaisEstadoMunicipioBairro('widgetInscricaoEstadual');
						} else {
							this.controlaVisibilidadeCampoPaisEstadoMunicipioBairro('widgetInscricaoMunicipal');
						}
					}
				}
				if (response.dataset.ERRO) ScreenService.showMessage(response.dataset.ERRO.MESSAGE, "warning");
			}.bind(self));
		}
	};

	this.editarCadastro = function (args) {
		var widget = args.owner.widget;
		//widget.backupRow = angular.copy(widget.currentRow);
		General.edit(widget);
		widget.getField('NMESTADO').readOnly = false;
		widget.getField('NMMUNICIPIO').readOnly = false;
		widget.getField('NMBAIRRO').readOnly = false;
	};

	this.adicionar = function (args) {
		var widget = args.owner.widget;
		widget.newRow();
		widget.getField('NMESTADO').readOnly = true;
		widget.getField('NMMUNICIPIO').readOnly = true;
		widget.getField('NMBAIRRO').readOnly = true;
		this.controlaStatusWidgets(widget, 'EmpresaWidget', false);
	};

	this.limparValorPais = function () {
		var widget = templateManager.container.getActiveWidget();
		var pais = widget.getField('NMPAIS');
		if (pais.value()) {
			widget.getField('NMESTADO').setValue("");
			widget.getField('NMMUNICIPIO').setValue("");
			widget.getField('NMBAIRRO').setValue("");
			widget.getField('SGESTADO').setValue("");
			widget.getField('CDBAIRRO').setValue("");
			widget.getField('CDMUNICIPIO').setValue("");
			widget.getField('NMESTADO').readOnly = false;
			widget.getField('NMMUNICIPIO').readOnly = true;
			widget.getField('NMBAIRRO').readOnly = true;
			widget.getField('NMESTADO').reload();
		} else {
			widget.getField('NMESTADO').setValue("");
			widget.getField('NMMUNICIPIO').setValue("");
			widget.getField('NMBAIRRO').setValue("");
			widget.getField('SGESTADO').setValue("");
			widget.getField('CDBAIRRO').setValue("");
			widget.getField('CDMUNICIPIO').setValue("");
			widget.getField('NMESTADO').readOnly = true;
			widget.getField('NMMUNICIPIO').readOnly = true;
			widget.getField('NMBAIRRO').readOnly = true;
			widget.getField('NMESTADO').reload();
		}
	};

	this.limparValorEstado = function () {
		var widget = templateManager.container.getActiveWidget();
		var estado = widget.getField('NMESTADO');
		if (estado.value()) {
			widget.getField('NMMUNICIPIO').setValue("");
			widget.getField('NMBAIRRO').setValue("");
			widget.getField('CDBAIRRO').setValue("");
			widget.getField('CDMUNICIPIO').setValue("");
			widget.getField('NMMUNICIPIO').readOnly = false;
			widget.getField('NMBAIRRO').readOnly = true;
			widget.getField('NMMUNICIPIO').reload();
		} else {
			widget.getField('NMMUNICIPIO').setValue("");
			widget.getField('NMBAIRRO').setValue("");
			widget.getField('CDBAIRRO').setValue("");
			widget.getField('CDMUNICIPIO').setValue("");
			widget.getField('NMMUNICIPIO').readOnly = true;
			widget.getField('NMBAIRRO').readOnly = true;
			widget.getField('NMMUNICIPIO').reload();
		}
	};

	this.limparValorMunicipio = function () {
		var widget = templateManager.container.getActiveWidget();
		var municipio = widget.getField('NMMUNICIPIO');
		if (municipio.value()) {
			widget.getField('NMBAIRRO').setValue("");
			widget.getField('CDBAIRRO').setValue("");
			widget.getField('NMBAIRRO').readOnly = false;
			widget.getField('NMBAIRRO').reload();
		} else {
			widget.getField('NMBAIRRO').setValue("");
			widget.getField('CDBAIRRO').setValue("");
			widget.getField('NMBAIRRO').readOnly = true;
			widget.getField('NMBAIRRO').reload();
		}
	};

	this.verificaFieldOnChangePais = function (endereco) {
		var widget = templateManager.container.getWidget('EmpresaWidget');
		if (!endereco) {
			widget.getField('NMPAIS').setValue("");
			widget.getField('CDPAIS').setValue("");

			widget.getField('NMESTADO').readOnly = true;
			widget.getField('NMESTADO').setValue("");
			widget.getField('SGESTADO').setValue("");

			widget.getField('NMMUNICIPIO').readOnly = true;
			widget.getField('NMMUNICIPIO').setValue("");
			widget.getField('CDMUNICIPIO').setValue("");

			widget.getField('NMBAIRRO').readOnly = true;
			widget.getField('NMBAIRRO').setValue("");
			widget.getField('CDBAIRRO').setValue("");
		} else {
			var pais = endereco.NMPAIS;
			var estado = endereco.NMESTADO;
			var municipio = endereco.NMMUNICIPIO;
			if (!pais) {
				widget.getField('NMESTADO').readOnly = true;
				widget.getField('NMMUNICIPIO').readOnly = true;
				widget.getField('NMBAIRRO').readOnly = true;
			} else {
				if (!estado) {
					widget.getField('NMESTADO').readOnly = false;
					widget.getField('NMMUNICIPIO').readOnly = true;
					widget.getField('NMBAIRRO').readOnly = true;
				} else {
					widget.getField('NMESTADO').readOnly = false;
					if (!municipio) {
						widget.getField('NMMUNICIPIO').readOnly = false;
						widget.getField('NMBAIRRO').readOnly = true;
					} else {
						widget.getField('NMMUNICIPIO').readOnly = false;
						widget.getField('NMBAIRRO').readOnly = false;
					}
				}
			}
		}
	};

	this.controlaStatusWidgets = function (mainWidget, nomeWidgetAtual, status) {
		mainWidget.widgets.forEach(function (widg) {
			if (nomeWidgetAtual !== widg.name)
				widg.enabled = status;
		});

		if (mainWidget.name !== nomeWidgetAtual)
			mainWidget.enabled = status;
	};

	this.verficaTipoempresa = function (args) {
		var widget = templateManager.container.getWidget('EmpresaDadosAdicionaisWidget');
		if (widget.currentRow.IDTIPOEMPR !== '3') {
			widget.getField('IDOPTSIMPLES').readOnly = false;
			if (widget.currentRow.IDTIPOEMPR === null) {
				widget.getField('IDOPTSIMPLES').readOnly = true;
				widget.getField('IDOPTSIMPLES').setValue("");
			}
		} else {
			widget.getField('IDOPTSIMPLES').readOnly = true;
			widget.getField('IDOPTSIMPLES').setValue("");
		}
	};

	this.criaCampoRegimeApuracao = function (args) {
		var widget = args.owner.widget;
		widget.currentRow.valorInicialRegimeApuracao = widget.currentRow.IDCUMUPICOEMP;
	};

	this.controlaVisibilidadeCampoPaisEstadoMunicipioBairro = function (nomeWidget) {
		var widget = templateManager.container.getWidget(nomeWidget);
		var pais = widget.getField('NMPAIS');
		var estado = widget.getField('NMESTADO');
		var municipio = widget.getField('NMMUNICIPIO');
		var bairro = '';
		if (widget.name == 'widgetInscricaoMunicipal') {
			bairro = widget.getField('NMBAIRRO');
		} else {
			bairro = widget.getField('NMBAIRIEST');
		}
		if (widget.currentRow.NMPAIS) {
			estado.readOnly = false;
			municipio.readOnly = true;
			bairro.readOnly = true;
			if (widget.currentRow.NMESTADO) {
				municipio.readOnly = false;
				bairro.readOnly = true;
				if (widget.currentRow.NMMUNICIPIO) {
					bairro.readOnly = false;
				} else {
					bairro.readOnly = true;
				}
			} else {
				municipio.readOnly = true;
				bairro.readOnly = true;
			}
		} else {
			estado.readOnly = true;
			municipio.readOnly = true;
			bairro.readOnly = true;
		}
	};

	this.controlaValorCampoPaisEstadoMunicipioBairro = function (nomeCampoAtual, nomeWidget) {
		var widget = templateManager.container.getWidget(nomeWidget);
		var pais = widget.getField('NMPAIS');
		var estado = widget.getField('NMESTADO');
		var municipio = widget.getField('NMMUNICIPIO');
		var bairro = '';
		if (widget.name == 'widgetInscricaoMunicipal') {
			bairro = widget.getField('NMBAIRRO');
		} else {
			bairro = widget.getField('NMBAIRIEST');
		}
		switch (nomeCampoAtual) {
		case 'Pais':

			widget.currentRow.SGESTADO = null;
			estado.setValue("");
			estado.reload();

			widget.currentRow.CDMUNICIPIO = null;
			municipio.setValue("");
			municipio.reload();

			widget.currentRow.CDBAIRRO = null;
			bairro.setValue("");
			bairro.reload();
			break;
		case 'Estado':

			widget.currentRow.CDMUNICIPIO = null;
			municipio.setValue("");
			municipio.reload();

			widget.currentRow.CDBAIRRO = null;
			bairro.setValue("");
			bairro.reload();
			break;
		case 'Municipio':

			widget.currentRow.CDBAIRRO = null;
			bairro.setValue("");
			bairro.reload();
			break;
		default:
			break;
		}
	};

	this.recarregarCampo = function (nomeWidget, nomeCampo) {
		var widget = templateManager.container.getWidget(nomeWidget);
		widget.getField(nomeCampo).reload();
	};

	this.recarregarWidget = function (nomeWidget) {
		var widget = templateManager.container.getWidget(nomeWidget);
		widget.reload();
	};
	
	

	this.saveIncricao = function (widget) {
		if (widget.isValid()) {
			widget.currentRow.CDINSCESTA = widget.currentRow.CDINSCESTA.replace(/[^a-zA-Z0-9]/g, '');
			if (widget.currentRow.__is_new) {
				var widgetEmpresa = templateManager.container.getWidget('EmpresaWidget');
				widget.currentRow.CDEMPRESA = widgetEmpresa.currentRow.CDEMPRESA;
			}
			if (widget.currentRow.NRINSJURIEST) {
				widget.currentRow.NRINSJURIEST = widget.currentRow.NRINSJURIEST.replace(/[^0-9]/g, '');
			}
			if (widget.currentRow.NRCEPIEST) {
				widget.currentRow.NRCEPIEST = widget.currentRow.NRCEPIEST.replace(/[^0-9]/g, '');
			}
			if (!widget.currentRow.DSDIRCERTIFICADO) {
				widget.currentRow.DSDIRCERTIFICADO = [];
			}
			Ger00200_Empresa_Service.concatenaCamposInscricaoEstadual(widget.currentRow);
			Ger00200_Empresa_Service.salvarInscricao(widget).then(function (Success) {
					widget.currentRow.DSDIRCERTIFICADO = null;
					widget.getAction('abrirParametrizacao').isVisible = true;
					widget.activate();
					if (widget.currentRow.__is_new) {
						widget.list(true);
						ScreenService.goBack();
						widget.reload().then(function () {});
					} else {
						widget.view();
					}
				}.bind(this),
				function (callback) {
					if (callback.data) {
						ScreenService.showMessage(callback.data.error);
					}
				});
		}
		
		widget.reload();
		
		
	};

	this.salvarInscricaoMunicipal = function (args) {
		var widgetEmpresa = templateManager.container.getWidget('EmpresaWidget');
		var widget = args.owner.widget;
		if (widget.isValid()) {
			widget.currentRow.CDINSCMUNI = widget.currentRow.CDINSCMUNI.replace(/[^a-zA-Z0-9]/g, '');
			if (widget.currentRow.__is_new) {
				widget.currentRow.CDEMPRESA = widgetEmpresa.currentRow.CDEMPRESA;
				widget.currentRow.CDFILIAL = '';
			}
			if (widget.currentRow.NRINSJURIMUNI) {
				widget.currentRow.NRINSJURIMUNI = widget.currentRow.NRINSJURIMUNI.replace(/[^0-9]/g, '');
			}
			if (widget.currentRow.NRCEPIMUN) {
				widget.currentRow.NRCEPIMUN = widget.currentRow.NRCEPIMUN.replace(/[^0-9]/g, '');
			}
			Ger00200_Empresa_Service.concatenaCamposInscricaoMunicipal(widget.currentRow);
			//widget.dataSource.name = 'cadFis#/crud/inscrmunicip_completa';
			General.saveCrud(widget).then(function (Success) {
				//widget.dataSource.name = 'cadFis#/inscrmunicip_completa';
			},
			function (callback) {
				if (callback.data) {
					ScreenService.showMessage(callback.data.error);
				}
			});
		}
	};

	this.checkNumeroDeInscricao = function (field) {
		var validatedInscricao = Ger00200_Empresa_Service.validateNumeroDeInscricao(field.widget.currentRow[field.descriptionField]);
		var widget = field.widget;

		if (validatedInscricao.valid) {
			//if input is valid, builds unformatted data to save
			switch (validatedInscricao.tipo.cod) {
			case 'O': //Código genérico
				validatedInscricao.rawValue = General.fill(validatedInscricao.parameter, 5);
				break;
			case 'I': //Inscrição genérica
				validatedInscricao.rawValue = General.fill(validatedInscricao.parameter, 20);
				break;
			default: //CPF && CNPJ
				validatedInscricao.rawValue = validatedInscricao.parameter;
			}

			//sets data in the currentRow
			if (widget.name == 'widgetInscricaoEstadual') {
				widget.currentRow.IDTPIJURIEST = validatedInscricao.tipo.cod;

			}
			if (widget.name == 'EmpresaWidget') {
				widget.currentRow.IDTPIJUREMPR = validatedInscricao.tipo.cod;
			}
			widget.currentRow[field.valueField] = validatedInscricao.rawValue;
			widget.currentRow[field.descriptionField] = validatedInscricao.value;
		} else {
			//if message exists, throws warning popup
			if (validatedInscricao.error.msg)
				ScreenService.showMessage(validatedInscricao.error.msg, "warning");

			//cleans data
			widget.currentRow[field.valueField] = null;
			widget.currentRow[field.descriptionField] = null;
		}
	};
	
	this.visibilidadeAction = function (widget, nomeAction, visibilidade) {
		var action = widget.getAction(nomeAction);
		action.isVisible = visibilidade;
	};

	this.setarNomeCertificado = function (widget) {
		//var certificado = widget.getField('CERTIFICADO');
		if (widget.currentRow.DSDIRCERTIFICADO) {
			if (widget.currentRow.DSDIRCERTIFICADO.length === 0) {
				widget.currentRow.NMCERTIFICADO = null;
			} else {
				var nomeCertificado = widget.currentRow.DSDIRCERTIFICADO[0].name;
				var pos = nomeCertificado.indexOf('.');
				var maxlength = widget.getField('NMCERTIFICADO').maxlength;
				nomeCertificado = nomeCertificado.substring(0, pos);
				if(nomeCertificado.length <= maxlength){
					widget.currentRow.NMCERTIFICADO = nomeCertificado;	
				}else{
					ScreenService.showMessage('Nome do arquivo grande demais. Por favor insira um arquivo com nome de até '+maxlength+' caracteres.', "error");
					widget.getField('DSDIRCERTIFICADO').setValue([]);
					widget.getField('DSDIRCERTIFICADO').reload();
					templateManager.updateTemplate();
				}
				
			}
		}
		this.controlaCampoSenha(widget);
	};

	this.controlaCampoSenha = function (widget) {
		var campoNome = widget.getField('NMCERTIFICADO');
		var campoSenha = widget.getField('CDSENHACERTIF');

		if (campoNome.value()) {
			campoSenha.readOnly = false;
		} else {
			campoSenha.readOnly = true;
			campoSenha.setValue("");
		}
	};

	this.validarCpnjInscricaoMunicipal = function (widget) {
		var cnpjFormantado = widget.currentRow.NRINSJURIMUNI;
		if (cnpjFormantado) {
			var cnpj = widget.currentRow.NRINSJURIMUNI.replace(/[^0-9]/g, '');
			if (!General.validateCNPJ(cnpj)) {
				MessageService.showMessageByCode("INSCRICAO_INVALIDA", {"CNPJ": cnpjFormantado});
				widget.currentRow.NRINSJURIMUNI = null;
			}
		}
	};
	
	this.cancel = function(args, widget){
        General.backOrCancel(args);
        widget.template = "widget/form-view.html";
		widget.list();
		
    };
    
    this.validaEmail = function(widget, nomeWidgetAtual){
    	var email = templateManager.container.getWidget('widgetParametrizacaoDFE').getField('DSEMAILCCNFE').value();
    	if(email){
    		var ponto = '.com';
    		var arroba = '@';
	    	if((email.search(ponto) == -1) || (email.search(arroba) == -1) || (email.search(ponto) < email.search(arroba))){
	    		ScreenService.showMessage("Informe um email válido no campo 'Cc'");
	    		templateManager.container.getWidget('widgetParametrizacaoDFE').getField('DSEMAILCCNFE').setValue("");
	    	}else{
	    		this.salvar(widget, nomeWidgetAtual);
	    	}
    	}else{
    		this.salvar(widget, nomeWidgetAtual);
    	}
    };
    
    self.retiraPontuacao = function(widget){
    	widget.currentRow.CDINSCESTA = widget.currentRow.CDINSCESTA.replace(/[^a-zA-Z0-9]/g, '_');
    };
    
    self.setNrorg = function(widget){
    	widget.currentRow.NRORG = getLocalVar('NRORG');	
    };
    
    this.verificaTamanhoCnpj = function(widget){
    	if(widget.currentRow.NRINSJUREMPR){
    		widget.currentRow.NRINSJUREMPR = widget.currentRow.NRINSJUREMPR.replace(/[^0-9]/g, '');
    		if(widget.currentRow.NRINSJUREMPR.length > 14){
    			ScreenService.showMessage("CNPJ inválido!");
    			return false;
    		}
    	}
    	return true;
    };
    
    self.setShortCutKey = function(widget){
    	var actions = widget.actions;
    	
    	widget.getParent().actions.forEach(function(result){
			if(result.name == "ADD"){
				result.shortcutKey = "";
		        result.tooltip = "";
			}
			if(result.name == "EDITAR"){
				result.shortcutKey = "";
				result.tooltip = "";
			}
			if(result.name == "DELETAR"){
				result.shortcutKey = "";
				result.tooltip = "";
			}
		});
		
		actions.forEach(function(result){
			if(result.name == "ADD"){
				result.shortcutKey = "f2";
		        result.tooltip = "Adicionar (F2)";
			}
			if(result.name == "EDITAR"){
				result.shortcutKey = "f3";
				result.tooltip = "Editar (F3)";
			}
			if(result.name == "DELETAR"){
				result.shortcutKey = "mod+d";
				result.tooltip = "Ctrl + D";
			}
		});
		
		widget.reload();
    };
    
    this.setarNomeLogo = function (widget) {
		//var certificado = widget.getField('CERTIFICADO');
		if (widget.currentRow.DSLOGOMARCA) {
			if (widget.currentRow.DSLOGOMARCA.length === 0) {
				widget.currentRow.DSARQLOGOEMP = null;
			} else {
				var nomeLogo = widget.currentRow.DSLOGOMARCA[0].name;
				var pos = nomeLogo.indexOf('.');
				nomeLogo = nomeLogo.substring(0, pos);
				widget.currentRow.DSARQLOGOEMP = nomeLogo;
			}
		}
	};
	
	this.openHistCronDfe = () => {
		ScreenService.openWindow('cadFis#dfs53300_historico_cronograma_dfe');
	};
};



Configuration(function (ContextRegister) {
	ContextRegister.register('Ger00200_Empresa_Controller', Ger00200_Empresa_Controller);
});

// FILE: ./assets/js/controllers/Ger00250_ParametrizacaoInscricaoEstadual_Controller.js
var Ger00250_ParametrizacaoInscricaoEstadual_Controller = function (ZhFilterPreferences, Ger00250_ParametrizacaoInscricaoEstadual_Service, ScreenService, General, templateManager, localStorageEngine, Endereco, LibUtilities){

	var self = this;

	this.validateFiltroInscricaoEstadual = function(widget){
		var popup = widget.appliedFilter.FILTER_ROW;
		widget.dataSourceFilter = [
			{
                "name": "CDEMPRESA",
                "operator": "=",
                "value": popup.CDEMPRESA
            }
		];
	};
	
	this.abreCritCalc = function(widget){
		sessionStorage.setItem("CritCalc", true);
		LibUtilities.openWindow("cadCtb#ctb92200_padrao_rateio_ajustes_apuracao");
		//LibUtilities.openWindow()
	};
	
	this.abreFormulaCalc = function(widget){
		LibUtilities.openWindow("cadFis#fis94500_formula_ajuste_fiscal");
		//LibUtilities.openWindow()
	};
	
	this.editarParametrosGerais = function (widget) {
		this.controlarCampoEncargo(widget);
		this.verificaVigencia(widget);
		this.editar(widget);
		
	};

	this.controlarCampoFiltro = function (args) {
		var widget = args.owner.owner.widget;
		var empresa = widget.getField('NMEMPRESA');
		var inscricao = widget.getField('CDINSCESTA');
		inscricao.setValue("");
		if (empresa.value()) {
			inscricao.readOnly = false;
		} else {
			inscricao.readOnly = true;
		}
	};

	this.controlaStatusWidgets = function (mainWidget, nomeWidgetAtual, status) {
		if(mainWidget && mainWidget.widgets){
    		mainWidget.widgets.forEach(function (widg) {
    			if (nomeWidgetAtual !== widg.name)
    				widg.enabled = status;
    		});
		}
		if (mainWidget && mainWidget.name !== nomeWidgetAtual)
			mainWidget.enabled = status;
	};

	this.WidgetOnEnter = function (args, widget) {
		args.owner.currentRow = args.owner.dataSource.data[0];
	};

	this.editar = function (widget) {
		widget.template = widget.templateToForm;
		General.edit(widget);
		var widgetPrincipal = templateManager.container.getWidget('gridInscricaoEstadual');
		var widgetRegimeEspecial = templateManager.container.getWidget('tabbedRegimeEspecialTributacao');
		var widgetAjusteApuracao = templateManager.container.getWidget('tabbedAjusteApuracao');
		if (widget.name == 'tabbedCargaTributaria') {
			self.controlaStatusWidgets(widgetPrincipal, widgetRegimeEspecial.name, false);
			self.controlaStatusWidgets(widgetRegimeEspecial, widget.name, false);
			self.controlaCargaTributaria(widget);
			widgetRegimeEspecial.enabled = true;
		} else if (widget.name == 'gridApuracao') {
			var widgetPresumido = templateManager.container.getWidget('tabbedCreditoPresumido');
			self.controlaStatusWidgets(widgetPrincipal, widgetRegimeEspecial.name, false);
			self.controlaStatusWidgets(widgetRegimeEspecial, widgetPresumido.name, false);
			self.controlaStatusWidgets(widgetPresumido, widget.name, false);
			widgetRegimeEspecial.enabled = true;
			widgetPresumido.enabled = true;
			widget.enabled = true;
		} else if(widget.name == 'gridDiferimento'){
			var widgetDiferimento = templateManager.container.getWidget('tabbedDiferimentoAntecipado');
			self.controlaStatusWidgets(widgetPrincipal, widgetRegimeEspecial.name, false);
			self.controlaStatusWidgets(widgetRegimeEspecial, widgetDiferimento.name, false);
			self.controlaStatusWidgets(widgetDiferimento, widget.name, false);
			widgetRegimeEspecial.enabled = true;
			widgetDiferimento.enabled = true;
			widget.enabled = true;
		} else if ( (widget.name == 'PortariaCAT') || (widget.name == 'compRessarcICMSST') ) {
			self.controlaStatusWidgets(widgetPrincipal, widgetAjusteApuracao.name, false);
			self.controlaStatusWidgets(widgetAjusteApuracao, widget.name, false);
			widgetAjusteApuracao.enabled = true;
			widget.enabled = true;
		} else if(widget.name == 'DiferencialAliq'){
			var widgettabbedDiferencialAliq = templateManager.container.getWidget('tabbedDiferencialAliq');
			self.controlaStatusWidgets(widgetPrincipal, widgetAjusteApuracao.name, false);
			self.controlaStatusWidgets(widgetAjusteApuracao, widget.name, false);
			self.controlaStatusWidgets(widgettabbedDiferencialAliq, widget.name, false);
			widgetAjusteApuracao.enabled = true;
			widgettabbedDiferencialAliq.enabled = true;
			widget.enabled = true;
		} else {
			self.controlaStatusWidgets(widgetPrincipal, widget.name, false);
		}
		widget.reload();
	};

	this.cancelar = function (widget) {
		for (var i in widget.backupRow) {
			widget.currentRow[i] = widget.backupRow[i];
		}
		widget.template = widget.templateToView;
		widget.view();
		widget.activate();
		
		var widgetPrincipal = templateManager.container.getWidget('gridInscricaoEstadual');
		var widgetRegimeEspecial = templateManager.container.getWidget('tabbedRegimeEspecialTributacao');
		var widgetAjusteApuracao = templateManager.container.getWidget('tabbedAjusteApuracao');
		if (widget.name == 'gridApuracao') {
			var widgetPresumido = templateManager.container.getWidget('tabbedCreditoPresumido');
			self.controlaStatusWidgets(widgetPrincipal, widgetRegimeEspecial.name, true);
			self.controlaStatusWidgets(widgetRegimeEspecial, widgetPresumido.name, true);
			self.controlaStatusWidgets(widgetPresumido, widget.name, true);
		} else if(widget.name == 'gridDiferimento') {
			var widgetDiferimento = templateManager.container.getWidget('tabbedDiferimentoAntecipado');
			self.controlaStatusWidgets(widgetPrincipal, widgetRegimeEspecial.name, true);
			self.controlaStatusWidgets(widgetRegimeEspecial, widgetDiferimento.name, true);
			self.controlaStatusWidgets(widgetDiferimento, widget.name, true);
		} else if(widget.name == 'tabbedCargaTributaria'){
			self.controlaStatusWidgets(widgetPrincipal, widgetRegimeEspecial.name, true);
			self.controlaStatusWidgets(widgetRegimeEspecial, widget.name, true);
		} else if ( (widget.name == 'PortariaCAT') || (widget.name == 'compRessarcICMSST') ) {
				self.controlaStatusWidgets(widgetPrincipal, widgetAjusteApuracao.name, true);
				self.controlaStatusWidgets(widgetAjusteApuracao, widget.name, true);
		} else if(widget.name == 'DiferencialAliq'){
			var widgettabbedDiferencialAliq = templateManager.container.getWidget('tabbedDiferencialAliq');
			self.controlaStatusWidgets(widgetPrincipal, widgetAjusteApuracao.name, true);
			self.controlaStatusWidgets(widgetAjusteApuracao, widget.name, true);
			self.controlaStatusWidgets(widgettabbedDiferencialAliq, widget.name, true);
		} else {	
			self.controlaStatusWidgets(widgetPrincipal, widget.name, true);
		}
	};

	this.recarregarWidgets = function (args) {
		var widget = args.owner;
		widget.widgets.forEach(function (widg) {
			if (widg.widgets) {
				widg.widgets.forEach(function (widgFilhas) {
					widgFilhas.reload();
				});
			}
			widg.reload();
		});
	};

	this.controlarCampoEncargo = function (widget) {
		var campoVerifica = widget.getField('IDSUGREGSTENTR');
		var campoEncargo = widget.getField('NMENCARGO');
		if (campoVerifica.value() == 'S') {
			campoEncargo.readOnly = false;
		} else {
			campoEncargo.setValue("");
			widget.currentRow.CDENCARGOST = null;
			campoEncargo.readOnly = true;
		}
		campoEncargo.reload();
		campoVerifica.reload();
	};

	this.verificaVigencia = function (widget) {
		var dateInicial = widget.getField('DTINIVIGIEST');
		var dateFinal = widget.getField('DTFIMVIGIEST');
		dateFinal.minDate = dateInicial.value();
		dateInicial.maxDate = dateFinal.value();
	};

	this.salvar = function (args) {
		var widgetPrincipal = templateManager.container.getWidget('gridInscricaoEstadual');
		var widgetRegimeEspecial = templateManager.container.getWidget('tabbedRegimeEspecialTributacao');
		var widgetAjusteApuracao = templateManager.container.getWidget('tabbedAjusteApuracao');
		var widget = args.owner.widget;
		
		widget.currentRow.CDEMPRESA = widgetPrincipal.currentRow.CDEMPRESA;
		widget.currentRow.CDINSCESTA = 	widgetPrincipal.currentRow.CDINSCESTA;
		
		if (widget.name == 'compRessarcICMSST'){
			if (widget.currentRow.VRALIQINTERNA && widget.currentRow.VRALIQINTERNA.length && widget.currentRow.VRALIQINTERNA < 100.00){
				var aliquota = widget.currentRow.VRALIQINTERNA.replace(',','.');
				widget.currentRow.VRALIQINTERNA = aliquota;
			}else {
					ScreenService.showMessage('Valor inválido!');
			}
		}
		if (widget.currentRow.__is_new) {
			General.saveCrud(widget).then(function (Success) {
			//	widget.template = widget.templateToView;
				
			//	if((widget.name == 'ParamCFOP') || (widget.name == 'widgetFECP')){
			//		if(widget.currentRow.__is_new){
			//			widget.list();
			//		} else {
			//			widget.view();
			//		}
			//	} else {
			//		widget.view();
			//	}
				
				widget.currentRow.__is_new = false;
				widget.currentRow.changed = false;
				widget.reload();
				
				if (widget.name == 'gridApuracao') {
					var widgetPresumido = templateManager.container.getWidget('tabbedCreditoPresumido');
					self.controlaStatusWidgets(widgetPrincipal, widgetRegimeEspecial.name, true);
					self.controlaStatusWidgets(widgetRegimeEspecial, widgetPresumido.name, true);
					self.controlaStatusWidgets(widgetPresumido, widget.name, true);
				} else if(widget.name == 'gridDiferimento') {
					var widgetDiferimento = templateManager.container.getWidget('tabbedDiferimentoAntecipado');
					self.controlaStatusWidgets(widgetPrincipal, widgetRegimeEspecial.name, true);
					self.controlaStatusWidgets(widgetRegimeEspecial, widgetDiferimento.name, true);
					self.controlaStatusWidgets(widgetDiferimento, widget.name, true);
				} else if(widget.name == 'tabbedCargaTributaria'){
					self.controlaStatusWidgets(widgetPrincipal, widgetRegimeEspecial.name, true);
					self.controlaStatusWidgets(widgetRegimeEspecial, widget.name, true);
				} else if ( (widget.name == 'PortariaCAT') || (widget.name == 'compRessarcICMSST') ) { 
					self.salvaPortariaCAT(widget).then(function(data){
    					self.controlaStatusWidgets(widgetPrincipal, widgetAjusteApuracao.name, true);
    					self.controlaStatusWidgets(widgetAjusteApuracao, widget.name, true);
					});
				} else if(widget.name == 'DiferencialAliq'){
					var widgettabbedDiferencialAliq = templateManager.container.getWidget('tabbedDiferencialAliq');
					self.controlaStatusWidgets(widgetPrincipal, widgetAjusteApuracao.name, true);
					self.controlaStatusWidgets(widgetAjusteApuracao, widget.name, true);
					self.controlaStatusWidgets(widgettabbedDiferencialAliq, widget.name, true);
				} else {
					self.controlaStatusWidgets(widgetPrincipal, widget.name, true);
				}
				self.aposSalvar(widget);
				//widget.list();
			}.bind(this), function (callback) {
				if (callback.data) {
					ScreenService.showMessage(callback.data.error);
				}
			});
		
		}else{
			General.saveCrud(widget).then(function (Success) {
			//	widget.template = widget.templateToView;
				
			//	if((widget.name == 'ParamCFOP') || (widget.name == 'widgetFECP')){
			//		if(widget.currentRow.__is_new){
			//			widget.list();
			//		} else {
			//			widget.view();
			//		}
			//	} else {
			//		widget.view();
			//	}
				
				widget.currentRow.__is_new = false;
				widget.currentRow.changed = false;
				widget.reload();
				
				if (widget.name == 'gridApuracao') {
					var widgetPresumido = templateManager.container.getWidget('tabbedCreditoPresumido');
					self.controlaStatusWidgets(widgetPrincipal, widgetRegimeEspecial.name, true);
					self.controlaStatusWidgets(widgetRegimeEspecial, widgetPresumido.name, true);
					self.controlaStatusWidgets(widgetPresumido, widget.name, true);
				} else if(widget.name == 'gridDiferimento') {
					var widgetDiferimento = templateManager.container.getWidget('tabbedDiferimentoAntecipado');
					self.controlaStatusWidgets(widgetPrincipal, widgetRegimeEspecial.name, true);
					self.controlaStatusWidgets(widgetRegimeEspecial, widgetDiferimento.name, true);
					self.controlaStatusWidgets(widgetDiferimento, widget.name, true);
				} else if(widget.name == 'tabbedCargaTributaria'){
					self.controlaStatusWidgets(widgetPrincipal, widgetRegimeEspecial.name, true);
					self.controlaStatusWidgets(widgetRegimeEspecial, widget.name, true);
				} else if ( (widget.name == 'PortariaCAT') || (widget.name == 'compRessarcICMSST') ) {
					self.salvaPortariaCAT(widget).then(function(data){
    					self.controlaStatusWidgets(widgetPrincipal, widgetAjusteApuracao.name, true);
    					self.controlaStatusWidgets(widgetAjusteApuracao, widget.name, true);
					});
				} else if(widget.name == 'DiferencialAliq'){
					var widgettabbedDiferencialAliq = templateManager.container.getWidget('tabbedDiferencialAliq');
					self.controlaStatusWidgets(widgetPrincipal, widgetAjusteApuracao.name, true);
					self.controlaStatusWidgets(widgetAjusteApuracao, widget.name, true);
					self.controlaStatusWidgets(widgettabbedDiferencialAliq, widget.name, true);
				} else {
					self.controlaStatusWidgets(widgetPrincipal, widget.name, true);
				}
				
				//widget.list();
				self.aposSalvar(widget);
			}.bind(this), function (callback) {
				if (callback.data) {
					ScreenService.showMessage(callback.data.error);
				}
			});
		}
	};
	
	this.aposSalvar = function (widget) {
		widget.reload();
		widget.template = widget.templateToView;
		widget.view();
		widget.activate();
		
		if (widget.name == 'tabbedParametrosGerais'){
			var utiliza = widget.getField('IDUTSERECFNF');
			var cupom = widget.getField('IDUTNRCUPOMNF');
			var sujeito = widget.getField('IDSUGREGSTENTR');
			var encargo = widget.getField('NMENCARGO');
			var inicial = widget.getField('DTINIVIGIEST');
			var final = widget.getField('DTFIMVIGIEST');
			
			utiliza.reload();
			cupom.reload();
			sujeito.reload();
			encargo.reload();
			inicial.reload();
			final.reload();
			widget.reload();
			widget.redraw();
		}
		if(widget.name == 'tabbedCargaTributaria'){
			var DSOUTDEBICARGA = widget.getField('DSOUTDEBICARGA');
			var CDAJSTDEBICARGA = widget.getField('CDAJSTDEBICARGA');
			var DSOUTCREDCARGA = widget.getField('DSOUTCREDCARGA');
			var CDAJSTCREDCARGA = widget.getField('CDAJSTCREDCARGA');
			var IDCARGA = widget.getField('IDCARGA');
			var IDUTCARGATRIB = widget.getField('IDUTCARGATRIB');
				DSOUTDEBICARGA.reload();
				CDAJSTDEBICARGA.reload();
				DSOUTCREDCARGA.reload();
				CDAJSTCREDCARGA.reload();
				IDCARGA.reload();
				IDUTCARGATRIB.reload();
		}
		
		widget.reload();
		templateManager.updateTemplate();
	};
	
	this.salvaPortariaCAT = function(widget){
	    widget.dataSource.name = "cadFis#/inscrestad_completa";
	    return General.saveCrud(widget).then(function (Success) {
	        widget.dataSource.name = "cadFis#/crud/inscrestad_paramestsped";
	        return widget.reload();
	    });
	};
	
	
	this.salvarMensagem = function (args) {
		var widgetPrincial = templateManager.container.getWidget('gridInscricaoEstadual');
		var widget = args.owner.widget;
		if (widget.currentRow.__is_new) {
			widget.currentRow.CDINSCESTA = widgetPrincial.currentRow.CDINSCESTA;
			widget.currentRow.CDEMPRESA = widgetPrincial.currentRow.CDEMPRESA;
		}
			if (widget.isValid()) {
				Ger00250_ParametrizacaoInscricaoEstadual_Service.salvarMensagem(widget.currentRow).then(function (Success) {
					widget.activate();
					if (widget.currentRow.__is_new) {
						widget.list(true);
						ScreenService.goBack();
						widget.reload().then(function () {});
					} else {
						widget.view();
					}
				}.bind(this), function (callback) {
					if (callback.data) {
						ScreenService.showMessage(callback.data.error);
					}
				});
			}
	};
	
	this.salvardiferencial = function (args) {
		var widgetPrincipal = templateManager.container.getWidget('gridInscricaoEstadual');
		var widgetAjusteApuracao = templateManager.container.getWidget('tabbedAjusteApuracao');
		var widget = args.owner.widget;
		
		widget.currentRow.CDEMPRESA = widgetPrincipal.currentRow.CDEMPRESA;
		widget.currentRow.CDINSCESTA = 	widgetPrincipal.currentRow.CDINSCESTA;

		Ger00250_ParametrizacaoInscricaoEstadual_Service.saveDiferncialAliquota(widget.currentRow).then(function (Success) {

			widget.currentRow.__is_new = false;
			widget.currentRow.changed = false;
			widget.reload();
			
			if(widget.name == 'DiferencialAliq'){
				var widgettabbedDiferencialAliq = templateManager.container.getWidget('tabbedDiferencialAliq');
				self.controlaStatusWidgets(widgetPrincipal, widgetAjusteApuracao.name, true);
				self.controlaStatusWidgets(widgetAjusteApuracao, widget.name, true);
				self.controlaStatusWidgets(widgettabbedDiferencialAliq, widget.name, true);
			} else {
				self.controlaStatusWidgets(widgetPrincipal, widget.name, true);
			}
			
			//widget.list();
		}.bind(this), function (callback) {
			if (callback.data) {
				ScreenService.showMessage(callback.data.error);
			}
		});
		
			widget.reload();
			widget.template = widget.templateToView;
			widget.view();
			widget.activate();
	};
	
	this.verificaTipoOperacao = function (widget) {
		var campoVerificaTipoOpercao = widget.getField('IDTIPOOPERCREDP');
		var campoTipoOperacao = widget.getField('CDTIPOPERCREDP');
		var campoCodigo = widget.currentRow.CDTIPOOPER;
		var campoES = widget.currentRow.IDENTRSAIDOP;
		if (campoVerificaTipoOpercao.value() !== 'L') {
			campoTipoOperacao.readOnly = true;
			campoTipoOperacao.setValue("");
			campoTipoOperacao.reload();
			if (campoCodigo) {
				campoCodigo.splice(0, campoCodigo.length);
			}
			if (campoES) {
				campoES.splice(0, campoES.length);
			}
			delete(campoTipoOperacao.validations.required);
		} else {
			campoTipoOperacao.readOnly = false;
			campoTipoOperacao.validations.required = true;
			campoTipoOperacao.reload();
		}
	};
	
	this.afterLoadDataSourceCreditoPresumido = function (args) {
		var CDTIPOOPER   = [];
		var IDENTRSAIDOP = [];
		
			if (args.dataSource.length > 0){
				if (args.dataSource[0].CDTIPOPERCREDP != null) {
					var arr = args.dataSource[0].CDTIPOPERCREDP.split('_');
					arr.shift();
					arr.pop();
					
					for( var i = 0; i < arr.length; ++i ) {
						IDENTRSAIDOP.push( arr[i].substr(0,1) );
						CDTIPOOPER.push(   arr[i].substr(1,2) );
					}
					
					args.dataSource[0].CDTIPOOPER   = CDTIPOOPER;
					args.dataSource[0].IDENTRSAIDOP = IDENTRSAIDOP;
					args.dataSource[0].CDTIPOPERCREDP = "";
				}
			}
			this.WidgetOnEnter(args);
		};

	this.afterLoadDataSourceCargatributaria = function (args) {
		this.WidgetOnEnter(args);
	};
	
	this.validaSalvarEstornoApuracao = function (args) {
    	var widget = args.owner.widget;
    	
    	if (widget.isValid()) {
    		widget.currentRow.__is_new = false;
    		widget.currentRow.CDEMPRESA = templateManager.container.getWidget('gridInscricaoEstadual').currentRow.CDEMPRESA;
    		widget.currentRow.CDINSCESTA = templateManager.container.getWidget('gridInscricaoEstadual').currentRow.CDINSCESTA;
    		if(widget.currentRow.IDREALIESTAPUR == 'N'){
    		    self.salvarEstornoApuracao(args);
    		}else{
        	     //validar aliquota 
        		if (this.validaAliquotaInterna(widget, 'VRALIQEFETIVA')) {
        		    //validar aliquota 2
        		    if (this.validaAliquotaInterna(widget, 'VRALIQINTERNA')){
        		        if (widget.currentRow.VRALIQEFETIVA < widget.currentRow.VRALIQINTERNA){
                		    self.salvarEstornoApuracao(args);
        		        }else{
        		            ScreenService.showMessage('Valor da Alíquota Efetiva deve ser menor que a Alíquota Interna do estado.');
        		        }
        		    }
        		}
    		}
    	}    
	};
    
    this.salvarEstornoApuracao = function (args) {
	    var widgetPrincipal = templateManager.container.getWidget('gridInscricaoEstadual');
    	var widget = args.owner.widget;
    	
	    Ger00250_ParametrizacaoInscricaoEstadual_Service.concatenaCampoTipoOperacao(widget.currentRow, 'CDTPOPERESTAPUR', 'CDTPOPERESTAPUR', 'IDENTRSAIDOP');
	    widget.currentRow.CDCFOPESTAPUR = !widget.currentRow.CDCFOPESTAPUR ? '' : !widget.currentRow.CDCFOPESTAPUR.length ? '' : !Array.isArray(widget.currentRow.CDCFOPESTAPUR)? widget.currentRow.CDCFOPESTAPUR : widget.currentRow.CDCFOPESTAPUR.length == 1 ? widget.currentRow.CDCFOPESTAPU[0] : '_'+ widget.currentRow.CDCFOPESTAPUR.join('_')+ '_';
        
        //salva
		General.saveCrud(widget).then(function (Success) {
			widget.currentRow.__is_new = false;
			widget.currentRow.changed = false;
			widget.template = widget.templateToView;
			widget.view();
			widget.reload();
			self.controlaStatusWidgets(widget, widget.name, true);
	        self.controlaStatusWidgets(widgetPrincipal, widget.name, true);
		}.bind(this), function (callback) {
			if (callback.data) {
				ScreenService.showMessage(callback.data.error);
			}
		});
    		        
	};    

	this.salvarCreditoPresumido = function (args) {
		var widgetPrincipal = templateManager.container.getWidget('gridInscricaoEstadual');
		var widget = args.owner.widget;
		
		if (widget.isValid()) {
			widget.currentRow.__is_new = false;
			widget.currentRow.CDEMPRESA = templateManager.container.getWidget('gridInscricaoEstadual').currentRow.CDEMPRESA;
			widget.currentRow.CDINSCESTA = templateManager.container.getWidget('gridInscricaoEstadual').currentRow.CDINSCESTA;
		
			if (widget.currentRow.CDTIPOPERCREDP) {
				if (widget.currentRow.CDTIPOPERCREDP.length === 0) {
					widget.currentRow.CDTIPOPERCREDP = null;
					widget.currentRow.CDTIPOOPER = null;
					widget.currentRow.IDENTRSAIDOP = null;
				}
			}

			if (Ger00250_ParametrizacaoInscricaoEstadual_Service.validaAliquota(widget.currentRow)) {
				Ger00250_ParametrizacaoInscricaoEstadual_Service.concatenaCampoTipoOperacao(widget.currentRow, 'CDTIPOOPER', 'CDTIPOPERCREDP', 'IDENTRSAIDOP');
				General.saveCrud(widget).then(function (Success) {
					widget.currentRow.__is_new = false;
					widget.currentRow.changed = false;
					widget.template = widget.templateToView;
					widget.currentRow.CDTIPOPERCREDP = widget.currentRow.CDTIPOOPER;
					//widget.view();
					//widget.reload();
					var widgetPresumido = templateManager.container.getWidget('tabbedCreditoPresumido');
					self.controlaStatusWidgets(widgetPresumido, widget.name, true);
					self.controlaStatusWidgets(widgetPrincipal, 'tabbedCreditoPresumido', true);
					self.aposSalvarCreditoPresumido(widget);
				}.bind(this), function (callback) {
					if (callback.data) {
						ScreenService.showMessage(callback.data.error);
					}
				});
			} else {
				ScreenService.showMessage('Valor inválido. A alíquota deve estar entre 0% e 100%.');
				
			} 
		}
		
	};
	
	this.aposSalvarCreditoPresumido = function (widget) {
	    var widgetRegime = templateManager.container.getWidget('tabbedRegimeEspecialTributacao');
		var widgetCredito = templateManager.container.getWidget('tabbedCreditoPresumido');
		var widgetApuracao = templateManager.container.getWidget('tabbedCreditoPresumido');
		self.controlaStatusWidgets(widgetRegime, widgetCredito.name, true);
		self.controlaStatusWidgets(widgetCredito, widgetApuracao.name, true);
		self.controlaStatusWidgets(widgetApuracao, widget.name, true);
		widget.reload();
		widget.template = widget.templateToView;
		widget.view();
		widget.activate();
				

		var DSOUTCREDTOTSAI =  widget.getField('DSOUTCREDTOTSAI');
		var VRALIQTOTALSAIDA =  widget.getField('VRALIQTOTALSAIDA');
		var CDTIPOOPER =  widget.getField('CDTIPOOPER');
		var IDENTRSAIDOP =  widget.getField('IDENTRSAIDOP');
		var IDAPURLUCPRE =  widget.getField('IDAPURLUCPRE');

			DSOUTCREDTOTSAI.reload();
			VRALIQTOTALSAIDA.reload();
			CDTIPOOPER.reload();
			IDENTRSAIDOP.reload();
			IDAPURLUCPRE.reload();
	    
	};

	this.controlaAliquotaUnica = function (widget) {
		var aliquotaSaida = widget.getField('VRALIQTOTALSAIDA');
		var aliquotaImposto = widget.getField('VRALIQIMPOSREC');
		var descAliquotaSaida = widget.getField('DSOUTCREDTOTSAI');
		var descAliquotaImposto = widget.getField('DSOUTCREDIMPREC');

		if (aliquotaSaida.value() === "") {
			aliquotaSaida.setValue(0);
		}

		if (aliquotaImposto.value() === "") {
			aliquotaImposto.setValue(0);
		}

		if ( (parseFloat(aliquotaSaida.value())) && (parseFloat(aliquotaSaida.value()) !== 0) ) {
			descAliquotaSaida.readOnly = false;
			descAliquotaSaida.validations.required = true;

			aliquotaImposto.setValue(0);
			aliquotaImposto.readOnly = true;

			descAliquotaImposto.setValue("");
			descAliquotaImposto.readOnly = true;
			delete(descAliquotaImposto.validations.required);
			
		} else if ( (parseFloat(aliquotaImposto.value())) && (parseFloat(aliquotaImposto.value()) !== 0)) {
			descAliquotaImposto.readOnly = false;
			descAliquotaImposto.validations.required = true;

			aliquotaSaida.setValue(0);
			aliquotaSaida.readOnly = true;

			descAliquotaSaida.setValue("");
			descAliquotaSaida.readOnly = true;
			delete(descAliquotaSaida.validations.required);
			
		} else {
			aliquotaImposto.readOnly	 = false;
			aliquotaSaida.readOnly		 = false;
			descAliquotaSaida.readOnly	 = true;
			descAliquotaImposto.readOnly = true;
			
			descAliquotaSaida.setValue("");
			descAliquotaImposto.setValue("");
			
			delete(descAliquotaImposto.validations.required);
			delete(descAliquotaSaida.validations.required);
		}
	};

	this.controlaCargaTributaria = function (widget) {
		var cargaTributaria		= widget.getField('IDUTCARGATRIB');
		var tipocargaTributaria = widget.getField('IDCARGA');
		var codigoAjusteCredito = widget.getField('CDAJSTCREDCARGA');
		var descAjusteCredito	= widget.getField('DSOUTCREDCARGA');
		var codigoAjusteDebito	= widget.getField('CDAJSTDEBICARGA');
		var descAjusteDebito	= widget.getField('DSOUTDEBICARGA');

		if (cargaTributaria.value() == 'N') {
			tipocargaTributaria.readOnly = true;

			tipocargaTributaria.isVisible = false;
			tipocargaTributaria.clearValue();
			tipocargaTributaria.isVisible = true;
			//templateManager.updateTemplate();
			delete(tipocargaTributaria.validations.required);

			codigoAjusteCredito.readOnly = true;
			descAjusteCredito.readOnly = true;
			codigoAjusteDebito.readOnly = true;
			descAjusteDebito.readOnly = true;
		} else {
			tipocargaTributaria.readOnly = false;
			tipocargaTributaria.validations.required = true;
		}
		this.controlaTipoCargaTributaria(widget);
	};
	
	this.controlaEstorno = function (widget) {
	    if(widget.currentRow){
    	    var IDREALIESTAPURField	  = widget.getField('IDREALIESTAPUR');
    		var CDTPOPERESTAPURField  = widget.getField('CDTPOPERESTAPUR'); //lista 
    		var CDCFOPESTAPURField    = widget.getField('CDCFOPESTAPUR'); //lista
    		var VRALIQEFETIVAField    = widget.getField('VRALIQEFETIVA');
    		var VRALIQINTERNAField    = widget.getField('VRALIQINTERNA');
    		var CDAJUSTESTAPURField   = widget.getField('CDAJUSTESTAPUR');
    		var DSESTORNODEBAPUField   = widget.getField('DSESTORNODEBAPU');
            
            
    		if (IDREALIESTAPURField.value() == 'N') {
    			CDTPOPERESTAPURField.readOnly = true;
                CDCFOPESTAPURField.readOnly = true;
                VRALIQEFETIVAField.readOnly = true;
                VRALIQINTERNAField.readOnly = true;
                CDAJUSTESTAPURField.readOnly = true;
                DSESTORNODEBAPUField.readOnly = true;
                
                CDTPOPERESTAPURField.setValue('');
                CDCFOPESTAPURField.setValue('');
                VRALIQEFETIVAField.setValue('');
                VRALIQINTERNAField.setValue('');
                CDAJUSTESTAPURField.setValue('');
                DSESTORNODEBAPUField.setValue('');
                
                //delete(CDTPOPERESTAPURField.validations.required);
                //delete(CDCFOPESTAPURField.validations.required);
                delete(VRALIQEFETIVAField.validations.required);
                delete(VRALIQINTERNAField.validations.required);
                delete(CDAJUSTESTAPURField.validations.required);
                delete(DSESTORNODEBAPUField.validations.required);
    
            } else {
                CDTPOPERESTAPURField.readOnly = false;
                CDCFOPESTAPURField.readOnly = false;
                VRALIQEFETIVAField.readOnly = false;
                VRALIQINTERNAField.readOnly = false;
                CDAJUSTESTAPURField.readOnly = false;
                DSESTORNODEBAPUField.readOnly = false;
                
                //CDTPOPERESTAPURField.validations  = {required: true}; lista
                //CDCFOPESTAPURField.validations    = {required: true}; lista
                VRALIQEFETIVAField.validations    = {required: true}; 
                VRALIQINTERNAField.validations    = {required: true};
                CDAJUSTESTAPURField.validations   = {required: true}; 
                DSESTORNODEBAPUField.validations  = {required: true}; 
                
            }
	    }
	};

	this.controlaTipoCargaTributaria = function (widget) {
		var tipocargaTributaria = widget.getField('IDCARGA');
		var codigoAjusteCredito = widget.getField('CDAJSTCREDCARGA');
		var descAjusteCredito   = widget.getField('DSOUTCREDCARGA');
		var codigoAjusteDebito  = widget.getField('CDAJSTDEBICARGA');
		var descAjusteDebito    = widget.getField('DSOUTDEBICARGA');

		if (tipocargaTributaria.value() == '1' ) {

			codigoAjusteCredito.readOnly = true;
			delete(codigoAjusteCredito.validations.required);

			descAjusteCredito.readOnly = true;
			delete(descAjusteCredito.validations.required);

			codigoAjusteDebito.readOnly = true;
			delete(codigoAjusteDebito.validations.required);

			descAjusteDebito.readOnly = true;
			delete(descAjusteDebito.validations.required);
			
			this.limpaCampos(widget);

		} else {
			codigoAjusteCredito.readOnly = false;
			codigoAjusteCredito.validations.required = true;

			descAjusteCredito.readOnly = false;
			descAjusteCredito.validations.required = true;

			codigoAjusteDebito.readOnly = false;
			codigoAjusteDebito.validations.required = true;

			descAjusteDebito.readOnly = false;
			descAjusteDebito.validations.required = true;
		}
	};

	this.salvarCargaTributaria = function (args) {
		var widget = args.owner.widget;
		if (widget.isValid()) {
		//	Ger00250_ParametrizacaoInscricaoEstadual_Service.controlaValorCargaTributaria(widget.currentRow);
			this.salvar(args);
		}
	};

	this.checkNumeroDeInscricao = function (field) {
		var validatedInscricao = Ger00250_ParametrizacaoInscricaoEstadual_Service.validateNumeroDeInscricao(field.widget.currentRow[field.descriptionField]);
		var widget = field.widget;

		if (validatedInscricao.valid) {
			//if input is valid, builds unformatted data to save
			switch (validatedInscricao.tipo.cod) {
			case 'O': //Código genérico
				validatedInscricao.rawValue = General.fill(validatedInscricao.parameter, 5);
				break;
			case 'I': //Inscrição genérica
				validatedInscricao.rawValue = General.fill(validatedInscricao.parameter, 20);
				break;
		//	default: //CPF && CNPJ
			//	validatedInscricao.rawValue = validatedInscricao.parameter;
			}

			//sets data in the currentRow
			widget.currentRow.IDTPIJURIEST = validatedInscricao.tipo.cod;
			widget.currentRow[field.valueField] = validatedInscricao.rawValue;
			widget.currentRow[field.descriptionField] = validatedInscricao.value;
		} else {
			//if message exists, throws warning popup
			if (validatedInscricao.error.msg)
				ScreenService.showMessage(validatedInscricao.error.msg, "warning");

			//cleans data
			widget.currentRow[field.valueField] = null;
			widget.currentRow[field.descriptionField] = null;
		}
	};

	this.setFieldsAddress = function (widgetName, fieldName) {
		//field = General.getFieldValue(fieldName,widgetName);
		//field = field.toString();
		//return field;
		return General.getFieldValue(fieldName, widgetName);
		//return templateManager.container.getWidget(widgetName).currentRow[fieldName] || '';
	};

	this.validarCepEnd = function (args) {

		var widget = args.owner.owner.widget;
		var CEP = widget.currentRow.NRCEPIEST;
		if (CEP) {
			Endereco.buscarCep(CEP).then(function (response) {
				var endereco = response.dataset.ENDERECO;
				if (endereco) {
					widget.currentRow.NRCEPIEST = CEP;
					widget.currentRow.CDPAIS = (endereco.CDPAIS) ? endereco.CDPAIS : '';
					widget.currentRow.NMPAIS = (endereco.NMPAIS) ? endereco.NMPAIS : '';
					widget.currentRow.SGESTADO = (endereco.SGESTADO) ? endereco.SGESTADO : '';
					widget.currentRow.NMESTADO = (endereco.NMESTADO) ? endereco.NMESTADO : '';
					widget.currentRow.CDMUNICIPIO = (endereco.CDMUNICIPIO) ? endereco.CDMUNICIPIO : '';
					widget.currentRow.NMMUNICIPIO = (endereco.NMMUNICIPIO) ? endereco.NMMUNICIPIO : '';
					widget.currentRow.NMBAIRIEST = (endereco.NMBAIRRO) ? endereco.NMBAIRRO : '';
					widget.currentRow.CDLOGRADOURO = (endereco.CDLOGRADOURO) ? endereco.CDLOGRADOURO : '';
					widget.currentRow.CDBAIRRO = (endereco.CDBAIRRO) ? endereco.CDBAIRRO : '';
					widget.currentRow.DSENDEIEST = ((endereco.DSLOGRADOURO) ? endereco.DSLOGRADOURO : '') + " " + ((endereco.DSENDERECO) ? endereco.DSENDERECO : '');
					//widget.currentRow.DSLOGRADOURO = (endereco.DSLOGRADOURO)? endereco.DSLOGRADOURO : '';

					this.controlaVisibilidadeCampoPaisEstadoMunicipioBairro('gridSubstitutoTributario');

				}
				if (response.dataset.ERRO){ 
					ScreenService.showMessage(response.dataset.ERRO.MESSAGE, "warning");
				}
			}.bind(this), function(error){
				ScreenService.showMessage("Ouve um erro ao tentar localizar este CEP. Insira um CEP Valido.", "warning");	
			});
		}
		
		//widget.redraw();
		widget.reload();

	};

	this.controlaVisibilidadeCampoPaisEstadoMunicipioBairro = function (nomeWidget) {
		var widget = templateManager.container.getWidget(nomeWidget);
		var pais = widget.getField('NMPAIS');
		var estado = widget.getField('NMESTADO');
		var municipio = widget.getField('NMMUNICIPIO');
		var bairro = widget.getField('NMBAIRIEST');
		if (widget.currentRow.NMPAIS) {
			estado.readOnly = false;
			municipio.readOnly = true;
			bairro.readOnly = true;
			if (widget.currentRow.NMESTADO) {
				municipio.readOnly = false;
				bairro.readOnly = true;
				if (widget.currentRow.NMMUNICIPIO) {
					bairro.readOnly = false;
				} else {
					bairro.readOnly = true;
				}
			} else {
				municipio.readOnly = true;
				bairro.readOnly = true;
			}
		} else {
			estado.readOnly = true;
			municipio.readOnly = true;
			bairro.readOnly = true;
		}
	};
	
	this.controlaVisibilidadeEditarCampoPaisEstadoMunicipioBairro = function(nomeWidget) {
		var widget = templateManager.container.getWidget(nomeWidget);
		var bool = widget.currentRow.NMPAIS ? true : false;
		
		widget.getField('NMPAIS').readOnly = !bool;
		widget.getField('NMESTADO').readOnly = !bool;
		widget.getField('NMMUNICIPIO').readOnly = !bool;
		widget.getField('NMBAIRIEST').readOnly = !bool;
	};

	this.controlaValorCampoPaisEstadoMunicipioBairro = function (nomeCampoAtual, nomeWidget) {
		var widget = templateManager.container.getWidget(nomeWidget);
		var pais = widget.getField('NMPAIS');
		var estado = widget.getField('NMESTADO');
		var municipio = widget.getField('NMMUNICIPIO');
		var bairro = widget.getField('NMBAIRIEST');
		switch (nomeCampoAtual) {
		case 'Pais':
			estado.setValue("");
			widget.currentRow.SGESTADO = null;
			estado.reload();

			municipio.setValue("");
			widget.currentRow.CDMUNICIPIO = null;
			municipio.reload();

			bairro.setValue("");
			widget.currentRow.CDBAIRRO = null;
			bairro.reload();

			break;
		case 'Estado':
			municipio.setValue("");
			widget.currentRow.CDMUNICIPIO = null;
			municipio.reload();
			
			bairro.setValue("");
			widget.currentRow.CDBAIRRO = null;
			bairro.reload();
			
			break;
		case 'Municipio':
			bairro.setValue("");
			widget.currentRow.CDBAIRRO = null;
			bairro.reload();
			
			break;
		default:
			break;
		}
	};

	this.recarregarCampo = function (nomeWidget, nomeCampo) {
		var widget = templateManager.container.getWidget(nomeWidget);
		widget.getField(nomeCampo).reload();
	};

	this.setFieldsAddress = function (widgetName, fieldName) {
		return General.getFieldValue(fieldName, widgetName);
	};

	this.editarSubstitutoTributario = function (args) {
		this.controlaVisibilidadeEditarCampoPaisEstadoMunicipioBairro('gridSubstitutoTributario');
		self.controlaStatusWidgets(args.owner.widget, 'gridSubstitutoTributario', false);
		General.edit(args.owner.widget);
	};

	this.salvarSubstitutoTributario = function (args) {
		var widget = args.owner.widget;
		var widgetPrincial = templateManager.container.getWidget('gridInscricaoEstadual');
		if (widget.isValid()) {
			widget.currentRow.NRINSJURIEST = widget.currentRow.NRINSJURIEST.replace(/[^0-9]/g, '');
			if (widget.currentRow.__is_new) {
				widget.currentRow.CDINSCESTA = widgetPrincial.currentRow.CDINSCESTA;
				widget.currentRow.CDEMPRESA = widgetPrincial.currentRow.CDEMPRESA;
				widget.currentRow.CDFILIAL = null;
			}
			Ger00250_ParametrizacaoInscricaoEstadual_Service.salvarSubstitutoTributario(widget.currentRow).then(function (Success) {
				widget.activate();
				if (widget.currentRow.__is_new) {
					widget.list(true);
					ScreenService.goBack();
					widget.reload().then(function () {});
				} else {
					widget.view();
				}

				self.controlaStatusWidgets(widget, widget.name, true);
			}.bind(this), function (callback) {
				if (callback.data) {
					ScreenService.showMessage(callback.data.error);
				}
			});
		}
	};

	this.adicionarSubstituto = function (args) {
		args.owner.widget.newRow();
		args.owner.widget.currentRow.IDPERIODOREFAPU = "I";
		this.controlaVisibilidadeCampoPaisEstadoMunicipioBairro('gridSubstitutoTributario');
		self.controlaStatusWidgets(args.owner.widget, 'gridSubstitutoTributario', false);
	};

	this.salvarMensagemSubstituto = function (args) {
		var widgetPrincial = templateManager.container.getWidget('gridSubstitutoTributario');
		
		var widget = args.owner.widget;
		if (widget.currentRow.__is_new) {
			widget.currentRow.CDINSCESTA = widgetPrincial.currentRow.CDINSCESTA;
			widget.currentRow.CDEMPRESA = widgetPrincial.currentRow.CDEMPRESA;
			widget.currentRow.CDINSCESTAST = widgetPrincial.currentRow.CDINSCESTAST;
		}
		if (widget.isValid()) {
			Ger00250_ParametrizacaoInscricaoEstadual_Service.salvarMensagemSubstituto(widget.currentRow).then(function (Success) {
				widget.activate();
				if (widget.currentRow.__is_new) {
					widget.list(true);
					ScreenService.goBack();
					widget.reload().then(function () {});
				} else {
					widget.view();
				}
			}.bind(this), function (callback) {
				if (callback.data) {
					ScreenService.showMessage(callback.data.error);
				}
			});
		}
	};
	
	this.credCargaOnChange = function (widget){
		if(!widget.currentRow.DSOUTCREDCARGA && widget.currentRow.DSOUTCREDCARGAAUX)
			widget.currentRow.DSOUTCREDCARGA = widget.currentRow.DSOUTCREDCARGAAUX;
	};
	
	this.debCargaOnChange = function (widget){
		if(!widget.currentRow.DSOUTDEBICARGA && widget.currentRow.DSOUTDEBICARGAAUX)
			widget.currentRow.DSOUTDEBICARGA = widget.currentRow.DSOUTDEBICARGAAUX;
	};
	
	this.limpaCampos = function (widget){
		widget.currentRow.CDAJSTCREDCARGA = "";
		widget.currentRow.DSOUTCREDCARGA  = "";
		widget.currentRow.CDAJSTDEBICARGA = "";
		widget.currentRow.DSOUTDEBICARGA  = "";
	};

	this.aplicaListaTipoOperacao = function (){
		var widget = templateManager.container.getWidget('gridApuracao');
		if(widget.currentRow.CDTIPOOPER){
			widget.currentRow.CDTIPOPERCREDP = widget.currentRow.CDTIPOOPER;
			widget.reload();
		}
		widget.reload();
	};
	
	this.aplicaDataSourceInscEsta = function (widget){
		if(widget.currentRow.CDEMPRESA)
			widget.getField("CDINSCESTA").dataSourceFilter[0].value = widget.currentRow.CDEMPRESA;
		else widget.currentRow.CDINSCESTA = "";
	};

	self.setRowPortariaCAT  =function () {
		var widget = templateManager.container.getWidget('PortariaCAT');
		var widgetDiferencialAliq = templateManager.container.getWidget('DiferencialAliq');
		var compRessarcICMSST = templateManager.container.getWidget('compRessarcICMSST');
		var widgetInscEsta = templateManager.container.getWidget('gridInscricaoEstadual');
		if(widget.dataSource.data.length > 0){
			widget.currentRow = widget.dataSource.data[0];
			widgetDiferencialAliq.currentRow = widget.dataSource.data[0];
			compRessarcICMSST.currentRow = widget.dataSource.data[0];
		} else {
			widget.currentRow.__is_new = true;
			widget.currentRow.NRORG = getLocalVar('NRORG');
			widget.currentRow.CDEMPRESA = widgetInscEsta.currentRow.CDEMPRESA;
			widget.currentRow.CDINSCESTA = widgetInscEsta.currentRow.CDINSCESTA;
			widget.currentRow.IDDIFEALIQUOTA = "DA";
			widget.currentRow.CDAJUSTE = "";
			widget.currentRow.DSAJUSTE = "";
			widget.currentRow.CDAJUSTENFEXTEMP = "";
			widget.currentRow.DSAJUSTENFEXTEMP = "";
			widget.currentRow.CDAJISENTOUTR = "";
			widget.currentRow.CDAJSTSUBSTITUIDO = "";
			widget.currentRow.CDAJUSTEENTRTRIB = "";
			widget.currentRow.DSAJUSTEENTRTRIB = "";
			widget.currentRow.CDAJUSTESAIDTRIB = "";
			widget.currentRow.DSAJUSTESAIDTRIB = "";
			widget.currentRow.CDAJUSTEVRREST = "";
			widget.currentRow.DSAJUSTEVRREST = "";
			widget.currentRow.CDAJUSTEVRCOMPL = "";
			widget.currentRow.DSAJUSTEVRCOMPL = "";
			widget.currentRow.CDAJUSTEE220VRREST = "";
			widget.currentRow.DSAJUSTEE220VRREST = "";
			widget.currentRow.CDAJUSTEE220VRCOMP = "";
			widget.currentRow.DSAJUSTEE220VRCOMP = "";
			widgetDiferencialAliq.currentRow = widget.currentRow;
			compRessarcICMSST.currentRow = widget.currentRow;
     	}
	};
	
	self.addParamCFOP = function(widget){
		var widgetPrincipal = templateManager.container.getWidget('gridInscricaoEstadual');
		widget.newRow();
		widget.currentRow.CDEMPRESA = widgetPrincipal.currentRow.CDEMPRESA;
		widget.currentRow.CDINSCESTA = widgetPrincipal.currentRow.CDINSCESTA;
		
	};
	
	self.addAliqInt = function(widget){
		var widgetPrincipal = templateManager.container.getWidget('gridInscricaoEstadual');
		widget.newRow();
		widget.currentRow.CDEMPRESA = widgetPrincipal.currentRow.CDEMPRESA;
		widget.currentRow.CDINSCESTA = widgetPrincipal.currentRow.CDINSCESTA;
		
	};
	
	self.changeSomaFECP = function(widget) {
		var idSomaFecp = widget.getField('IDSOMAFECP');
		if( idSomaFecp.value() === 'S'){
			widget.getField('TPAJUSTEFECP').dataSource.data = [
                {
                    "value": "DDE",
                    "description": "Dedução e Débito Especial"
                },
                {
                    "value": "N",
                    "description": "Não Gera Ajustes"
                }
            ];
		}
		if( idSomaFecp.value() === 'N'){
			widget.getField('TPAJUSTEFECP').dataSource.data = [
                {
                    "value": "DE",
                    "description": "Débito Especial"
                },
                {
                    "value": "OD",
                    "description": "Outros Débito"
                }
            ];
		}
		widget.getField('TPAJUSTEFECP').readOnly = false;
		widget.getField('TPAJUSTEFECP').reload();
	};
	
	self.changeTipoAjusteFECP = function(widget){
	    //DDE
	    widget.getField('CDAJUSTEDDUE').isVisible = false;
	    widget.getField('DSAJUSTEDDUE').isVisible = false;
	    widget.getField('DSAJUSTEDDUE').validations = {};
	    //DE
	    widget.getField('CDAJUSTDEBESP').isVisible = false;
	    widget.getField('DSAJUSTDEBESP').isVisible = false;
	    widget.getField('DSAJUSTDEBESP').validations = {};
	    //OD
	    widget.getField('CDAJUSTOUTDEB').isVisible = false;
	    widget.getField('DSAJUSTOUTDEB').isVisible = false;
	    widget.getField('DSAJUSTOUTDEB').validations = {};
	    
	    if(widget.currentRow.TPAJUSTEFECP === 'DDE'){
	        widget.getField('CDAJUSTEDDUE').isVisible = true;
	        widget.getField('DSAJUSTEDDUE').isVisible = true;
	        widget.getField('CDAJUSTEDDUE').validations = { 'required': true };
	        widget.getField('DSAJUSTEDDUE').validations = { 'required': true };
	        
	        widget.getField('CDAJUSTDEBESP').isVisible = true;
	        widget.getField('DSAJUSTDEBESP').isVisible = true;
	        widget.getField('CDAJUSTDEBESP').validations = { 'required': true };
	        widget.getField('DSAJUSTDEBESP').validations = { 'required': true };
	        
	    }
	    if(widget.currentRow.TPAJUSTEFECP === 'DE'){
	        widget.getField('CDAJUSTDEBESP').isVisible = true;
			widget.getField('DSAJUSTDEBESP').isVisible = true;
			widget.getField('CDAJUSTDEBESP').validations = { 'required': true };
			widget.getField('DSAJUSTDEBESP').validations = { 'required': true };
				
	    }
	    
	    if(widget.currentRow.TPAJUSTEFECP === 'OD'){
	        widget.getField('CDAJUSTOUTDEB').isVisible = true;
			widget.getField('DSAJUSTOUTDEB').isVisible = true;
			widget.getField('CDAJUSTOUTDEB').validations = { 'required': true };
			widget.getField('DSAJUSTOUTDEB').validations = { 'required': true };
		
	    }
	    if(widget.currentRow.TPAJUSTEFECP === 'N'){
	        
	    }
	};
	
	self.validaAliquota = function(widget){
		if(isNaN(parseFloat(widget.currentRow.VRALIQINTERNA)) || (parseFloat(widget.currentRow.VRALIQINTERNA) < 0) || (parseFloat(widget.currentRow.VRALIQINTERNA) > 100.00)){
			widget.getField('VRALIQINTERNA').clearValue();
			ScreenService.showMessage('Valor da Alíquota Interna deve ser maior que 0 e menor que 100');
		}
	};
	
	self.validaAliquotaCfop = function(widget){
		if(isNaN(parseFloat(widget.currentRow.VRALIQUOTA)) || (parseFloat(widget.currentRow.VRALIQUOTA) < 0) || (parseFloat(widget.currentRow.VRALIQUOTA) > 100)){
			widget.getField('VRALIQUOTA').clearValue();
			ScreenService.showMessage('Valor da Alíquota Interna deve ser maior que 0 e menor que 100');
		}
	};
	
	self.validaAliquotaSaida = function(widget){
		if(isNaN(parseFloat(widget.currentRow.VRALIQTOTALSAIDA)) || (parseFloat(widget.currentRow.VRALIQTOTALSAIDA) < 0) || (parseFloat(widget.currentRow.VRALIQTOTALSAIDA) > 100)){
			widget.getField('VRALIQTOTALSAIDA').clearValue();
			ScreenService.showMessage('Valor da Alíquota Interna deve ser maior que 0 e menor que 100');
		}
	};
	
	self.validaAliquotaImposto = function(widget){
		if(isNaN(parseFloat(widget.currentRow.VRALIQIMPOSREC)) || (parseFloat(widget.currentRow.VRALIQIMPOSREC) < 0) || (parseFloat(widget.currentRow.VRALIQIMPOSREC) > 100)){
			widget.getField('VRALIQIMPOSREC').clearValue();
			ScreenService.showMessage('Valor da Alíquota Interna deve ser maior que 0 e menor que 100');
		}
	};
	
	self.validaAliquotaInterna = function(widget, field = 'VRALIQINT'){
		if(isNaN(parseFloat(widget.currentRow[field])) || (parseFloat(widget.currentRow[field]) < 0) || (parseFloat(widget.currentRow[field]) > 100)){
			widget.getField(field).clearValue();
			ScreenService.showMessage('Valor da Alíquota Interna deve ser maior que 0 e menor que 100');
			return false;
		}else{
		    return true;
		}
	};
	
	self.validaAliquotaFecp = function(widget){
		if(isNaN(parseFloat(widget.currentRow.VRALIQFECP)) || (parseFloat(widget.currentRow.VRALIQFECP) < 0) || (parseFloat(widget.currentRow.VRALIQFECP) > 100)){
			widget.getField('VRALIQFECP').clearValue();
			ScreenService.showMessage('Valor da Alíquota FECP deve ser maior que 0 e menor que 100');
		}
	};
	
	this.controlaBeneficioFiscal = function (widget) {
		var idbeneficio = widget.getField('IDBENEFICIO');
    	var codigoE = widget.getField('CDAJUSTENF');
			if (idbeneficio.value() === 'IOP') {
				codigoE.readOnly = true;
				codigoE.isVisible = false;
			//	codigoE.clearValue();
				codigoE.isVisible = true;
				//templateManager.updateTemplate();
				delete(codigoE.validations.required);
			} else {
				codigoE.readOnly = false;
				codigoE.validations.required = true;
			}
	};
	
	this.SalvarBeneficioFiscal = function (widget) {
		var widgetPrincipal = templateManager.container.getWidget('gridInscricaoEstadual');
		if (widget.currentRow.__is_new) {
			widget.currentRow.CDINSCESTA = widgetPrincipal.currentRow.CDINSCESTA;
			widget.currentRow.CDEMPRESA = widgetPrincipal.currentRow.CDEMPRESA;
				General.saveCrud(widget).then(function(Success) {
				    widget.reload();
				});
		} else {
				General.saveCrud(widget).then(function(Success) {
				    widget.reload();
				});
		}
	};
	
	this.statusWidget = function (widget){
		var diferimento = widget.row.IDDIFERICMSANT;
		var widgetDiferimento = templateManager.container.getWidget('gridCfopDiferimento');
		self.controlaStatusWidgets(widgetDiferimento, widget.name, false);
		if (diferimento == 'S'){
			self.controlaStatusWidgets(widgetDiferimento, widget.name, true);
		}
	};
	
	this.controlaCreditoPresumido = function(widget) {
		var template = templateManager.container.getWidget('gridApuracao');
		var apurar = widget.row.IDAPURLUCPRE;
		var aliquotaSaida = template.fields[5];
		var descAliquotaSaida = template.fields[6];
		var aliquotaImposto = template.fields[7];
		var descAliquotaImposto = template.fields[8];
		
		if (apurar == 'S'){
			aliquotaSaida.readOnly = false;
			aliquotaImposto.readOnly = false;
			descAliquotaSaida.readOnly = false;
			descAliquotaImposto.readOnly = false;
		} else {
			aliquotaSaida.readOnly = true;
			aliquotaImposto.readOnly = true;
			descAliquotaSaida.readOnly = true;
			descAliquotaImposto.readOnly = true;
			
			aliquotaSaida.clearValue();
			aliquotaImposto.clearValue();
			descAliquotaSaida.clearValue();
			descAliquotaImposto.clearValue();
			
		}
			aliquotaSaida.reload();
			aliquotaImposto.reload();
			descAliquotaSaida.reload();
			descAliquotaImposto.reload();
	};
	
	this.entradaSaida = function(args) {
		var entsaid  = args.row.IDENTRSAIDOP; 
        var cdtipooper  = args.owner.getParent().getParent().getField('CDTIPOOPER');
      
       	
        if (entsaid != null ){
             cdtipooper.dataSourceFilter = [
                {
                    "name": "IDENTRSAIDOP",
                    "operator": "=",
                    "value": entsaid
                }
            ];
        }else {
             cdtipooper.dataSourceFilter = [];
        }
        
        cdtipooper.reload();
	};
	
	this.reload = function(args) {
		 var aliquotaSaida = args.owner.getParent().getParent().getField('VRALIQTOTALSAIDA');
		 var aliquotaImposto = args.owner.getParent().getParent().getField('VRALIQIMPOSREC');
		 var descAliquotaSaida = args.owner.getParent().getParent().getField('DSOUTCREDTOTSAI');
		 var descAliquotaImposto = args.owner.getParent().getParent().getField('DSOUTCREDIMPREC');
		 
		 aliquotaSaida.reload();
		 aliquotaImposto.reload();
		 descAliquotaSaida.reload();
		 descAliquotaImposto.reload();

	};
	
	this.reloadtipooperac = function(args){
		var cdtipooper  = args.owner.getParent().getParent().getField('CDTIPOOPER');
		var entsaid =  args.owner.getParent().getParent().getField('IDENTRSAIDOP');
		
		
		 cdtipooper.reload();
		 entsaid.reload();
	};
	
	this.controlaCampoCodigoSubItem = function (widget){
        var field =  widget.getField('CDITEMOCOR');
        var campoDescricao     = widget.getField('DSITEMOCOR');
        var campoFundamentacao = widget.getField('DSFLEGALOCOR');
        if( field.value() ){
            var campoCodigo = field.value().replace(/[^0-9]/g,'');
            if(campoCodigo.substr(3,4) ==='99'){
                campoDescricao.readOnly = false;
                campoDescricao.validations.required = true;
                
                campoFundamentacao.readOnly = false;
                campoFundamentacao.validations.required = true;
            }else{
                campoDescricao.readOnly = true;
                campoDescricao.value('');
                delete(campoDescricao.validations.required);
                
                campoFundamentacao.readOnly = true;
                campoFundamentacao.value('');
                delete(campoFundamentacao.validations.required);
            }
            
        }else{
            campoDescricao.readOnly = true;
            campoDescricao.value('');
            delete(campoDescricao.validations.required);
            
            campoFundamentacao.readOnly = true;
            campoFundamentacao.value('');
            delete(campoFundamentacao.validations.required);
        }  
    };
    
    this.verificaProduto = function(widget){
        var prodIni = parseFloat(widget.currentRow.CDARVPRODINI);
        var prodFin = parseFloat(widget.currentRow.CDARVPRODFIN);
        if(prodIni > prodFin){
            ScreenService.showMessage("Produto Final deve ser maior que o Produto Inicial.");
            widget.getField('CDPRODUTOINI').clearValue();
            widget.getField('CDARVPRODINI').clearValue();
            widget.getField('NMPRODUTOINI').clearValue();
            widget.getField('CDPRODUTOFIN').clearValue();
            widget.getField('CDARVPRODFIN').clearValue();
            widget.getField('NMPRODUTOFIN').clearValue();
        }
    };
    
    this.replicacao_popUp = function(){
        var replicacao_pop_up = templateManager.container.getWidget('replicacao_pop_up');
        ScreenService.closePopup();
        replicacao_pop_up.isVisible = true;
        replicacao_pop_up.getField('CDEMPRESA_ORIG').clearValue();
        replicacao_pop_up.getField('NMEMPRESA_ORIG').clearValue();
        replicacao_pop_up.getField('CDINSCESTA_ORIG').clearValue();
        replicacao_pop_up.getField('CDEMPRESA_DEST').clearValue();
        replicacao_pop_up.getField('NMEMPRESA_DEST').clearValue();
        replicacao_pop_up.getField('CDINSCESTA_DEST').clearValue();
        ScreenService.openPopup(replicacao_pop_up);
    };
    
    this.replicacao_popUp_close = function(){
        var replicacao_pop_up = templateManager.container.getWidget('replicacao_pop_up');
        replicacao_pop_up.isVisible = false;
        ScreenService.closePopup();
    };
    
    this.replicacao_popUp_confirm = function(widget){
        if(widget.currentRow.CDEMPRESA_ORIG &&(widget.currentRow.CDEMPRESA_ORIG != "")){
            if(widget.currentRow.CDINSCESTA_ORIG &&(widget.currentRow.CDINSCESTA_ORIG != "")){
                if(widget.currentRow.CDEMPRESA_DEST &&(widget.currentRow.CDEMPRESA_DEST != "")){
                    if(widget.currentRow.CDINSCESTA_DEST &&(widget.currentRow.CDINSCESTA_DEST != "")){
                        widget.currentRow.DTATUAL = moment().format('DD/MM/YYYY');
						widget.currentRow.CDOPERADOR = getLocalVar('CDOPERADOR');
                        
                        Ger00250_ParametrizacaoInscricaoEstadual_Service.replicacao_AliqInt(widget.currentRow).then(function(sucess){
                            var result = sucess.dataset["/result"][0];
                            if(result){
                                ScreenService.showMessage('Replicado com sucesso.');
                                widget.isVisible = false;
                                ScreenService.closePopup();
                                templateManager.container.getWidget('widgetAliquotaInt').reload();
                            } else {
                                ScreenService.showMessage('Erro ao replicar.');
                            }
                        }, function(error){
                            
                        });
                    } else {
                        ScreenService.showMessage('A Inscrição Estadual de Destino deve ser informada.');
                    }
                } else {
                    ScreenService.showMessage('A Empresa de Destino deve ser informada.');
                }
            } else {
                ScreenService.showMessage('A Inscrição Estadual de Origem deve ser informada.');
            }
        } else {
            ScreenService.showMessage('A Empresa de Origem deve ser informada.');
        }
    
    };
    
    this.cadastramento_automatico = function(){
        var cadastramento_automatico_pop_up = templateManager.container.getWidget('cadastramento_automatico_pop_up');
        ScreenService.closePopup();
        cadastramento_automatico_pop_up.isVisible = true;
        cadastramento_automatico_pop_up.getField('CDPRODUTOINI').clearValue();
        cadastramento_automatico_pop_up.getField('CDARVPRODINI').clearValue();
        cadastramento_automatico_pop_up.getField('NMPRODUTOINI').clearValue();
        cadastramento_automatico_pop_up.getField('CDPRODUTOFIN').clearValue();
        cadastramento_automatico_pop_up.getField('CDARVPRODFIN').clearValue();
        cadastramento_automatico_pop_up.getField('NMPRODUTOFIN').clearValue();
        
        cadastramento_automatico_pop_up.getField('VRALIQINT').clearValue();
        cadastramento_automatico_pop_up.getField('VRALIQFECP').clearValue();
        
        ScreenService.openPopup(cadastramento_automatico_pop_up);
    };
    
    this.cadastramento_automatico_close = function(){
        var replicacao_pop_up = templateManager.container.getWidget('cadastramento_automatico_pop_up');
        replicacao_pop_up.isVisible = false;
        ScreenService.closePopup();
    };
    
    this.cadastramento_automatico_confirm = function(widget){
        if(widget.currentRow.CDPRODUTOINI &&(widget.currentRow.CDPRODUTOINI != "")){
            if(widget.currentRow.CDPRODUTOFIN &&(widget.currentRow.CDPRODUTOFIN != "")){
                if(widget.currentRow.VRALIQINT &&(widget.currentRow.VRALIQINT != "")){
                    if(widget.currentRow.VRALIQFECP &&(widget.currentRow.VRALIQFECP != "")){
                            
                        var widgetPrincipal = templateManager.container.getWidget('gridInscricaoEstadual');
		    
                        widget.currentRow.CDEMPRESA = widgetPrincipal.currentRow.CDEMPRESA;
						widget.currentRow.CDINSCESTA = widgetPrincipal.currentRow.CDINSCESTA;
                		widget.currentRow.DTATUAL = moment().format('DD/MM/YYYY');
						widget.currentRow.CDOPERADOR = getLocalVar('CDOPERADOR');
						
                        Ger00250_ParametrizacaoInscricaoEstadual_Service.cadastramento_automatico_AliqInt(widget.currentRow).then(function(sucess){
                            var result = sucess.dataset["/result"][0];
                            if(result){
                                ScreenService.showMessage('Cadastramento automático realizado com sucesso.');
                                widget.isVisible = false;
                                ScreenService.closePopup();
                                templateManager.container.getWidget('widgetAliquotaInt').reload();
                            } else {
                                ScreenService.showMessage('Erro no cadastramento automático.');
                            }
                        }, function(error){
                            ScreenService.showMessage(error.data.error);
                        });
                        
                    } else {
                        ScreenService.showMessage('Aliquota FECP deve ser informada.');
                    }
                } else {
                    ScreenService.showMessage('Aliquota Interna deve ser informada');
                }
            } else {
                ScreenService.showMessage('O Produto Final deve ser informado.');
            }
        } else {
            ScreenService.showMessage('O Produto Inicial deve ser informado.');
        }
    
    };
    
    this.controlarCampoReplicacao = function (args, tipo) {
		var widget = args.owner.owner.widget;
		var empresa = widget.getField('NMEMPRESA_'+tipo);
		var inscricao = widget.getField('CDINSCESTA_'+tipo);
		inscricao.setValue("");
		if (empresa.value()) {
			inscricao.readOnly = false;
		} else {
			inscricao.readOnly = true;
		}
	};

	this.aplicaDataSourceInscEstaReplicacao = function (widget, tipo){
		if(widget.getField('CDEMPRESA_'+tipo).value())
			widget.getField("CDINSCESTA_"+tipo).dataSourceFilter[0].value = widget.getField('CDEMPRESA_'+tipo).value();
		else widget.getField("CDINSCESTA_"+tipo).clearValue();
	};
	
	this.saveAliquotaInt = function(widget) {
		if(widget.currentRow.__is_new) {
			
			widget.currentRow.DTATUAL = moment().format('DD/MM/YYYY');
			widget.currentRow.CDOPERADOR = getLocalVar('CDOPERADOR');
			
			General.callRestEngine("cadFis#/saveAliquotaInt", "Row", widget.currentRow).then(function(sucess) {
                 ScreenService.closeSwipe();
                 ScreenService.showMessage("Registro salvo com sucesso.");
                 widget.reload();
            }, function(error){
            	ScreenService.showMessage(error.data.error);
            });
		} else {
			General.saveCrud(widget);
		}
	};

	this.selectIDTIPOCALCOnChange = function (field){
		field.widget.getField('IDTIPOCALCDOC').isVisible = field.value() == 'D';
	};
	
	this.selectIDTIPOCONTOnChange = function (field){
		field.widget.getField('DSRATEIOPADRAO').isVisible = field.value() == 'R';
	};
	
	this.widgetCritCalcOnEdit = function (widget){
		
		this.widgetCritCalcLoadFields(widget);
		
		General.edit(widget);
	};
	
	this.widgetCritCalcLoadFields = function(widget){
		// carregando estado dos campos da tela
		this.selectIDTIPOCALCOnChange(widget.getField('IDTIPOCALC'));
		this.selectIDTIPOCONTOnChange(widget.getField('IDTIPOCONT'));
	};
	
	this.widgetCritCalcOnEnter = function (widget){
		
	};

	this.idVrInformativoOnChange = function (field){
	    var fieldGroupActive = field.value() == 'S';
	    var CDAJCREDSTRS = field.widget.getField('CDAJCREDSTRS');
		var DSAJCREDSTRS = field.widget.getField('DSAJCREDSTRS');
		var CDTPOPCREDSTRS = field.widget.getField('CDTPOPCREDSTRS');
		
		CDAJCREDSTRS.readOnly = !fieldGroupActive;
		DSAJCREDSTRS.readOnly = !fieldGroupActive;
		CDTPOPCREDSTRS.readOnly = !fieldGroupActive;
		
		CDAJCREDSTRS.validations = {'required': true};
		DSAJCREDSTRS.validations = {'required': true};
		CDTPOPCREDSTRS.validations = {'required': true};
		if(!fieldGroupActive){
       		delete CDAJCREDSTRS.validations;
    		delete DSAJCREDSTRS.validations;
    		delete CDTPOPCREDSTRS.validations; 
		}
		
	};
	
	this.widgetCritCalcOnSave = function (widget){
		widget.currentRow.CDEMPRESA  = General.getFieldValue('CDEMPRESA','gridInscricaoEstadual');
		widget.currentRow.CDINSCESTA = General.getFieldValue('CDINSCESTA','gridInscricaoEstadual');
		widget.dataSource.name = 'cadFis#/crud/ajustfiscauto';
		General.saveCrud(widget).then(function(data){
			widget.dataSource.name = 'cadFis#/crud/ajustfiscauto_pesquisa';
			widget.reload();	
		});
	};
	
	this.mudanca = function(widget){
		if (widget.currentRow.CALCULOSOBRE == 'A' ){
			widget.getField('VRALIQTOTALSAIDA').name = "VRALIQIMPOSREC";
			widget.getField('DSOUTCREDTOTSAI').name = "DSOUTCREDIMPREC";
		}else{
			widget.getField('VRALIQIMPOSREC').name = "VRALIQTOTALSAIDA";
			widget.getField('DSOUTCREDIMPREC').name = "DSOUTCREDTOTSAI";
		}

	};
 
};
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger00250_ParametrizacaoInscricaoEstadual_Controller', Ger00250_ParametrizacaoInscricaoEstadual_Controller);
});

// FILE: ./assets/js/controllers/Ger00600_SerieDocumentosSaida_Controller.js
var  Ger00600_SerieDocumentosSaida_Controller = function(ScreenService, General, templateManager, ZHPromise){

    this.filtroEmpresa = "";
    this.filtroInscEst = "";
    this.filtroInscMun = "";
    this.filtraTabs    = [];
    var self = this;

    this.viewImposto = function (widget) {
        if (widget.mode === "list" && !widget.__is_new || widget.mode === "view") {
            widget.widgets[0].enabled = true;
        } else {
            widget.widgets[0].enabled = false;
        }
    };
    
    this.controlaViewNumeracao = function (widget) {
        var filiLocEmiss = widget.getField('IDUTFILILCEM');
        var utLocEmiss = widget.getField('IDUTLOCAEMIS'); 
        var utContrForm = widget.getField('IDUTCTRLFORM'); 
        var percentual = widget.getField('VRPEMINFRMNF'); 
        
        widget.getField('CDCTRLNUMENF').readOnly = true;
        
        if(utLocEmiss === 'S'){
            filiLocEmiss.readOnly = false;
            utContrForm.readOnly = false;
        }
        else{
            filiLocEmiss.readOnly = true;
            filiLocEmiss.value('N');
            utContrForm.readOnly = true;
            utContrForm.value('N');
        }
        
        if(utLocEmiss === 'S' && utContrForm === 'S')
            percentual.readOnly = false;
        else{
            percentual.readOnly = true;
            percentual.value(null);
        }
    };
    
    this.filtroSerieNF = function (widget) {
        this.filtroEmpresa = widget.getField('CDEMPRESA').value();
        if (widget.getField('CDINSCESTA').dataSourceFilter[0].value === "" ||widget.getField('CDINSCESTA').dataSourceFilter[0].value !== this.filtroEmpresa) {
            widget.getField('CDINSCESTA').dataSourceFilter[0].value = this.filtroEmpresa;
            widget.getField('CDINSCESTA').setValue(null);
            widget.getField('CDINSCESTA').reload();
            if (widget.getField('CDINSCMUNI').dataSourceFilter[0].value === "" || widget.getField('CDINSCMUNI').dataSourceFilter[0].value !== this.filtroEmpresa ){
                widget.getField('CDINSCMUNI').dataSourceFilter[0].value = this.filtroEmpresa;
                widget.getField('CDINSCMUNI').setValue(null);
                widget.getField('CDINSCMUNI').reload();
            } else {

            }
        } else if (widget.getField('CDINSCESTA').dataSourceFilter[0].value !== "") {
            widget.getField('CDINSCESTA').dataSourceFilter[0].value = this.filtroEmpresa;
            widget.getField('CDINSCESTA').setValue(null);
            widget.getField('CDINSCESTA').reload();
            if (widget.getField('CDINSCMUNI').dataSourceFilter[0].value !== "") {
                widget.getField('CDINSCMUNI').dataSourceFilter[0].value = this.filtroEmpresa;
                widget.getField('CDINSCMUNI').setValue(null);
                widget.getField('CDINSCMUNI').reload();
            }
        }
    };
    this.checkEmpresa = function (args) {
        var widget = args.owner.owner.widget;
        if (!widget.getField('CDEMPRESA').value()){
            if (!widget.getField('CDINSCESTA').value() && !widget.getField('CDINSCESTA').value()) {
                ScreenService.showMessage('Selecione Primeiro a Empresa.');
                widget.getField('CDINSCESTA').readOnly = true;
                widget.getField('CDINSCMUNI').readOnly = true;
                args.e.preventDefault();
            }
        }
    };
    this.checkFilters = function (widget) {
        if (!widget.getField('CDEMPRESA').value()){
            widget.getField('CDINSCESTA').readOnly = true;
            widget.getField('CDINSCMUNI').readOnly = true;
        } else if (widget.getField('CDINSCESTA').readOnly === true && widget.getField('CDINSCMUNI').readOnly === true) {
            widget.getField('CDINSCESTA').readOnly = false;
            widget.getField('CDINSCMUNI').readOnly = false;
        }
    };
    this.getFilters = function (field) {
        if(field.name == "CDINSCESTA") {
            this.filtroInscEst = field.value();
        } else if(field.name == "CDINSCMUNI") {
            this.filtroInscMun = field.value();
        }
    };
    this.verificaSalvar = function (widget) {
        if (widget.isValid()){
            var  serieNFE = widget.getField('CDSERIENFE').value();
       
            if(serieNFE) {
                if ((serieNFE < 0) || (serieNFE > 889)){
                    ScreenService.showMessage('Série para NF-e deve estar entre 0 e 889.');
                    return 0;
                }
            } 
            if(widget.getField('CDSERIENFESCAN').value()) {
                if ((widget.getField('CDSERIENFESCAN').value()) < 900){
                    ScreenService.showMessage('Série para NF-e SCAN deve estar entre 900 e 999.');
                    return 0;
                } 
            } 
            if (serieNFE){
                if (serieNFE[0] == "0"){
                    for (var i = 0; i < serieNFE.length; i++) {
                        serieNFE = serieNFE.replace(0, "");
                    }
                    widget.getField('CDSERIENFE').setValue(serieNFE);
                }
            }
            if (widget.getField('NRMAXITNF').value() === null || widget.getField('NRMAXITNF').value() === "") {
                widget.getField('NRMAXITNF').setValue("10");
            }
            if (widget.getField('NRMAXSERVNF').value() === null || widget.getField('NRMAXSERVNF').value() === "") {
                widget.getField('NRMAXSERVNF').setValue("5");
            }
            widget.getField('CDEMPRESA').setValue(this.filtroEmpresa);
            widget.getField('CDINSCESTA').setValue( this.filtroInscEst);
            widget.getField('CDINSCMUNI').setValue( this.filtroInscMun);
            General.saveCrud(widget).then(function (){
                self.viewImposto(widget);
            });
        }
    };
    this.filtroTabs = function (widget) {
        var deferred = ZHPromise.defer();
        if (this.filtraTabs[0] !== widget.getParent().currentRow.CDEMPRESA) {
            this.filtraTabs[0] = widget.getParent().currentRow.CDEMPRESA;
            this.filtraTabs[1] = widget.getParent().currentRow.CDINSCESTA;
            this.filtraTabs[2] = widget.getParent().currentRow.CDINSCMUNI;
            this.filtraTabs[3] = widget.getParent().currentRow.CDSERIE;
            for (var i = 0; i < (this.filtraTabs.length); i++) {
                widget.dataSourceFilter[i].value = this.filtraTabs[i];
            }
        } else if (widget.dataSourceFilter[3].value !== widget.getParent().currentRow.CDSERIE) {
            this.filtraTabs[3] = widget.getParent().currentRow.CDSERIE;
            widget.dataSourceFilter[3].value = this.filtraTabs[3];
        }
        widget.reload().then(function(){
            deferred.resolve();
        });
        return deferred.promise;
    };
    
    this.salvarImposto = function (widget) {
        widget.currentRow.CDEMPRESA = this.filtraTabs[0];
        widget.currentRow.CDINSCESTA = this.filtraTabs[1];
        widget.currentRow.CDINSCMUNI = this.filtraTabs[2];
        widget.currentRow.CDSERIE = this.filtraTabs[3];
        General.saveCrud(widget);
    };
    
    this.setStripeData = function(preference) {
        var stripeWidget = templateManager.container.getWidget("stripe");
        var currentRow   = preference.FILTER_ROW;

        stripeWidget.currentRow = {};
        stripeWidget.currentRow.NMEMPRESA  = currentRow.CDEMPRESA + ' - ' + currentRow.NMEMPRESA;
        stripeWidget.currentRow.CDINSCESTA = currentRow.CDINSCESTA;
        stripeWidget.currentRow.CDINSCMUNI = currentRow.CDINSCMUNI;
    };
    
    this.setMaskCNPJOrCpf = function (data, fieldName, outName) {
        var inscFormatada = void 0;
        data.forEach(function (value) {
            if (value[fieldName].length === 14) inscFormatada = value[fieldName].substr(0, 2) + '.' + value[fieldName].substr(2, 3) + '.' + value[fieldName].substr(5, 3) + '/' + value[fieldName].substr(8, 4) + '-' + value[fieldName].substr(12, 2);else if (value[fieldName].length === 11) inscFormatada = value[fieldName].substr(0, 3) + '.' + value[fieldName].substr(3, 3) + '.' + value[fieldName].substr(6, 3) + '-' + value[fieldName].substr(9, 2);
            value[outName] = inscFormatada;
        });
    };
    
    this.deleteCrud = function (widget) {
		var deferred = ZHPromise.defer();
		ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
		   self.filtroTabs(templateManager.container.getWidget("Tab3")).then(function() {
    		    if (Util.isEmptyOrBlank(templateManager.container.getWidget("Tab3").dataSource.data)){
        			widget.removeRow().then(function () {
        				ScreenService.closeSwipe().then(function () {
        					widget.activate();
        					deferred.resolve();
        				});
        			}, function (error) {
        				if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
        					ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
        				} else {
        					ScreenService.showMessage(error.data.error);
        				}
        				deferred.reject();
        			});
    		    } else {
    		        ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
    		    }
    		});
    		return deferred.promise;
		    });
	};

};
Configuration(function(ContextRegister){
    ContextRegister.register('Ger00600_SerieDocumentosSaida_Controller', Ger00600_SerieDocumentosSaida_Controller);
});

// FILE: ./assets/js/controllers/Ger01300_Pais_Controller.js
function Ger01300_Pais_Controller(General,Ger01300_Pais_Service,ScreenService){


    this.savePais = function(widget){
        if(widget.isValid()){
          	Ger01300_Pais_Service.salvarPais(widget.currentRow).then(function(Success) {
            	if (widget.currentRow.__is_new) {
		            widget.reload().then(function() {
                   		widget.list(true);
                   		ScreenService.closeSwipe();
                    });
                }
                else {
                    widget.view();
                }
            }.bind(this),
            function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Ger01300_Pais_Controller', Ger01300_Pais_Controller);
});


// FILE: ./assets/js/controllers/Ger01500_municipio.js
function Ger01500_municipio(ScreenService, General, Ger01500_Municipio_Service, ZHPromise, templateManager, localStorageEngine){

    this.filtraEstado = function(widget){
        widget.getField('NMESTADO').readOnly    = widget.currentRow.CDPAIS?false:true;
        widget.getField('NMMUNICIPIO').readOnly = true;
        
        widget.currentRow.SGESTADO = '';
        widget.currentRow.NMESTADO = '';
        widget.currentRow.CDMUNICIPIO ='';
        widget.currentRow.NMMUNICIPIO ='';
        
		widget.getField('NMESTADO').dataSourceFilter[0].value = widget.currentRow.CDPAIS;
    };
    
    this.filtraMunicipio = function(widget){
        widget.getField('NMMUNICIPIO').readOnly    = widget.currentRow.SGESTADO?false:true;
        
        widget.currentRow.CDMUNICIPIO ='';
        widget.currentRow.NMMUNICIPIO ='';
        
		widget.getField('NMMUNICIPIO').dataSourceFilter[0].value = widget.currentRow.CDPAIS;
		widget.getField('NMMUNICIPIO').dataSourceFilter[1].value = widget.currentRow.SGESTADO;
    };
    
    this.blockFields = function(args){
        var widget = args.owner;
        widget.getField('NMPAIS').readOnly = true;
        widget.getField('NMESTADO').readOnly = true;
    };

    this.takeLocations = function(widget){
        var popupCurrentRow = widget.appliedFilter.FILTER_ROW;
        widget.currentRow.NMPAIS = popupCurrentRow.NMPAIS;
        widget.currentRow.CDPAIS = popupCurrentRow.CDPAIS;
        widget.currentRow.NMESTADO = popupCurrentRow.NMESTADO;
        widget.currentRow.SGESTADO = popupCurrentRow.SGESTADO;
    };

    this.salvarMunicipio = function (widget){
        if(widget.currentRow.CDPAIS && widget.currentRow.SGESTADO){
            if(widget.isValid()){
                Ger01500_Municipio_Service.salvarMunicipio(widget.currentRow).then(function(Success) {
                    this.controlaStatusWidgets(widget,'municipio',true); 
                    if (widget.currentRow.__is_new) {
                        widget.reload().then(function() {
                            widget.view(true);
                            //ScreenService.closeSwipe();
                        });
                    }
                    else {
                        widget.view();
                    }
                }.bind(this),
                function(callback){
                    if(callback.data){
                        ScreenService.showMessage(callback.data.error);
                    }
                });
            }   
        }else{
            ScreenService.showMessage('Campos do filtro não preenchidos.');
        }
       
    };
    
    this.deleteMunicipio = function(widget){
        General.deleteCrud(widget).then(function(){
            if(widget.appliedFilter.FILTER_ROW.CDMUNICIPIO == widget.currentRow.CDMUNICIPIO ){
                widget.appliedFilter.FILTER_ROW.CDMUNICIPIO = '';
                widget.appliedFilter.FILTER_ROW.NMMUNICIPIO = ''; 
                widget.dataSource.reload();
            }else if(widget.dataSource.data.length == 0){
                widget.dataSource.reload().then(function(data){
                    if(!data.length){
                        widget.appliedFilter.FILTER_ROW.CDMUNICIPIO = '';
                        widget.appliedFilter.FILTER_ROW.NMMUNICIPIO = ''; 
                        widget.dataSource.reload();
                    }                    
                });
            }       
        });    
    };
    
    this.addBairro = function (widget){
        var widgetMunicipio           = widget.getParent();
        var filtro =  {
            "CDPAIS"     : widgetMunicipio.currentRow.CDPAIS,
            "SGESTADO"   : widgetMunicipio.currentRow.SGESTADO,
            "CDMUNICIPIO": widgetMunicipio.currentRow.CDMUNICIPIO
        };
        widget.newRow();
        Ger01500_Municipio_Service.novoCodigoBairro(filtro).then(
            function(success) {
                var codigo                    = formatCdbairro(String (success.dataset.CDBAIRRO.CDBAIRRO[0].MAIORBAIRRO));
                widget.currentRow.CDBAIRRO    = codigo.substring(0,10);
                widget.currentRow.CDPAIS      = widgetMunicipio.currentRow.CDPAIS;
                widget.currentRow.SGESTADO    = widgetMunicipio.currentRow.SGESTADO;
                widget.currentRow.CDMUNICIPIO = widgetMunicipio.currentRow.CDMUNICIPIO;
            },
            function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            }
        );
       
    };
    
    function formatCdbairro (string){
        switch (string.length){
            case 1:
                return '000000000' + string;
            case 2:
                return '00000000' + string;
            case 3:
                return '0000000' + string;
            case 4:
                return '000000' + string;
            case 5:
                return '00000' + string;
            case 6:
                return '0000' + string;
            case 7:
                return '000' + string;
            case 8:
                return '00' + string;
            case 9:
                return '0' + string;
            case 10:
                return string;
        }
    }
    
    this.addMunicipio = function (widget){
        var filtro = widget.appliedFilter.FILTER_ROW;
        widget.newRow();
        widget.currentRow.CDPAIS   = filtro.CDPAIS;
        widget.currentRow.SGESTADO = filtro.SGESTADO;
        this.controlaStatusWidgets(widget,'municipio',false); 
    };
    
    this.controlaStatusWidgets = function(mainWidget, nomeWidgetAtual, status){
        mainWidget.widgets.forEach(function(widg) {
            if(nomeWidgetAtual !== widg.name)
                widg.enabled = status;
        });

        if(mainWidget.name !== nomeWidgetAtual)
            mainWidget.enabled = status;
    };
    
    this.salvarBairro = function (widget){
        if(widget.isValid()){
            if(widget.currentRow.QTHORAENTREGA)
                widget.currentRow.QTHORAENTREGA = widget.currentRow.QTHORAENTREGA.replace(/[^0-9]/g,'');
            General.saveCrud(widget);
            
        }
    };
    
    this.addRegiao = function (widget){
        var widgetMunicipio           = widget.getParent();
        var filtro =  {
            "CDPAIS"     : widgetMunicipio.currentRow.CDPAIS,
            "SGESTADO"   : widgetMunicipio.currentRow.SGESTADO,
            "CDMUNICIPIO": widgetMunicipio.currentRow.CDMUNICIPIO
        };
        widget.newRow();
        Ger01500_Municipio_Service.novoCodigoRegiao(filtro).then(
            function(success) {
                var codigo                     = formatCdregiaoMuni(String(success.dataset.CDREGIAOMUNI.CDREGIAOMUNI[0].MAIORREGIAO));
                widget.currentRow.CDREGIAOMUNI = codigo.substring(0,4);
                widget.currentRow.CDPAIS       = widgetMunicipio.currentRow.CDPAIS;
                widget.currentRow.SGESTADO     = widgetMunicipio.currentRow.SGESTADO;
                widget.currentRow.CDMUNICIPIO  = widgetMunicipio.currentRow.CDMUNICIPIO;
            },
            function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            }
        );
       
    };
    
    function formatCdregiaoMuni (string){
        switch (string.length){
            case 1:
                return '000' + string;
            case 2:
                return '00' + string;
            case 3:
                return '0' + string;
        }
    }
    
    this.recarrecarWidgetsFilhas = function (widget){
        if(! widget.currentRow.__is_new){
            widget.widgets.forEach(function(widg) {
                widg.reload();
            });
        }
    };
    
    this.filtraEstadoFilter = function(field){
        var fieldEstado = field.widget.container.getWidget('municipio').getField('NMESTADO');
        
        			var estado =field.widget.container.getWidget('municipio').getField('NMESTADO');
		estado.dataSourceFilter[0].value = widget.currentRow.CDPAIS;
		estado.reload();
        
        
        var country = field.widget.container.getWidget('municipio');

        field.getParent().getField('NMESTADO').readOnly    = country.currentRow.CDPAIS?false:true;
        field.getParent().getField('NMMUNICIPIO').readOnly = true;
        
        field.getParent().getField('NMESTADO').value('');
        
        country.currentRow.NMMUNICIPIO ='';
        country.currentRow.CDMUNICIPIO ='';

        country.currentRow.SGESTADO = '';
        
    };
    
    this.filtraMunicipioFilter = function(field){
        var fieldMunicipio = field.widget.container.getWidget('municipio').getField('NMMUNICIPIO');
        var country = field.widget;

        if(country.currentRow.CDPAIS && country.currentRow.SGESTADO){
            field.getParent().getField('NMMUNICIPIO').readOnly = false;

        }else{
            field.getParent().getField('NMMUNICIPIO').readOnly = true;
        }
        


    };
    
    this.downloadFile = function(widget) {
        var body = document.body;
    
        this.downloadFilePromisse(widget, body).then(function(element) {
            body.removeChild(element);
        });
        
    };
    
    this.downloadFilePromisse = function(widget, body) {
        window.open(widget.currentRow.DSDIRLOGOMARCA, "_blank");
    };
    
    this.openAnexoSwipe = function(widget) {
        widget.isVisible = true;
        ScreenService.openSwipe(widget).then(function(){
            widget.newRow();
        });
    };
    
    this.closeAnexoSwipe = function(widget) {
        widget.dataSource.data.pop();
        ScreenService.closeSwipe();
        widget.isVisible = false;
    };
    
    this.deleteFile = function(widget) {
        var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
        widget.currentRow.CDMUNICIPIO = widget.getParent().currentRow.CDMUNICIPIO;
        widget.currentRow.NMARQUIVO = null;
        widget.currentRow.DSDIRLOGOMARCA = null;
        widget.currentRow.__is_new = false;
		var row = Util.clone(widget.currentRow, ignoredKeys);
		
        ScreenService.confirmMessage("Excluir Logomarca?", "question", 
            function() {
                General.callRestEngine('cadFis#/municipio/saveLogomarca', 'Row', row).then(
                    function(response) {
                        ScreenService.showMessage("Logomarca excluida com sucesso");
                        widget.dataSource.data.pop();
                        ScreenService.closeSwipe();
                        widget.reload().then(
                            function(){
                                this.checkAdicionar(widget);
                            }.bind(this)
                        );
                    }.bind(this),
                    function(error){
                        console.log(error);
                    }
                );
            }.bind(this),
            null
        );
    };
    
    this.uploadFile = function(widget) {
        if(widget.isValid()){
           widget.currentRow.CDMUNICIPIO = widget.getParent().getParent().currentRow.CDMUNICIPIO;
            var row = widget.currentRow;
            General.callRestEngine('cadFis#/municipio/saveLogomarca', 'Row', row).then(function(response) {
                var wdgLogo = templateManager.container.getWidget("wdgLogomarca");
                wdgLogo.reload().then(
                    function(){
                        if(wdgLogo.dataSource.data.length == 0){
                            ScreenService.showMessage("Nenhuma inscrição municipal encontrada");
                        }else{
                            ScreenService.showMessage("Logomarca salva com sucesso");
                        }
                        this.checkAdicionar(wdgLogo);
                    }.bind(this)
                );
                this.closeAnexoSwipe(widget);
            }.bind(this)); 
        }
    };
    
    this.checkAdicionar = function(widget){
        if(widget.dataSource.data.length && widget.dataSource.data[0].NMARQUIVO){
            widget.getAction("ADD").isVisible = false;
        }else {
            widget.getAction("ADD").isVisible = true;
        }
        widget.redraw();
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('Ger01500_municipio', Ger01500_municipio);
});

// FILE: ./assets/js/controllers/Ger05400_Logradouro_Controller.js
function Ger05400_Logradouro_Controller(General, MessageService) {

    this.abreviaturaRepetida = function(widget) {
        MessageService.confirmMessageByCode('CONFIRM_DUPLICATE_ABBREVIATION').then(function() {
            General.saveCrud(widget);
        });
    };

    this.filtroAbreviatura = function(row) {
        return row.DSABREVLOGRA == this;
    };
    this.filtroLogradouro = function(row) {
        return row.CDLOGRADOURO != this;
    };

    this.saveLogradouro = function(widget) {

        var currentLogradouro = widget.currentRow.CDLOGRADOURO;
        var currentAbreviatura = widget.currentRow.DSABREVLOGRA;

        var repetidas = widget.dataSource.data
            .filter(this.filtroAbreviatura, currentAbreviatura)
            .filter(this.filtroLogradouro, currentLogradouro);

        if (repetidas.length > 0) {
            this.abreviaturaRepetida(widget);
            return;
        }
        General.saveCrud(widget);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Ger05400_Logradouro_Controller', Ger05400_Logradouro_Controller);
});

// FILE: ./assets/js/controllers/Ger05500_produtosDesoneracaoImpostos_Controller.js
function Ger05500_produtosDesoneracaoImpostos_Controller(General, ScreenService, MessageService, templateManager, Ger05500_produtosDesoneracaoImpostos_Service) {

    this.saveNewDesoneracao = function(widget){
        var widgetForncerdor = templateManager.container.getWidget('fornecedor');
        var widgetCliente = templateManager.container.getWidget('cliente');
        var widgetFilial = templateManager.container.getWidget('filial');
        
        if(widget.currentRow.CDPRODUTO){
            var msg = "CADASTRO_NOVO_PRODUTO";
            var dialogConfig = {
                type: 'INFORMATION',
                actions: [{
                    label: ScreenService.i18n("Fornecedor"),
                    code: function() {
                        General.changeWidgetAcessibility(widget.widgets, true);
                        widgetForncerdor.enabled = true;
                        widgetForncerdor.activate().then(function(){
                            setTimeout(function(){ 
                                templateManager.container.getActiveWidget().newRow();
                                templateManager.container.getActiveWidget().currentRow.CDPRODUTO = widget.currentRow.CDPRODUTO;
                            }, 1000);
                        });
                    }
                }, 
                {
                    label: ScreenService.i18n("Cliente"),
                    code: function() {
                        General.changeWidgetAcessibility(widget.widgets, true); 
                        widgetCliente.enabled = true;
                        widgetCliente.activate().then(function(){
                            setTimeout(function(){ 
                                templateManager.container.getActiveWidget().newRow();
                                templateManager.container.getActiveWidget().currentRow.CDPRODUTO = widget.currentRow.CDPRODUTO;
                            }, 1000);
                        });
                    }
                },
                {
                     label: ScreenService.i18n("Unidade"),
                    code: function() {
                        General.changeWidgetAcessibility(widget.widgets, true);
                        widgetFilial.enabled = true;
                        widgetFilial.activate().then(function(){
                            setTimeout(function(){ 
                                templateManager.container.getActiveWidget().newRow();
                                templateManager.container.getActiveWidget().currentRow.CDPRODUTO = widget.currentRow.CDPRODUTO;
                            }, 1000);
                        });
                    }   
                }
                ]};
            MessageService.showCustomDialogByCode(msg, {"NMPRODUTO": widget.currentRow.NMPRODUTO}, dialogConfig);
    } else {
        ScreenService.showMessage('É necessário selecionar um produto');
    }
    };
    
    this.newRowDesoneracao = function(widget){
        widget.newRow();
        widget.currentRow.CDPRODUTO = widget.getParent().currentRow.CDPRODUTO;
    };
    
    this.verificaProdDesone = function(widget) {
        widget.dataSource.data.forEach(function(element){
            if((element.CDPRODUTO == widget.currentRow.CDPRODUTO) && (element.__is_new == false)){
                ScreenService.showMessage('Produto já cadastrado.');
                widget.currentRow.CDPRODUTO = "";
                widget.currentRow.NMPRODUTO = "";
            }
        });
    };
    
    this.verificaWidgetProdutosDesoneracao =function(){
        var WidgetProdutosDesoneracao = templateManager.container.getWidget('produtos_desoneracao');
        if(WidgetProdutosDesoneracao.mode == 'edit'){
            WidgetProdutosDesoneracao.mode = 'view';
            WidgetProdutosDesoneracao.view();
            WidgetProdutosDesoneracao.reload();
        }
    };
    
    this.goBackList = function(){
        ScreenService.goBack();
        templateManager.container.getActiveWidget().reload();
        templateManager.container.getWidget('produtos_desoneracao').reload();
    };
    
    this.deleteProdutos = function(widget) {
        ScreenService.confirmMessage('A exclusão do produto irá excluir também os fornecedores, clientes e filiais relacionados. Deseja realmente excluir?', 'question', function (success) {
            General.callRestEngine('cadFis#/delete_produtos_desoneracao', 'Row', {"CDPRODUTO": widget.currentRow.CDPRODUTO, "NRORG": widget.currentRow.NRORG}).then(function(){
                ScreenService.closeSwipe().then(function() {
                    widget.reload();
                    widget.activate();
                });
            });
        });
    };
 
}

Configuration(function (ContextRegister) {
	ContextRegister.register('Ger05500_produtosDesoneracaoImpostos_Controller', Ger05500_produtosDesoneracaoImpostos_Controller);
});

// FILE: ./assets/js/controllers/Ger06800_SerieDocumentosEntrada_Controller.js
function Ger06800_SerieDocumentosEntrada_Controller(Ger06800_SerieDocumentosEntrada_Service, General, ScreenService, templateManager) {
	this.salvar = function(args){
        var widget= args.owner.widget, 
        	currentRow = widget.currentRow;
        
        if(currentRow.DSSERIEENTR && currentRow.DSSERIEENTR.length){
	        if(Ger06800_SerieDocumentosEntrada_Service.validaCodigoNfeScan(currentRow.CDSERIEENTSCAN)){
		        if(Ger06800_SerieDocumentosEntrada_Service.validaCodigoNfe(currentRow.CDSERIEENTRNFE)){
			        General.saveCrud(widget).then(function(Success) {
			        }, function(callback){
			            if(callback.data){
			                ScreenService.showMessage(callback.data.error);
			            }
			        });
	    		}
	    		else{
	    			ScreenService.showMessage('Código para NF-e deve estar entre 1 e 889.');
	    		}
	    	}
	    	else{
	    		ScreenService.showMessage('Código para NF-e SCAN deve estar entre 900 e 999.');
	    	}	
        }else{
        	ScreenService.showMessage('A descrição não pode ser vazia.');
        }
        
    };
}
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger06800_SerieDocumentosEntrada_Controller', Ger06800_SerieDocumentosEntrada_Controller);
});

// FILE: ./assets/js/controllers/Ger33600_Percentual_Carga_Tributaria_Media_Controller.js
function Ger33600_Percentual_Carga_Tributaria_Media_Controller(General, ScreenService, templateManager) {
    
    this.fieldOnChangeTipoOper = function() {
        var widget = templateManager.container.getWidget('percentual_carga_tributaria_media');
        var dadosWidget = templateManager.container.getWidget('percentual_carga_tributaria_media_grid');
        
        widget.getField('CDPAIS').clearValue();
        widget.getField('NMPAIS').clearValue();
        widget.getField('SGESTADO').clearValue();
        widget.getField('NMESTADO').clearValue();
        
        if(!widget.getField('NMTIPOOPER').value()) {
            widget.getField('NMPAIS').readOnly = true;
            dadosWidget.isVisible = false;
            dadosWidget.deactivate();
            dadosWidget.actions.forEach(function(action){
                action.isVisible = false;
            });
            dadosWidget.reload();
        } else {
            widget.getField('NMPAIS').readOnly = false;
        }
        
        var field = widget.getField('NMPAIS');
        field.reload();
    };
    
    this.fieldOnChangePais = function() {
        var widget = templateManager.container.getWidget('percentual_carga_tributaria_media');
        var dadosWidget = templateManager.container.getWidget('percentual_carga_tributaria_media_grid');
        
        widget.getField('SGESTADO').clearValue();
        widget.getField('NMESTADO').clearValue();
        
        if(!widget.getField('NMPAIS').value()) {
            widget.getField('NMESTADO').readOnly = true;
            dadosWidget.isVisible = false;
            dadosWidget.deactivate();
            dadosWidget.actions.forEach(function(action){
                action.isVisible = false;
            });
            dadosWidget.reload();
        } else {
            widget.getField('NMESTADO').readOnly = false;
        }
        
        var field = widget.getField('NMESTADO');
        field.reload();
    };
     
    this.fieldOnChangeEstado = function() {
        var widget = templateManager.container.getWidget('percentual_carga_tributaria_media');
        var dadosWidget = templateManager.container.getWidget('percentual_carga_tributaria_media_grid');
        if(!widget.getField('NMESTADO').value()){
            dadosWidget.isVisible = false;
            dadosWidget.deactivate();
            dadosWidget.actions.forEach(function(action){
                action.isVisible = false;
            });
            dadosWidget.reload(); 
        } else {
            dadosWidget.isVisible = true;
            dadosWidget.activate();
            dadosWidget.actions.forEach(function(action){
                action.isVisible = true;
            });
            dadosWidget.reload();
        }
    };
    
    this.verificaPorcentagem = function(field){
        var valor_porcentagem = parseFloat(field.value().toString().replace(",","."));
        if((valor_porcentagem < 0) || (valor_porcentagem > 100)){
            ScreenService.showMessage(field.label+" deve ser entre 0 e 100.");
            field.clearValue();
        }
    };
    
    this.newRowPerc = function(widget){
        widget.newRow();
        
        widget.currentRow.CDTIPOOPER = widget.getParent().currentRow.CDTIPOOPER; 
        widget.currentRow.CDPAIS = widget.getParent().currentRow.CDPAIS; 
        widget.currentRow.SGESTADO = widget.getParent().currentRow.SGESTADO; 
        widget.currentRow.IDENTRSAIDOP = "S"; 
    };
    
}
Configuration(function (ContextRegister) {
    ContextRegister.register('Ger33600_Percentual_Carga_Tributaria_Media_Controller', Ger33600_Percentual_Carga_Tributaria_Media_Controller);
});

// FILE: ./assets/js/controllers/ger01200_estadoController.js
function ger01200_estadoController(ScreenService, General, Ger01200_Estado_Service, templateManager, ZHPromise) {
	var self = this;
	this.salvar = function (widget) {
		if (widget.isValid()) {
			Ger01200_Estado_Service.salvarEstado(widget.currentRow).then(function (Success) {
					if (widget.currentRow.__is_new) {
						widget.reload().then(function () {
							widget.list(true);
							ScreenService.closeSwipe();
						});
					} else {
						widget.view();
					}
				}.bind(this),
				function (callback) {
					if (callback.data) {
						ScreenService.showMessage(callback.data.error);
					}
				});
		}
	};

	this.toAddCountry = function (args) {
		var arr = args.owner.widget.dataSourceFilter;
		var nm_pais = args.owner.widget.appliedFilter.FILTER_ROW.NMPAIS;
		var cd_pais = args.owner.widget.appliedFilter.FILTER_ROW.CDPAIS;
		args.owner.widget.newRow();
		args.owner.widget.currentRow.NMPAIS = nm_pais;
		args.owner.widget.currentRow.CDPAIS = cd_pais.toString();
	};

	this.controlaCampoEstado = function (widget) {
		var estado = widget.getField('NMESTADO');
		widget.currentRow.NMESTADO = '';
		widget.currentRow.SGESTADO = '';
		if (widget.currentRow.CDPAIS) {
			estado.readOnly = false;
		} else {
			estado.readOnly = true;
		}
	};

	this.setFiltroEstado = function (widget) {
		var estado = widget.getField('NMESTADO');
		estado.dataSourceFilter[0].value = widget.currentRow.CDPAIS;
		estado.reload();
	};

	this.converteSiglaEstadoMaisculo = function (field) {
		field.value(field.value().toUpperCase());

	};
	
	this.webservice_estadualOnEnter = function (args) {
	    args.owner.reload().then(function(){
	        args.owner.currentRow = args.owner.dataSource.data[0] ||{};
	        var row = args.owner.currentRow;
	        row.IDAMBIENTE = row.IDAMBIENTE || args.owner.dataSourceFilter.filter((filtro)=>{return filtro.name === "IDAMBIENTE";})[0].value;
	        row.IDSERVICO  = row.IDSERVICO  || args.owner.dataSourceFilter.filter((filtro)=>{return filtro.name === "IDSERVICO";})[0].value;
	        row.DSAMBIENTE = row.IDAMBIENTE == "1" ? "Produção" : "Homologação";
	        
	        if(row.CDSVC != 0 ){
	            args.owner.getField('CDSVC').reload().then(function(data){
	            	if(data){
	            		data = data.dataset.webservicesvc_filter;
	                	row.DSSVC = data.find((svc)=> svc.CDSVC == row.CDSVC).DSSVC;
	                	templateManager.updateTemplate();
	            	}	            
	            		
            	});
	        }
	            //args.owner.view();
	        args.owner.activate();
	        templateManager.updateTemplate();
	        
	    });
	    
	};
	
	this.campoFiltroOnChange = function (field) {
		var deferred = ZHPromise.defer();
		var value = field.value();
		if(value){
			this.setFilterGenerico(field.valueField, field.widget.dataSourceFilter, value);
            field.widget.reload().then(function(data){
            	if(data){
		        	field.widget.currentRow = field.widget.dataSource.data[0] ||{};
		            field.widget.currentRow.DSAMBIENTE = field.widget.currentRow.IDAMBIENTE == "1" ? "Produção" : "Homologação";
		            field.widget.currentRow.IDAMBIENTE= field.widget.currentRow.IDAMBIENTE === "1" ? "1" : "2";
		            	
					field.widget.activate();
					templateManager.updateTemplate();
		        	deferred.resolve(data);
            	}
            });
				        
		}else{
            deferred.resolve([]);
    	}
        return deferred.promise;
	};
	
	this.setFilterGenerico = function(nomeFiltro, dataSourceFilter, value){
		dataSourceFilter.forEach(function(obj, idx, arr){
			if(obj.name == nomeFiltro){
				arr[idx].value = value;	
			}
		});
	};
	
	this.abreAutorizacaoGeral = function(widgetGeral){
		var widgetEstado = templateManager.container.getWidget('ger01200_estado_grid');
		widgetEstado.isVisible = false;
		
		widgetGeral.isVisible = true;
		// widgets filhas, senão não funciona
		widgetGeral.widgets.forEach(function(widgetFilha){
			widgetFilha.isVisible = true;
			widgetFilha.widgets.forEach(function(widgetNeta){
				widgetNeta.isVisible = true;
				//filtro do cdpais
				widgetNeta.dataSourceFilter[0] = widgetEstado.dataSourceFilter[0] ? widgetEstado.dataSourceFilter[0] : widgetNeta.dataSourceFilter[0];
			});
		});	
		ScreenService.closePopup();
		widgetGeral.activate();
		//widgetGeral.widgets[0].reload();
	};
	
	this.fechaAutorizacaoGeral = function(widgetGeral){
		var widgetEstado = templateManager.container.getWidget('ger01200_estado_grid');
		widgetEstado.isVisible = true;
		widgetGeral = widgetGeral.parent.parent;
		
		widgetGeral.isVisible = false;
		// widgets filhas, senão não funciona
		widgetGeral.widgets.forEach(function(widgetFilha){
			widgetFilha.isVisible = false;
			widgetFilha.widgets.forEach(function(widgetNeta){
				widgetNeta.isVisible = false;
			});
		});

		widgetEstado.activate();
		widgetEstado.reload();
	};
	
	this.abreContigTabbed = function(widgetContig){
		var widgetEstado = templateManager.container.getWidget('ger01200_estado_grid');
		widgetEstado.isVisible = false;
		
		ScreenService.closePopup();
		
		widgetContig.isVisible = true;
		// widgets filhas, senão não funciona
		widgetContig.widgets[0].isVisible = true;
		widgetContig.widgets[1].isVisible = true; 
		
		//carrega datasource do filtro
		widgetContig.widgets[0].fields[0].reload();
		widgetContig.widgets[1].fields[0].reload();
		
		widgetContig.activate();
		widgetContig.reload();
		
	};
	
	this.fechaContigTabbed = function(widgetContig){
		var widgetEstado = templateManager.container.getWidget('ger01200_estado_grid');
		widgetEstado.isVisible = true;
		
		widgetContig.isVisible = false;
		// widgets filhas, senão não funciona
		widgetContig.widgets[0].isVisible = false;
		widgetContig.widgets[1].isVisible = false; 
		
		widgetEstado.activate();
		widgetEstado.reload();
		
	};
	
	this.campoFiltroVisibilidade = function(field, data =[]){
		var value = field.value();
		var widgetContig = field.widget;
		if(value && data){
			widgetContig.fields.forEach(function(field){
				if(field.name != "CDSVC" && field.name != "IDAMBIENTE"){
					field.readOnly = false;
				}
			});
		}
	};
	// função criada só para conseguir usar promise e saber se o datasource carregou antes de tentar carregar.
	this.campoFiltroOnChangeVisib = function(field){
		self.campoFiltroOnChange(field).then(function(data){
			self.campoFiltroVisibilidade(field, data);
		});
	};

	this.saveWithParent = function(widget){
		widget.dataSourceFilter.forEach(function(obj, idx, arr){
			widget.currentRow[obj.name] = widget.currentRow[obj.name] ? widget.currentRow[obj.name] : obj.value;  
			let value = widget.currentRow[obj.name];
			if(value[0] == '@' && value[value.length-1] == '@'){
				widget.currentRow[obj.name] = eval(value.slice(1, value.length -1));
			}
		});
		
		widget.currentRow.__is_new = typeof widget.currentRow.__is_new != "undefined" ? widget.currentRow.__is_new : true;
		widget.currentRow.NRORG = getLocalVar('NRORG');
		
		General.saveCrud(widget).then(function(){widget.activate();widget.view();});
	};
}

Configuration(function (ContextRegister) {
	ContextRegister.register('ger01200_estadoController', ger01200_estadoController);
});

// FILE: ./assets/js/controllers/zhFavorites.js
var ZeedhiFields = angular.module("ZeedhiFields");

ZeedhiFields.directive('zhNavbarDefaultHeader', function(templateManager, ScreenService, eventAggregator, $compile, ApplicationContext) {
	return {
		restrict: 'C',
		link: function($scope, element) {
		    $scope.favoritesList = [];
		    $scope.lastDeletedItem = undefined;
		    
		    var favoritesText = 'Favoritos';
		    var favoritesAddText = 'Adicionar aos Favoritos';
		    var favoritesRemoveText = 'Remover dos Favoritos';
		    var favoritesUndoText = 'DESFAZER';

			// TRANSLATE - Adicionar essas variaveis a lista da aplicação (words.jon)
		    // var favoritesText = ScreenService.i18n('FAVORITES');
		    // var favoritesAddText = ScreenService.i18n('ADD_TO_FAVORITES');
		    // var favoritesRemoveText = ScreenService.i18n('REMOVE_FROM_FAVORITES');
		    // var favoritesUndoText = ScreenService.i18n('UNDO');
		    
		    var favoritesContainer;
		    
		    var startHollowCode = '<svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="0 0 30 30" style="enable-background:new 0 0 30 30;" xml:space="preserve">'+
				'	<style type="text/css">'+
				'		.st0{fill:#FFFFFF;}'+
				'	</style>'+
				'	<g>'+
				'		<path class="st0" d="M15,4.21l3.51,7.1l7.84,1.14l-5.67,5.53l1.34,7.81L15,22.1l-7.01,3.69l1.34-7.81l-5.67-5.53l7.84-1.14L15,4.21'+
				'			 M15,2.21c-0.76,0-1.46,0.43-1.79,1.11l-3.04,6.16l-6.8,0.99c-0.75,0.11-1.38,0.64-1.61,1.36c-0.24,0.72-0.04,1.52,0.51,2.05'+
				'			l4.92,4.8l-1.16,6.77c-0.13,0.75,0.18,1.51,0.8,1.96c0.35,0.25,0.76,0.38,1.18,0.38c0.32,0,0.64-0.08,0.93-0.23l6.08-3.2l6.08,3.2'+
				'			c0.29,0.15,0.61,0.23,0.93,0.23c0.41,0,0.83-0.13,1.18-0.38c0.62-0.45,0.92-1.21,0.8-1.96l-1.16-6.77l4.92-4.8'+
				'			c0.55-0.53,0.74-1.33,0.51-2.05c-0.24-0.72-0.86-1.25-1.61-1.36l-6.8-0.99l-3.04-6.16C16.46,2.64,15.76,2.21,15,2.21L15,2.21z"/>'+
				'	</g>'+
				'</svg>';
		    var startFilledCode = '<svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="0 0 30 30" style="enable-background:new 0 0 30 30;" xml:space="preserve">'+
				'	<style type="text/css">'+
				'		.st0{fill:#FFFFFF;}'+
				'	</style>'+
				'	<g>'+
				'		<path class="st0" d="M28.25,11.83c-0.24-0.72-0.86-1.25-1.61-1.36l-6.8-0.99l-3.04-6.16C16.46,2.64,15.76,2.21,15,2.21'+
				'			s-1.46,0.43-1.79,1.11l-3.04,6.16l-6.8,0.99c-0.75,0.11-1.38,0.64-1.61,1.36c-0.24,0.72-0.04,1.52,0.51,2.05l4.92,4.8l-1.16,6.77'+
				'			c-0.13,0.75,0.18,1.51,0.8,1.96c0.35,0.25,0.76,0.38,1.18,0.38c0.32,0,0.64-0.08,0.93-0.23l6.08-3.2l6.08,3.2'+
				'			c0.29,0.15,0.61,0.23,0.93,0.23c0.41,0,0.83-0.13,1.18-0.38c0.62-0.45,0.92-1.21,0.8-1.96l-1.16-6.77l4.92-4.8'+
				'			C28.29,13.35,28.48,12.56,28.25,11.83z"/>'+
				'	</g>'+
				'</svg>';
		    
		    function createVisualElements() {
    			var headerContainer = $(element).children()[0];
    			headerContainer.style.width = 'calc(100% - 50px)';
    			
    			favoritesContainer = $('<div class="zh-favorites"></div>').appendTo(element);
    			
    			var favoritesButtonElement = $compile(
    				'<div class="zh-favorites-button" ng-click="toggleList()">'+
    				'  <div class="zh-favorites-button-star" ng-if="!isFavorited">'+
    				'    '+startHollowCode+
    				'  </div>'+
    				'  <div class="zh-favorites-button-star" ng-if="isFavorited">'+
    				'    '+startFilledCode+
    				'  </div>'+
    				'  <div class="zh-favorites-button-text">'+favoritesText+'</div>'+
    				'</div>'
    			)($scope);
    			var favoritesButton = $(favoritesButtonElement).appendTo(favoritesContainer);
    			
    			var favoritesListElement = $compile(
    				'<div class="zh-favorites-list" ng-class="{\'opened\': opened}">'+
    				'  <div class="zh-favorites-list-button" ng-if="!isFavorited" ng-click="addToFavorites()">'+favoritesAddText+'</div>'+
    				'  <div class="zh-favorites-list-button" ng-if="isFavorited" ng-click="removeFromFavorites()">'+favoritesRemoveText+'</div>'+
    				'  <div class="zh-favorites-list-undo" ng-show="lastDeletedItem" ng-click="undo()">'+favoritesUndoText+'</div>'+
    				'  <div class="zh-favorites-list-items" ng-show="favoritesList.length > 0">'+
    				'	 <div class="zh-favorites-list-item" ng-repeat="item in favoritesList track by item.id" ng-click="openItem(item)">'+
    				'      {{ item.label }}'+
    				'      <span class="zh-favorites-list-item-delete" data-zh-icon="trash icon-white no-border" ng-click="deleteItem(item, $index, $event)"></span>'+
    				'    </div>'+
    				'  </div>'+
    				'</div>'
    			)($scope);
    			var favoritesList = $(favoritesListElement).appendTo(favoritesContainer);
		    }
		    
		    function checkIsFavorited(containerId) {
		    	var oldIsFavorited = $scope.isFavorited;
			    $scope.isFavorited = $scope.favoritesList.findIndex((item) => item.id === containerId) !== -1;
			    if (oldIsFavorited !== $scope.isFavorited) {
			    	templateManager.updateTemplate();
			    }
		    }
		    
		    $scope.addToFavorites = function() {
		    	var item = {
		    		id: templateManager.container.id,
		    		name: templateManager.container.fileName.split('.json')[0],
		    		label: templateManager.container.label,
		    	};
		    	$scope.favoritesList.push(item);
		    	$scope.isFavorited = true;
		    	eventAggregator.publish('ZhFavoritesOnChange', { fullList: $scope.favoritesList, changed: { item, status: 'add' }});
		    };
		    
		    $scope.removeFromFavorites = function() {
		    	var index = $scope.favoritesList.findIndex((item) => item.id === templateManager.container.id);
		    	if (index > -1) {
			    	var item = $scope.favoritesList.splice(index, 1);
			    	$scope.isFavorited = false;
			    	eventAggregator.publish('ZhFavoritesOnChange', { fullList: $scope.favoritesList, changed: { item, status: 'delete' }});
		    	}
		    };
		    
		    $scope.openItem = function(item) {
		    	ApplicationContext.LibUtilities.openWindow(item.name);
	    		$scope.opened = false;
		    };
		    
		    var undoTimeout;
		    
		    $scope.deleteItem = function(item, index, event) {
		    	$scope.favoritesList.splice(index, 1);
		    	$scope.lastDeletedItem = { item, index };

		    	clearTimeout(undoTimeout);
		    	undoTimeout = setTimeout(() => {
		    		$scope.lastDeletedItem = undefined;
		    		templateManager.updateTemplate();
		    	}, 10000);

			    eventAggregator.publish('ZhFavoritesOnChange', { fullList: $scope.favoritesList, changed: { item, status: 'delete' }});

		    	if (item.id === templateManager.container.id) {
		    		$scope.isFavorited = false;
		    	}

		    	event.stopImmediatePropagation();
		    };
		    
		    $scope.undo = function() {
		    	if ($scope.lastDeletedItem) {
		    		$scope.favoritesList.splice($scope.lastDeletedItem.index, 0, $scope.lastDeletedItem.item);
		    	}
		    	$scope.lastDeletedItem = undefined;
		    };

		    $scope.toggleList = function() {
		    	$scope.opened = !$scope.opened;
		    };
		    
		    document.addEventListener('mousedown', (evt) => {
		    	if ($(favoritesContainer).find(evt.target).length === 0 && $scope.opened) {
		    		$scope.opened = false;
			    	templateManager.updateTemplate();
		    	}	
		    });
		    
		    eventAggregator.subscribe(eventAggregator.ON_CONTAINER_OPEN, (args) => {
		    	checkIsFavorited(args.container.id);
		    });
		    
		    eventAggregator.subscribe('ZhFavoritesOnLoad', (favorites) => {
		    	
		    	$scope.favoritesList = favorites;
			    if (templateManager.container) {
			    	checkIsFavorited(templateManager.container.id);
			    }
		    });

		    createVisualElements();
		}
	};
});
